#include <windows.h>
#include "Queue.h"

QNode *top, *end;

void initQueue()
{
	top = NULL;
	end = NULL;
}

void enqueue(LPVOID e)
//
// enqueue is thread-safe since only one thread at a time may create and add a new node to the queue list
//
{
	QNode *t = (QNode *) malloc(sizeof(QNode));
	t->Q = (qParams *)e;
	t->next = NULL;
	   if (top != NULL) {
		   end->next = t;
		   end = t;
	   }
	   else {
		   top = t;
		   end = t;
	   }
}

int dequeue(LPVOID *d)
//
// if no node is currently on the list (queue is empty), dequeue returns 1
//
{
	QNode *ptr;
	if (top){
		   ptr = top;
		   top = top->next;
   		*d = (LPVOID)ptr->Q;
		free(ptr);
		return 0;
	}
	else {
		return 1;
	}
}