// Quicksort Iterative.cpp : Iterative version of Quicksort algorithm using a queue data structure to 
//                             simulate recursive nature of the original algorithm.  
//
#include <windows.h>
#include <stdio.h>
#include "Queue.h"

int *A,N;

int Partition (int p, int r)
{
	int x = A[p];
	int k = p;
	int l = r+1;
	int t;
	while (1)
	{
		do 
		  k++;
		while ((A[k] <= x) && (k < r));
		do 
		  l--;
		while (A[l] > x);

		while (k < l) {
			t = A[k];  A[k] = A[l];  A[l] = t;
			do k++; while (A[k] <= x);
			do l--; while (A[l] > x);
		}
		t = A[p];  A[p] = A[l];  A[l] = t;
		return l;
	}
}

int QuickSort()
{
	int p;
	int r;
	int q;
	qParams *d=NULL, *d1, *d2;

	while (1) {
		if (dequeue((LPVOID *)&d)) break;  //pull out next index pair, unless queue is empty
		p = d->p;
		r = d->r;
		free(d);
		if (p < r)  // if there is one or more things to sort...
		{
			q = Partition(p, r);

// encapsulate the indices for the lower portion of the partition and enqueue
			d1 = (qParams *) malloc(sizeof(qParams));
			d1->p = p;
			d1->r = q-1;
			enqueue(d1);

// encapsulate the indices for the upper portion of the partition and enqueue
			d2 = (qParams *) malloc(sizeof(qParams));
			d2->p = q+1;
			d2->r = r;
			enqueue(d2);
		}
	}
	return 0;
}

void init_data()
{
   FILE *fd;
   int i;

   fopen_s(&fd, "InputData.in", "r");
   fscanf_s(fd, "%d", &N);
   A = (int*) malloc(N * sizeof(int));
   for (i = 0; i < N; i++)
      fscanf_s(fd, "%d", &A[i]);
   fclose(fd);
}

void out_data()
{
   FILE *fd;
   int i;

   fopen_s(&fd, "Sorted.out", "w");
   for (i = 0; i < N; i++)
      fprintf(fd, "%d\n", A[i]);
   fclose(fd);
}


int main(int argc, char* argv[])
{
	int q;
	qParams *e1, *e2;

	init_data();
	initQueue();

	// Initial partition of data and enqueueing of first two index pairs before calling QuickSort
	q = Partition(0, N-1);

	e1 = (qParams *) malloc(sizeof(qParams)); e1->p = 0; e1->r = q-1;
	enqueue((LPVOID)e1);
	e2 = (qParams *) malloc(sizeof(qParams)); e2->p = q+1; e2->r = N-1;
	enqueue((LPVOID)e2);

	QuickSort();
	out_data();

	return 0;
}