// Quicksort.cpp : Traditional version of Quicksort algorithm.  
//
//
#include <windows.h>
#include <stdio.h>

int *A, N;

int Partition (int p, int r)
{
	int x = A[p];
	int k = p;
	int l = r+1;
	int t;
	while (1)
	{
		do 
		  k++;
		while ((A[k] <= x) && (k < r));
		do 
		  l--;
		while (A[l] > x);

		while (k < l) {
			t = A[k];  A[k] = A[l];  A[l] = t;
			do k++; while (A[k] <= x);
			do l--; while (A[l] > x);
		}
		t = A[p];  A[p] = A[l];  A[l] = t;
		return l;
	}
}

void QuickSort(int p, int r)
{
	if (p < r) 
	{int q = Partition(p, r);
		QuickSort (p, q-1); 
		QuickSort (q+1, r);
	}
}


void init_data()
{
   FILE *fd;
   int i;

   fopen_s(&fd, "InputData.in", "r");
   fscanf_s(fd, "%d", &N);
   A = (int*) malloc(N * sizeof(int));
   for (i = 0; i < N; i++)
      fscanf_s(fd, "%d", &A[i]);
   fclose(fd);
}

void out_data()
{
   FILE *fd;
   int i;

   fopen_s(&fd, "Sorted.out", "w");
   for (i = 0; i < N; i++)
      fprintf(fd, "%d\n", A[i]);
   fclose(fd);
}

int main(int argc, char* argv[])
{
   init_data();
   QuickSort(0, N-1);
   out_data();
   return 0;
}