using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;
using System.Text;
[Serializable()]
public  class Sudoku6x6 : ISerializable {

 //-------------- MCsharp functions -----------

 public Sudoku6x6 ( ) {
  mcsharp_initiate();
}

 public Sudoku6x6 ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendResult = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendResult" );
  mcsharpQueuegetResult = new MCSharp.ThreadQ();

  getResult = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetResult" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   String file_name ;

  int P = 1  ;

  int i ;

  if ( args.Length  > 0  )
   file_name = args[ 0   ]  ;

  else
  {
   Console.WriteLine( "Usage: Sudoku.exe <file-name> [<number of cores/threads>]"   )  ;
 return ;
  }
 
 if ( args.Length  > 1  )
   P = Convert.ToInt32( args[ 1   ]   )  ;

  FileStream fs_in = new FileStream ( file_name   , FileMode.Open   , FileAccess.Read   )   ;

  int length = Convert.ToInt32( fs_in.Length   )  ;

  char[] data = new char [ length   ]    ;

  StreamReader sr = new StreamReader ( fs_in   )   ;

  int n = sr.ReadBlock( data   , 0   , length   )  ;

  int tasks = length / 37  ;

  Sudoku6x6 s6x6 = new Sudoku6x6 ( )   ;

  int q = tasks / P  , r = tasks % P  ;

  int from_ = 0  , to ;

  for ( i = 0  ; i  < P ; i++   )
  {
   to = from_ + q + ( i  < r  ? 1   : 0    )  ;
 s6x6.Solver( i   , from_   , to   , data   , s6x6.sendResult   )  ;
 from_ = to  ;
 }

  StringBuilder[] results = new StringBuilder [ P   ]    ;

  for ( i = 0  ; i  < P ; i++   )
 s6x6.getResult  .Get(new object[]{ results   } )
;

  for ( i = 0  ; i  < P ; i++   )
 Console.Write( results[ i   ]   )  ;

  }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendResult;

 //-------------Handler declaration-----------------

    public MCSharp.handler getResult;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetResult;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getResult = 1 << 0;
 private const int mcsharp_mask_sendResult = 1 << 1;
 private const int mcsharp_mask_getResultsendResult =
            mcsharp_mask_getResult
          | mcsharp_mask_sendResult;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetResultsendResult = new MCSharp.BitMask();

 private void scangetResultsendResult () {
  if ( mcsharpBitMaskgetResultsendResult.match
        ( mcsharp_mask_getResultsendResult ) )
   mcsharpQueuegetResult.wakeup();
 }


[OneWay]
public void mcsharpChannelsendResult (  StringBuilder sb,  int n )  {
   lock ( mcsharpQueuegetResult ) {
    sendResult.Enqueue ( new object [] { sb, n } );
    if ( ! mcsharpBitMaskgetResultsendResult.match
          ( mcsharp_mask_sendResult ) )   {
     mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_sendResult );
     scangetResultsendResult ();
    }
   }
 }

 public void mcsharpHandlergetResult (  StringBuilder[] results )   {
  Monitor.Enter ( mcsharpQueuegetResult );
  if ( ! mcsharpBitMaskgetResultsendResult.match ( mcsharp_mask_getResult ) ) goto now;
  later:
   mcsharpQueuegetResult.yield ( mcsharpQueuegetResult );
   if ( mcsharpQueuegetResult.empty )
    mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_getResult );
  now:
   if ( mcsharpBitMaskgetResultsendResult.match ( 
    mcsharp_mask_sendResult ) )   {
    object[] osendResult = ( object[] ) sendResult.Dequeue();
    StringBuilder sb = ( StringBuilder ) osendResult [ 0 ];
    int n = ( int ) osendResult [ 1 ];
    if ( sendResult.Count == 0 )
         mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_sendResult );
    scangetResultsendResult ();
    Monitor.Exit ( mcsharpQueuegetResult );
     {
   results[ n   ] = sb  ;
 }
   }
   else {
    mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_getResult );
    goto later;
  }

 }
  private class McsharpPrivateClassSolver {

   Sudoku6x6 parent;
   int myNumber;
   int from_;
   int to;
   char[] data;
   channel  sendStop;

   public McsharpPrivateClassSolver ( Sudoku6x6 parent,
               int myNumber,
               int from_,
               int to,
               char[] data,
               channel  sendStop
              ) {
    this.parent = parent;
    this.myNumber = myNumber;
    this.from_ = from_;
    this.to = to;
    this.data = data;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpSolverBody ( myNumber, from_, to, data, sendStop );

   }
  }

  private void mcsharpSolverBody (
               int myNumber,
               int from_,
               int to,
               char[] data,
               channel  sendStop
              )
 {
   int offset ;

  int[,] board = new int [ 6  , 6   ]    ;

  String[] words = new String [ 4   ]  { "NO"  , "UNIQUE"  , "MULTIPLY"  , "MULTIPLY"   }   ;

  StringBuilder sb = new StringBuilder ( 29 * ( to - from_   )   )   ;

  for ( int i = from_  ;

  i  < to ; i++   )
  {
   offset = i * 37  ;
 fillBoard( ref board   , data   , offset   )  ;
 sb.Append( "Puzzle # " + ( i + 1   ) + ":" + words[ Sudoku( board   , 0   , 0   )   ] + "\n"   )  ;
 }

  sendStop.Send ( new object[] {  sb   , myNumber    } )
  ;
 }




  public  void Solver (  int myNumber,  int from_,  int to,  char[] data,  channel  sendStop ) {
   McsharpPrivateClassSolver prclassobject = new McsharpPrivateClassSolver ( this, myNumber, from_, to, data, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public static  int Sudoku (  int[,] board,  int i0,  int j0 )   {
   int i , j , k ;

  bool found ;

  int i_new , j_new ;

  int solutions ;

  found = false  ;
 i = i0  ;
 j = j0  ;
 while ( !found  && i  < 6  )
 if ( board[ i  , j   ]  == 0   )
   found = true  ;

  else
 if ( j  < 5  )
   j++  ;

  else
  {
   i++  ;
 j = 0  ;
 }
 
 

  if ( !found   )
   return ( 1   )  ;
 
  solutions = 0  ;
 k = 1  ;
 while ( solutions  < 2 && k  < 7  )
 if ( isAllowed( board   , i   , j   , k   )   )
    {
   board[ i  , j   ] = k  ;
 if ( j  < 5  )
    {
   i_new = i  ;
 j_new = j + 1  ;
 }

  else
  {
   i_new = i + 1  ;
 j_new = 0  ;
 }
 
 solutions += Sudoku( board   , i_new   , j_new   )  ;
 if ( solutions  < 2  )
    {
   board[ i  , j   ] = 0  ;
 k++  ;
 }

  }

  else
 k++  ;
 

  return ( solutions   )  ;
  }
public static  bool isAllowed (  int[,] board,  int i,  int j,  int k )   {
   bool found ;

  int i1 , j1 ;

  int i2 , j2 ;

  found = false  ;
 j1 = 0  ;
 while ( !found  && j1  < 6  )
 if ( board[ i  , j1   ]  != k   )
   j1++  ;

  else
 found = true  ;
 

  if ( found   )
   return ( false   )  ;
 
  i1 = 0  ;
 while ( !found  && i1  < 6  )
 if ( board[ i1  , j   ]  != k   )
   i1++  ;

  else
 found = true  ;
 

  if ( found   )
   return ( false   )  ;
 
  if ( i % 2  == 0   )
    {
   i1 = i  ;
 i2 = i + 2  ;
 }

  else
  {
   i1 = i - 1  ;
 i2 = i + 1  ;
 }
 
 if ( j  < 3  )
    {
   j1 = 0  ;
 j2 = 2  ;
 }

  else
  {
   j1 = 3  ;
 j2 = 5  ;
 }
 
 while ( !found  && i1  < i2  )
 if ( board[ i1  , j1   ]  == k   )
   found = true  ;

  else
 if ( j1  < j2  )
   j1++  ;

  else
  {
   i1++  ;
 j1 = j1 - 2  ;
 }
 
 

  return ( !found   )  ;
  }
public static  void fillBoard ( ref  int[,] board,  char[] buffer,  int offset )   {
   int k ;

  for ( int i = 0  ;

  i  < 6 ; i++   )
 for ( int j = 0  ;

  j  < 6 ; j++   )
  {
   k = i * 6 + j + offset  ;
 if ( buffer[ k   ]  == '*'   )
   board[ i  , j   ] = 0  ;

  else
 board[ i  , j   ] = Convert.ToInt32( buffer[ k   ].ToString( )   )  ;
 
 }

 
  }
}

