using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Text;
[Serializable()]
public  class AmicableNumbers : ISerializable {

 //-------------- MCsharp functions -----------

 public AmicableNumbers ( ) {
  mcsharp_initiate();
}

 public AmicableNumbers ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendAmicable = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendAmicable" );
  mcsharpQueuegetAmicable = new MCSharp.ThreadQ();

  getAmicable = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetAmicable" );
  sendReady = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendReady" );
  mcsharpQueuegetReady = new MCSharp.ThreadQ();

  getReady = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetReady" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   if ( args.Length  < 2  )
    {
   Console.WriteLine( "Usage:  AmicableNumbers <from> <to> [<number of threads/cores>]"   )  ;
 return ;
  }

  int MIN = Convert.ToInt32( args[ 0   ]   )  ;

  int MAX = Convert.ToInt32( args[ 1   ]   ) + 1  ;

  int P = 1  ;

  if ( args.Length  > 2  )
   P = Convert.ToInt32( args[ 2   ]   )  ;

  int i = 1  ;

  while ( i  <= P  )
 i = i * 2  ;

  if ( i / 2  != P   )
    {
   Console.WriteLine( "\nNumber of threads/cores must be power of 2 ..."   )  ;
 return ;
  }

  int SIZE = MAX - MIN  ;

  int[] s = new int [ SIZE   ]    ;

  int[,] f = new int [ SIZE  , 3   ]    ;

  int[,] g = new int [ SIZE  , 3   ]    ;

  AmicableNumbers an = new AmicableNumbers ( )   ;

  new Worker ( ) .handleSegment( 1   , P   , MIN   , MIN   , MAX   , s   , f   , g   , an.sendReady   )  ;
 an.getReady  .Get(new object[]{ } )
;
 an.buildAmicablePairs( s   , MIN   , MAX   , an.sendAmicable   )  ;
 printFriendlyPairs( f   , SIZE   )  ;
 Console.Write( an.getAmicable  .Get(new object[]{ } )
 )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendAmicable;

 //-------------Handler declaration-----------------

    public MCSharp.handler getAmicable;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetAmicable;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getAmicable = 1 << 0;
 private const int mcsharp_mask_sendAmicable = 1 << 1;
 private const int mcsharp_mask_getAmicablesendAmicable =
            mcsharp_mask_getAmicable
          | mcsharp_mask_sendAmicable;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetAmicablesendAmicable = new MCSharp.BitMask();

 private void scangetAmicablesendAmicable () {
  if ( mcsharpBitMaskgetAmicablesendAmicable.match
        ( mcsharp_mask_getAmicablesendAmicable ) )
   mcsharpQueuegetAmicable.wakeup();
 }


[OneWay]
public void mcsharpChannelsendAmicable (  StringBuilder sb )  {
   lock ( mcsharpQueuegetAmicable ) {
    sendAmicable.Enqueue ( new object [] { sb } );
    if ( ! mcsharpBitMaskgetAmicablesendAmicable.match
          ( mcsharp_mask_sendAmicable ) )   {
     mcsharpBitMaskgetAmicablesendAmicable.set ( mcsharp_mask_sendAmicable );
     scangetAmicablesendAmicable ();
    }
   }
 }

 public StringBuilder mcsharpHandlergetAmicable (  )   {
  Monitor.Enter ( mcsharpQueuegetAmicable );
  if ( ! mcsharpBitMaskgetAmicablesendAmicable.match ( mcsharp_mask_getAmicable ) ) goto now;
  later:
   mcsharpQueuegetAmicable.yield ( mcsharpQueuegetAmicable );
   if ( mcsharpQueuegetAmicable.empty )
    mcsharpBitMaskgetAmicablesendAmicable.clear ( mcsharp_mask_getAmicable );
  now:
   if ( mcsharpBitMaskgetAmicablesendAmicable.match ( 
    mcsharp_mask_sendAmicable ) )   {
    object[] osendAmicable = ( object[] ) sendAmicable.Dequeue();
    StringBuilder sb = ( StringBuilder ) osendAmicable [ 0 ];
    if ( sendAmicable.Count == 0 )
         mcsharpBitMaskgetAmicablesendAmicable.clear ( mcsharp_mask_sendAmicable );
    scangetAmicablesendAmicable ();
    Monitor.Exit ( mcsharpQueuegetAmicable );
     {
   return ( sb   )  ;
  }
   }
   else {
    mcsharpBitMaskgetAmicablesendAmicable.set ( mcsharp_mask_getAmicable );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendReady;

 //-------------Handler declaration-----------------

    public MCSharp.handler getReady;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetReady;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getReady = 1 << 0;
 private const int mcsharp_mask_sendReady = 1 << 1;
 private const int mcsharp_mask_getReadysendReady =
            mcsharp_mask_getReady
          | mcsharp_mask_sendReady;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetReadysendReady = new MCSharp.BitMask();

 private void scangetReadysendReady () {
  if ( mcsharpBitMaskgetReadysendReady.match
        ( mcsharp_mask_getReadysendReady ) )
   mcsharpQueuegetReady.wakeup();
 }


[OneWay]
public void mcsharpChannelsendReady (  )  {
   lock ( mcsharpQueuegetReady ) {
    sendReady.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetReadysendReady.match
          ( mcsharp_mask_sendReady ) )   {
     mcsharpBitMaskgetReadysendReady.set ( mcsharp_mask_sendReady );
     scangetReadysendReady ();
    }
   }
 }

 public void mcsharpHandlergetReady (  )   {
  Monitor.Enter ( mcsharpQueuegetReady );
  if ( ! mcsharpBitMaskgetReadysendReady.match ( mcsharp_mask_getReady ) ) goto now;
  later:
   mcsharpQueuegetReady.yield ( mcsharpQueuegetReady );
   if ( mcsharpQueuegetReady.empty )
    mcsharpBitMaskgetReadysendReady.clear ( mcsharp_mask_getReady );
  now:
   if ( mcsharpBitMaskgetReadysendReady.match ( 
    mcsharp_mask_sendReady ) )   {
    object[] osendReady = ( object[] ) sendReady.Dequeue();
    if ( sendReady.Count == 0 )
         mcsharpBitMaskgetReadysendReady.clear ( mcsharp_mask_sendReady );
    scangetReadysendReady ();
    Monitor.Exit ( mcsharpQueuegetReady );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetReadysendReady.set ( mcsharp_mask_getReady );
    goto later;
  }

 }
public static  void printFriendlyPairs (  int[,] f,  int SIZE )   {
   StringBuilder sb = new StringBuilder ( )   ;

  int j1 = 0  , j2 = 1  ;

  while ( j2  < SIZE  )
  {
   while ( j2  < SIZE && f[ j2  , 0   ]  == f[ j1  , 0   ]  && f[ j2  , 1   ]  == f[ j1  , 1   ]   )
 j2++  ;

  if ( j2 - j1  > 1  )
    {
   for ( int k = j1  ;

  k  < j2 ; k++   )
 sb.Append( f[ k  , 2   ] + " "   )  ;

  sb.Append( "are FRIENDLY\n"   )  ;
 }

  j1 = j2  ;
 j2 = j1 + 1  ;
 }

  Console.WriteLine( sb   )  ;
 }
  private class McsharpPrivateClassbuildAmicablePairs {

   AmicableNumbers parent;
   int[] s;
   int MIN;
   int MAX;
   channel  sendAmicable;

   public McsharpPrivateClassbuildAmicablePairs ( AmicableNumbers parent,
               int[] s,
               int MIN,
               int MAX,
               channel  sendAmicable
              ) {
    this.parent = parent;
    this.s = s;
    this.MIN = MIN;
    this.MAX = MAX;
    this.sendAmicable = sendAmicable;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpbuildAmicablePairsBody ( s, MIN, MAX, sendAmicable );

   }
  }

  private void mcsharpbuildAmicablePairsBody (
               int[] s,
               int MIN,
               int MAX,
               channel  sendAmicable
              )
 {
   int i_min ;

  StringBuilder sb = new StringBuilder ( )   ;

  for ( int i = MIN  ;

  i  < MAX ; i++   )
  {
   i_min = i - MIN  ;
 if ( s[ i_min   ]  < i && MIN  <= s[ i_min   ]  )
   if ( s[ s[ i_min   ] - MIN   ]  == i   )
   sb.Append( i + " and " + s[ i_min   ] + " are AMICABLE\n"   )  ;

 
  }

  sendAmicable.Send ( new object[] {  sb    } )
  ;
 }




  public  void buildAmicablePairs (  int[] s,  int MIN,  int MAX,  channel  sendAmicable ) {
   McsharpPrivateClassbuildAmicablePairs prclassobject = new McsharpPrivateClassbuildAmicablePairs ( this, s, MIN, MAX, sendAmicable );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

[Serializable()]
public  class Worker : ISerializable {

 //-------------- MCsharp functions -----------

 public Worker ( ) {
  mcsharp_initiate();
}

 public Worker ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

  private class McsharpPrivateClasshandleSegment {

   Worker parent;
   int myNumber;
   int P;
   int MIN;
   int begin;
   int end;
   int[] s;
   int[,] f;
   int[,] g;
   channel  sendReady;

   public McsharpPrivateClasshandleSegment ( Worker parent,
               int myNumber,
               int P,
               int MIN,
               int begin,
               int end,
               int[] s,
               int[,] f,
               int[,] g,
               channel  sendReady
              ) {
    this.parent = parent;
    this.myNumber = myNumber;
    this.P = P;
    this.MIN = MIN;
    this.begin = begin;
    this.end = end;
    this.s = s;
    this.f = f;
    this.g = g;
    this.sendReady = sendReady;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharphandleSegmentBody ( myNumber, P, MIN, begin, end, s, f, g, sendReady );

   }
  }

  private void mcsharphandleSegmentBody (
               int myNumber,
               int P,
               int MIN,
               int begin,
               int end,
               int[] s,
               int[,] f,
               int[,] g,
               channel  sendReady
              )
 {
   int i , i_min ;

  int sigma_i , divisor ;

  int mid ;

  if ( myNumber  < P  )
    {
   mid = begin + ( end - begin   ) / 2  ;
 new Worker ( ) .handleSegment( myNumber * 2   , P   , MIN   , begin   , mid   , s   , f   , g   , sendStop   )  ;
 new Worker ( ) .handleSegment( myNumber * 2   , P   , MIN   , mid   , end   , s   , f   , g   , sendStop   )  ;
 for ( i = 0  ; i  < 2 ; i++   )
 getStop  .Get(new object[]{ } )
;

  merge( f   , g   , begin - MIN   , mid - MIN   , end - MIN   )  ;
 }

  else
  {
   for ( i = begin  ; i  < end ; i++   )
  {
   i_min = i - MIN  ;
 s[ i_min   ] = FastSum( i   )  ;
 sigma_i = s[ i_min   ] + i  ;
 divisor = gcd( sigma_i   , i   )  ;
 f[ i_min  , 0   ] = sigma_i / divisor  ;
 f[ i_min  , 1   ] = i / divisor  ;
 f[ i_min  , 2   ] = i  ;
 }

  sort( f   , g   , begin - MIN   , end - MIN   )  ;
 }
 
 sendReady.Send ( new object[] {   } )
  ;
 }




  public  void handleSegment (  int myNumber,  int P,  int MIN,  int begin,  int end,  int[] s,  int[,] f,  int[,] g,  channel  sendReady ) {
   McsharpPrivateClasshandleSegment prclassobject = new McsharpPrivateClasshandleSegment ( this, myNumber, P, MIN, begin, end, s, f, g, sendReady );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
public static  int FastSum (  int n )   {
   int sum = 1  ;

  int sqrt = (int)Math.Sqrt( n   )  ;

  for ( int i = 2  ;

  i  <= sqrt + 1 ; i++   )
  {
   if ( n % i  == 0   )
    {
   int j = n / i  ;

  if ( j  > i  )
   sum = sum + i + j  ;

  else
  {
   if ( j  == i   )
   sum = sum + i  ;

  break  ;
 }
 
 }

  }

  return sum  ;
  }
public static  int gcd (  int a,  int b )   {
   int t ;

  while ( b  != 0   )
  {
   t = b  ;
 b = a % b  ;
 a = t  ;
 }

  return a  ;
  }
public static  void sort (  int[,] f,  int[,] g,  int begin,  int end )   {
   if ( begin + 1  == end   )
   return ;
 
  int mid = begin + ( end - begin   ) / 2  ;

  sort( f   , g   , begin   , mid   )  ;
 sort( f   , g   , mid   , end   )  ;
 merge( f   , g   , begin   , mid   , end   )  ;
 return ;
  }
public static  void merge (  int[,] f,  int[,] g,  int begin,  int mid,  int end )   {
   int i , j , k ;

  i = begin  ;
 while ( i  < mid  )
  {
   g[ i  , 0   ] = f[ i  , 0   ]  ;
 g[ i  , 1   ] = f[ i  , 1   ]  ;
 g[ i  , 2   ] = f[ i  , 2   ]  ;
 i++  ;
 }

  i = begin  ;
 j = mid  ;
 k = begin  ;
 while ( i  < mid && j  < end  )
 if ( g[ i  , 0   ]  < f[ j  , 0   ] || ( g[ i  , 0   ]  == f[ j  , 0   ]  && g[ i  , 1   ]  < f[ j  , 1   ]  )   )
    {
   f[ k  , 0   ] = g[ i  , 0   ]  ;
 f[ k  , 1   ] = g[ i  , 1   ]  ;
 f[ k  , 2   ] = g[ i  , 2   ]  ;
 k++  ;
 i++  ;
 }

  else
  {
   f[ k  , 0   ] = f[ j  , 0   ]  ;
 f[ k  , 1   ] = f[ j  , 1   ]  ;
 f[ k  , 2   ] = f[ j  , 2   ]  ;
 k++  ;
 j++  ;
 }
 

  while ( i  < mid  )
  {
   f[ k  , 0   ] = g[ i  , 0   ]  ;
 f[ k  , 1   ] = g[ i  , 1   ]  ;
 f[ k  , 2   ] = g[ i  , 2   ]  ;
 k++  ;
 i++  ;
 }

  }
}

