using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Globalization;
[Serializable()]
public  class FindingRoots : ISerializable {

 //-------------- MCsharp functions -----------

 public FindingRoots ( ) {
  mcsharp_initiate();
}

 public FindingRoots ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendIntervalOrigin = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendIntervalOrigin" );
  mcsharpQueuegetIntervalOrigin = new MCSharp.ThreadQ();

  getIntervalOrigin = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetIntervalOrigin" );
  sendResult = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendResult" );
  mcsharpQueuegetResult = new MCSharp.ThreadQ();

  getResult = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetResult" );
 }

public static  double EPSILON = 0.0000001  ;

 public static  int WORK_ITEM_SIZE = 1000  ;

 public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i ;

  double a , b ;

  int P = 1  ;

  NumberFormatInfo provider = new NumberFormatInfo ( )   ;

  provider.NumberDecimalSeparator = "."  ;
 if ( args.Length  > 1  )
    {
   a = System.Convert.ToDouble( args[ 0   ]   , provider   )  ;
 b = System.Convert.ToDouble( args[ 1   ]   , provider   )  ;
 }

  else
  {
   Console.WriteLine( "\nUsage: FindingRoots <left_end> <right_end> [<procs/threads>]"   )  ;
 return ;
  }
 
 if ( args.Length  > 2  )
   P = System.Convert.ToInt32( args[ 2   ]   )  ;

  Console.WriteLine( "\nGiven interval: [ " + a + ", " + b + " ),  number of procs/cores = " + P   )  ;
 int interval_size = System.Convert.ToInt32( ( b - a   ) / EPSILON   )  ;

  if ( interval_size % WORK_ITEM_SIZE  != 0   )
    {
   Console.WriteLine( "The width of input interval must be at least " + ( WORK_ITEM_SIZE * EPSILON   )   )  ;
 Console.WriteLine( "Please modify the input parameters ..."   )  ;
 return ;
  }

  FindingRoots fr = new FindingRoots ( )   ;

  for ( i = 0  ; i  < P ; i++   )
 fr.Worker( i   , a   , fr.getIntervalOrigin   , fr.sendResult   )  ;

  for ( i = 0  ; i  < interval_size ; i = i + WORK_ITEM_SIZE   )
 fr.sendIntervalOrigin.Send ( new object[] {  i    } )
  ;

  for ( i = 0  ; i  < P ; i++   )
 fr.sendIntervalOrigin.Send ( new object[] {  -1    } )
  ;

  int roots = 0  ;

  for ( i = 0  ; i  < P ; i++   )
 roots += (int)fr.getResult  .Get(new object[]{ } )
;

  Console.WriteLine( "Number of roots is " + roots   )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendIntervalOrigin;

 //-------------Handler declaration-----------------

    public MCSharp.handler getIntervalOrigin;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetIntervalOrigin;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getIntervalOrigin = 1 << 0;
 private const int mcsharp_mask_sendIntervalOrigin = 1 << 1;
 private const int mcsharp_mask_getIntervalOriginsendIntervalOrigin =
            mcsharp_mask_getIntervalOrigin
          | mcsharp_mask_sendIntervalOrigin;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetIntervalOriginsendIntervalOrigin = new MCSharp.BitMask();

 private void scangetIntervalOriginsendIntervalOrigin () {
  if ( mcsharpBitMaskgetIntervalOriginsendIntervalOrigin.match
        ( mcsharp_mask_getIntervalOriginsendIntervalOrigin ) )
   mcsharpQueuegetIntervalOrigin.wakeup();
 }


[OneWay]
public void mcsharpChannelsendIntervalOrigin (  int b )  {
   lock ( mcsharpQueuegetIntervalOrigin ) {
    sendIntervalOrigin.Enqueue ( new object [] { b } );
    if ( ! mcsharpBitMaskgetIntervalOriginsendIntervalOrigin.match
          ( mcsharp_mask_sendIntervalOrigin ) )   {
     mcsharpBitMaskgetIntervalOriginsendIntervalOrigin.set ( mcsharp_mask_sendIntervalOrigin );
     scangetIntervalOriginsendIntervalOrigin ();
    }
   }
 }

 public int mcsharpHandlergetIntervalOrigin (  )   {
  Monitor.Enter ( mcsharpQueuegetIntervalOrigin );
  if ( ! mcsharpBitMaskgetIntervalOriginsendIntervalOrigin.match ( mcsharp_mask_getIntervalOrigin ) ) goto now;
  later:
   mcsharpQueuegetIntervalOrigin.yield ( mcsharpQueuegetIntervalOrigin );
   if ( mcsharpQueuegetIntervalOrigin.empty )
    mcsharpBitMaskgetIntervalOriginsendIntervalOrigin.clear ( mcsharp_mask_getIntervalOrigin );
  now:
   if ( mcsharpBitMaskgetIntervalOriginsendIntervalOrigin.match ( 
    mcsharp_mask_sendIntervalOrigin ) )   {
    object[] osendIntervalOrigin = ( object[] ) sendIntervalOrigin.Dequeue();
    int b = ( int ) osendIntervalOrigin [ 0 ];
    if ( sendIntervalOrigin.Count == 0 )
         mcsharpBitMaskgetIntervalOriginsendIntervalOrigin.clear ( mcsharp_mask_sendIntervalOrigin );
    scangetIntervalOriginsendIntervalOrigin ();
    Monitor.Exit ( mcsharpQueuegetIntervalOrigin );
     {
   return ( b   )  ;
  }
   }
   else {
    mcsharpBitMaskgetIntervalOriginsendIntervalOrigin.set ( mcsharp_mask_getIntervalOrigin );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendResult;

 //-------------Handler declaration-----------------

    public MCSharp.handler getResult;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetResult;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getResult = 1 << 0;
 private const int mcsharp_mask_sendResult = 1 << 1;
 private const int mcsharp_mask_getResultsendResult =
            mcsharp_mask_getResult
          | mcsharp_mask_sendResult;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetResultsendResult = new MCSharp.BitMask();

 private void scangetResultsendResult () {
  if ( mcsharpBitMaskgetResultsendResult.match
        ( mcsharp_mask_getResultsendResult ) )
   mcsharpQueuegetResult.wakeup();
 }


[OneWay]
public void mcsharpChannelsendResult (  int x )  {
   lock ( mcsharpQueuegetResult ) {
    sendResult.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskgetResultsendResult.match
          ( mcsharp_mask_sendResult ) )   {
     mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_sendResult );
     scangetResultsendResult ();
    }
   }
 }

 public int mcsharpHandlergetResult (  )   {
  Monitor.Enter ( mcsharpQueuegetResult );
  if ( ! mcsharpBitMaskgetResultsendResult.match ( mcsharp_mask_getResult ) ) goto now;
  later:
   mcsharpQueuegetResult.yield ( mcsharpQueuegetResult );
   if ( mcsharpQueuegetResult.empty )
    mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_getResult );
  now:
   if ( mcsharpBitMaskgetResultsendResult.match ( 
    mcsharp_mask_sendResult ) )   {
    object[] osendResult = ( object[] ) sendResult.Dequeue();
    int x = ( int ) osendResult [ 0 ];
    if ( sendResult.Count == 0 )
         mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_sendResult );
    scangetResultsendResult ();
    Monitor.Exit ( mcsharpQueuegetResult );
     {
   return ( x   )  ;
  }
   }
   else {
    mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_getResult );
    goto later;
  }

 }
  private class McsharpPrivateClassWorker {

   FindingRoots parent;
   int ownNumber;
   double origin;
   handler  getIntervalOrigin;
   channel  sendResult;

   public McsharpPrivateClassWorker ( FindingRoots parent,
               int ownNumber,
               double origin,
               handler  getIntervalOrigin,
               channel  sendResult
              ) {
    this.parent = parent;
    this.ownNumber = ownNumber;
    this.origin = origin;
    this.getIntervalOrigin = getIntervalOrigin;
    this.sendResult = sendResult;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpWorkerBody ( ownNumber, origin, getIntervalOrigin, sendResult );

   }
  }

  private void mcsharpWorkerBody (
               int ownNumber,
               double origin,
               handler  getIntervalOrigin,
               channel  sendResult
              )
 {
   double a , b , Fa , Fb , end ;

  int roots = 0  ;

  int offset = (int)getIntervalOrigin  .Get(new object[]{ } )
;

  while ( offset  != -1   )
  {
   a = origin + offset * EPSILON  ;
 end = origin + ( offset + WORK_ITEM_SIZE   ) * EPSILON  ;
 b = a + EPSILON  ;
 Fa = F( a   )  ;
 Fb = F( b   )  ;
 while ( a  < end  )
  {
   if ( Math.Sign( Fa   )  != Math.Sign( Fb   )   )
   roots++  ;

  a = b  ;
 Fa = Fb  ;
 b += EPSILON  ;
 Fb = F( b   )  ;
 }

  offset = (int)getIntervalOrigin  .Get(new object[]{ } )
;
 }

  sendResult.Send ( new object[] {  roots    } )
  ;
 }




  public  void Worker (  int ownNumber,  double origin,  handler  getIntervalOrigin,  channel  sendResult ) {
   McsharpPrivateClassWorker prclassobject = new McsharpPrivateClassWorker ( this, ownNumber, origin, getIntervalOrigin, sendResult );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public static  double F (  double x )   {
   double Fx = -2.0  ;

  double arg = 1.0  ;

  for ( int i = 1  ;

  i  <= 1000 ; i++   )
  {
   arg = arg * x  ;
 Fx += Math.Sin( arg   )  ;
 }

  return ( Fx   )  ;
  }
}

