using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Collections;
using System.IO;
[Serializable()]
public  class Communicator : ISerializable {

 //-------------- MCsharp functions -----------

 public Communicator ( ) {
  mcsharp_initiate();
}

 public Communicator ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  toUp = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChanneltoUp" );
  mcsharpQueuefromDown = new MCSharp.ThreadQ();

  fromDown = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerfromDown" );
  toDown = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChanneltoDown" );
  mcsharpQueuefromUp = new MCSharp.ThreadQ();

  fromUp = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerfromUp" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel toUp;

 //-------------Handler declaration-----------------

    public MCSharp.handler fromDown;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuefromDown;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_fromDown = 1 << 0;
 private const int mcsharp_mask_toUp = 1 << 1;
 private const int mcsharp_mask_fromDowntoUp =
            mcsharp_mask_fromDown
          | mcsharp_mask_toUp;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskfromDowntoUp = new MCSharp.BitMask();

 private void scanfromDowntoUp () {
  if ( mcsharpBitMaskfromDowntoUp.match
        ( mcsharp_mask_fromDowntoUp ) )
   mcsharpQueuefromDown.wakeup();
 }


[OneWay]
public void mcsharpChanneltoUp (  )  {
   lock ( mcsharpQueuefromDown ) {
    toUp.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskfromDowntoUp.match
          ( mcsharp_mask_toUp ) )   {
     mcsharpBitMaskfromDowntoUp.set ( mcsharp_mask_toUp );
     scanfromDowntoUp ();
    }
   }
 }

 public void mcsharpHandlerfromDown (  )   {
  Monitor.Enter ( mcsharpQueuefromDown );
  if ( ! mcsharpBitMaskfromDowntoUp.match ( mcsharp_mask_fromDown ) ) goto now;
  later:
   mcsharpQueuefromDown.yield ( mcsharpQueuefromDown );
   if ( mcsharpQueuefromDown.empty )
    mcsharpBitMaskfromDowntoUp.clear ( mcsharp_mask_fromDown );
  now:
   if ( mcsharpBitMaskfromDowntoUp.match ( 
    mcsharp_mask_toUp ) )   {
    object[] otoUp = ( object[] ) toUp.Dequeue();
    if ( toUp.Count == 0 )
         mcsharpBitMaskfromDowntoUp.clear ( mcsharp_mask_toUp );
    scanfromDowntoUp ();
    Monitor.Exit ( mcsharpQueuefromDown );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskfromDowntoUp.set ( mcsharp_mask_fromDown );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel toDown;

 //-------------Handler declaration-----------------

    public MCSharp.handler fromUp;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuefromUp;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_fromUp = 1 << 0;
 private const int mcsharp_mask_toDown = 1 << 1;
 private const int mcsharp_mask_fromUptoDown =
            mcsharp_mask_fromUp
          | mcsharp_mask_toDown;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskfromUptoDown = new MCSharp.BitMask();

 private void scanfromUptoDown () {
  if ( mcsharpBitMaskfromUptoDown.match
        ( mcsharp_mask_fromUptoDown ) )
   mcsharpQueuefromUp.wakeup();
 }


[OneWay]
public void mcsharpChanneltoDown (  )  {
   lock ( mcsharpQueuefromUp ) {
    toDown.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskfromUptoDown.match
          ( mcsharp_mask_toDown ) )   {
     mcsharpBitMaskfromUptoDown.set ( mcsharp_mask_toDown );
     scanfromUptoDown ();
    }
   }
 }

 public void mcsharpHandlerfromUp (  )   {
  Monitor.Enter ( mcsharpQueuefromUp );
  if ( ! mcsharpBitMaskfromUptoDown.match ( mcsharp_mask_fromUp ) ) goto now;
  later:
   mcsharpQueuefromUp.yield ( mcsharpQueuefromUp );
   if ( mcsharpQueuefromUp.empty )
    mcsharpBitMaskfromUptoDown.clear ( mcsharp_mask_fromUp );
  now:
   if ( mcsharpBitMaskfromUptoDown.match ( 
    mcsharp_mask_toDown ) )   {
    object[] otoDown = ( object[] ) toDown.Dequeue();
    if ( toDown.Count == 0 )
         mcsharpBitMaskfromUptoDown.clear ( mcsharp_mask_toDown );
    scanfromUptoDown ();
    Monitor.Exit ( mcsharpQueuefromUp );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskfromUptoDown.set ( mcsharp_mask_fromUp );
    goto later;
  }

 }
}

[Serializable()]
public  class Cell : ISerializable {

 //-------------- MCsharp functions -----------

 public Cell ( ) {
  mcsharp_initiate();
}

 public Cell ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public  int row ;

 public  int col ;

 public  Cell (  int r,  int c )  {

   mcsharp_initiate();

    row = r  ;
 col = c  ;


 }

}

[Serializable()]
public  class ReusableCellList : ISerializable {

 //-------------- MCsharp functions -----------

 public ReusableCellList ( ) {
  mcsharp_initiate();
}

 public ReusableCellList ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

private  ArrayList list ;

 private  int size ;

 private  int count ;

 public  ReusableCellList (  int n )  {

   mcsharp_initiate();

    list = new ArrayList ( n   )   ;
 size = 0  ;
 count = 0  ;


 }

public  int Count {get  {
   return count  ;
  }
 }public  void AddCell (  int row,  int col )   {
   Cell c1 ;

  if ( count  == size   )
    {
   list.Add( new Cell ( row   , col   )    )  ;
 size++  ;
 }

  else
  {
   c1 = (Cell)list[ count   ]  ;
 c1.row = row  ;
 c1.col = col  ;
 }
 
 count++  ;
 }
public  void Clear (  )   {
   count = 0  ;
 }
public  Cell GetByIndex (  int i )   {
   return (Cell)list[ i   ]  ;
  }
}

[Serializable()]
public  class GameOfLife : ISerializable {

 //-------------- MCsharp functions -----------

 public GameOfLife ( ) {
  mcsharp_initiate();
}

 public GameOfLife ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  int DEAD = 0  ;

 public static  int ALIVE = 1  ;

 public static  int MAXROW = 5000  ;

 public static  int MAXCOL = 5000  ;

 public static  int[,] map = new int [ MAXROW  , MAXCOL   ]    ;

 public static  int[,] numNeighbors = new int [ MAXROW  , MAXCOL   ]    ;

 public static  int[,] up_deltas ;

 public static  int[,] down_deltas ;

 public static  Communicator[] comms = null  ;

 public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i ;

  int P = 1  ;

  int gens = 1  ;

  Cell c1 = null  , c2 = null  ;

  String fName ;

  if ( args.Length  > 0  )
    {
   fName = args[ 0   ]  ;
 if ( args.Length  > 1  )
   P = System.Convert.ToInt32( args[ 1   ]   )  ;

  }

  else
  {
   Console.WriteLine( "\nUsage: GameOfLife <file_name> [<procs/threads>]"   )  ;
 return ;
  }
 
 Console.WriteLine( "FILE NAME: " + fName   )  ;
 Initialize( P   , fName   , out gens   , out c1   , out c2   )  ;
 GameOfLife gol = new GameOfLife ( )   ;

  DateTime dt1 = DateTime.Now  ;

  int q = MAXROW / P  , r = MAXROW % P  ;

  int first = 0  , last ;

  for ( i = 0  ; i  < P ; i++   )
  {
   last = first + q - 1 + ( i  < r  ? 1   : 0    )  ;
 gol.Worker( i   , P   , gens   , first   , last   , gol.sendStop   )  ;
 first = last + 1  ;
 }

  for ( i = 0  ; i  < P ; i++   )
 gol.getStop  .Get(new object[]{ } )
;

  DateTime dt2 = DateTime.Now  ;

  WriteMap( gens   , c1   , c2   )  ;
 Console.WriteLine( "\nElapsed time: " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
public static  void Initialize (  int P,  String fName, out  int gens, out  Cell c1, out  Cell c2 )   {
   int i , j ;

  if ( P  > 1  )
    {
   comms = new Communicator [ P - 1   ]    ;
 for ( i = 0  ; i  < P - 1 ; i++   )
 comms[ i   ] = new Communicator ( )   ;

  }

  up_deltas = new int [ P  , MAXCOL   ]    ;
 down_deltas = new int [ P  , MAXCOL   ]    ;
 for ( i = 0  ; i  < P ; i++   )
 for ( j = 0  ; j  < MAXCOL ; j++   )
  {
   up_deltas[ i  , j   ] = 0  ;
 down_deltas[ i  , j   ] = 0  ;
 }

 
  ReadMap( fName   , out gens   , out c1   , out c2   )  ;
 }
public static  void ReadMap (  String fName, out  int gens, out  Cell c1, out  Cell c2 )   {
   int row , col ;

  int nbrrow , nbrcol ;

  int good = 0  , bad = 0  , dup = 0  ;

  String[] ss ;

  for ( row = 0  ; row  < MAXROW ; row++   )
 for ( col = 0  ; col  < MAXCOL ; col++   )
  {
   map[ row  , col   ] = DEAD  ;
 numNeighbors[ row  , col   ] = 0  ;
 }

 
  FileStream fs = new FileStream ( fName   , FileMode.Open   )   ;

  StreamReader sr = new StreamReader ( fs   )   ;

  Console.WriteLine( "Reading input data from " + fName + " ..."   )  ;
 ss = sr.ReadLine( ).Split( ' '   )  ;
 row = System.Convert.ToInt32( ss[ 0   ]   )  ;
 col = System.Convert.ToInt32( ss[ 1   ]   )  ;
 while ( row  != 0  || col  != 0   )
  {
   if ( row  >= 1 && row  <= MAXROW && col  >= 1 && col  <= MAXCOL  )
    {
   if ( map[ row - 1  , col - 1   ]  == DEAD   )
    {
   good++  ;
 map[ row - 1  , col - 1   ] = ALIVE  ;
 for ( nbrrow = row - 2  ; nbrrow  <= row ; nbrrow++   )
 for ( nbrcol = col - 2  ; nbrcol  <= col ; nbrcol++   )
 if ( nbrrow  >= 0 && nbrrow  < MAXROW && nbrcol  >= 0 && nbrcol  < MAXCOL && ( nbrrow  != row - 1  || nbrcol  != col - 1   )   )
   numNeighbors[ nbrrow  , nbrcol   ]++  ;

 
 
  }

  else
 dup++  ;
 
 }

  else
 bad++  ;
 
 ss = sr.ReadLine( ).Split( ' '   )  ;
 row = System.Convert.ToInt32( ss[ 0   ]   )  ;
 col = System.Convert.ToInt32( ss[ 1   ]   )  ;
 }

  ss = sr.ReadLine( ).Split( ' '   )  ;
 gens = System.Convert.ToInt32( ss[ 0   ]   )  ;
 ss = sr.ReadLine( ).Split( ' '   )  ;
 c1 = new Cell ( System.Convert.ToInt32( ss[ 0   ]   ) - 1   , System.Convert.ToInt32( ss[ 1   ]   ) - 1   )   ;
 c2 = new Cell ( System.Convert.ToInt32( ss[ 2   ]   ) - 1   , System.Convert.ToInt32( ss[ 3   ]   ) - 1   )   ;
 Console.Write( "Done.\n " + good + " cells created"   )  ;
 if ( bad  > 0  )
   Console.Write( ", " + bad + " cells out of range"   )  ;

  if ( dup  > 0  )
   Console.Write( " and " + dup + " cells duplicated"   )  ;

  Console.WriteLine( "\nNumber of generations to simulate: " + gens   )  ;
 Console.WriteLine( "Final print area is " + ( c1.row + 1   ) + " " + ( c1.col + 1   ) + " " + ( c2.row + 1   ) + " " + ( c2.col + 1   )   )  ;
 sr.Close( )  ;
 fs.Close( )  ;
 }
  private class McsharpPrivateClassWorker {

   GameOfLife parent;
   int ownNumber;
   int P;
   int gens;
   int first;
   int last;
   channel  sendStop;

   public McsharpPrivateClassWorker ( GameOfLife parent,
               int ownNumber,
               int P,
               int gens,
               int first,
               int last,
               channel  sendStop
              ) {
    this.parent = parent;
    this.ownNumber = ownNumber;
    this.P = P;
    this.gens = gens;
    this.first = first;
    this.last = last;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpWorkerBody ( ownNumber, P, gens, first, last, sendStop );

   }
  }

  private void mcsharpWorkerBody (
               int ownNumber,
               int P,
               int gens,
               int first,
               int last,
               channel  sendStop
              )
 {
   int i , j ;

  int gencount = 0  ;

  ReusableCellList maylive = new ReusableCellList ( MAXCOL   )   ;

  ReusableCellList newlive = new ReusableCellList ( MAXCOL   )   ;

  ReusableCellList maydie = new ReusableCellList ( MAXCOL   )   ;

  ReusableCellList newdie = new ReusableCellList ( MAXCOL   )   ;

  for ( i = first  ; i  <= last ; i++   )
 for ( j = 0  ; j  < MAXCOL ; j++   )
  {
   if ( map[ i  , j   ]  == DEAD  && numNeighbors[ i  , j   ]  == 3   )
   maylive.AddCell( i   , j   )  ;

  if ( map[ i  , j   ]  == ALIVE  && ( numNeighbors[ i  , j   ]  <= 1 || numNeighbors[ i  , j   ]  >= 4  )   )
   maydie.AddCell( i   , j   )  ;

  }

 
  while ( gencount  < gens  )
  {
   gencount++  ;
 Vivify( ownNumber   , first   , last   , P   , maylive   , newlive   )  ;
 maylive.Clear( )  ;
 Kill( ownNumber   , first   , last   , P   , maydie   , newdie   )  ;
 maydie.Clear( )  ;
 if ( ownNumber  != 0   )
   comms[ ownNumber - 1   ].toUp.Send ( new object[] {   } )
  ;

  if ( ownNumber  != P - 1   )
   comms[ ownNumber   ].toDown.Send ( new object[] {   } )
  ;

  if ( ownNumber  != 0   )
   comms[ ownNumber - 1   ].fromUp  .Get(new object[]{ } )
;

  if ( ownNumber  != P - 1   )
   comms[ ownNumber   ].fromDown  .Get(new object[]{ } )
;

  AddNeighbors( first   , last   , newlive   , maylive   , maydie   )  ;
 newlive.Clear( )  ;
 SubtractNeighbors( first   , last   , newdie   , maylive   , maydie   )  ;
 newdie.Clear( )  ;
 if ( ownNumber  != 0   )
   HandleDeltas( ownNumber - 1   , down_deltas   , first   , maylive   , maydie   )  ;

  if ( ownNumber  != P - 1   )
   HandleDeltas( ownNumber + 1   , up_deltas   , last   , maylive   , maydie   )  ;

  if ( ownNumber  != 0   )
   comms[ ownNumber - 1   ].toUp.Send ( new object[] {   } )
  ;

  if ( ownNumber  != P - 1   )
   comms[ ownNumber   ].toDown.Send ( new object[] {   } )
  ;

  if ( ownNumber  != 0   )
   comms[ ownNumber - 1   ].fromUp  .Get(new object[]{ } )
;

  if ( ownNumber  != P - 1   )
   comms[ ownNumber   ].fromDown  .Get(new object[]{ } )
;

  }

  sendStop.Send ( new object[] {   } )
  ;
 }




  public  void Worker (  int ownNumber,  int P,  int gens,  int first,  int last,  channel  sendStop ) {
   McsharpPrivateClassWorker prclassobject = new McsharpPrivateClassWorker ( this, ownNumber, P, gens, first, last, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public static  void Vivify (  int ownNumber,  int first,  int last,  int P,  ReusableCellList maylive,  ReusableCellList newlive )   {
   int i ;

  int nbrcol ;

  Cell cell ;

  for ( i = 0  ; i  < maylive.Count ; i++   )
  {
   cell = maylive.GetByIndex( i   )  ;
 if ( map[ cell.row  , cell.col   ]  == DEAD  && numNeighbors[ cell.row  , cell.col   ]  == 3   )
    {
   map[ cell.row  , cell.col   ] = ALIVE  ;
 newlive.AddCell( cell.row   , cell.col   )  ;
 if ( ownNumber  != 0  && cell.row  == first   )
   for ( nbrcol = cell.col - 1  ; nbrcol  <= cell.col + 1 ; nbrcol++   )
 if ( nbrcol  >= 0 && nbrcol  < MAXCOL  )
   up_deltas[ ownNumber  , nbrcol   ]++  ;

 
 
  if ( ownNumber  != P - 1  && cell.row  == last   )
   for ( nbrcol = cell.col - 1  ; nbrcol  <= cell.col + 1 ; nbrcol++   )
 if ( nbrcol  >= 0 && nbrcol  < MAXCOL  )
   down_deltas[ ownNumber  , nbrcol   ]++  ;

 
 
  }

  }

  }
public static  void Kill (  int ownNumber,  int first,  int last,  int P,  ReusableCellList maydie,  ReusableCellList newdie )   {
   int i ;

  int nbrcol ;

  Cell cell ;

  for ( i = 0  ; i  < maydie.Count ; i++   )
  {
   cell = maydie.GetByIndex( i   )  ;
 if ( map[ cell.row  , cell.col   ]  == ALIVE  && ( numNeighbors[ cell.row  , cell.col   ]  > 3 || numNeighbors[ cell.row  , cell.col   ]  < 2  )   )
    {
   map[ cell.row  , cell.col   ] = DEAD  ;
 newdie.AddCell( cell.row   , cell.col   )  ;
 if ( ownNumber  != 0  && cell.row  == first   )
   for ( nbrcol = cell.col - 1  ; nbrcol  <= cell.col + 1 ; nbrcol++   )
 if ( nbrcol  >= 0 && nbrcol  < MAXCOL  )
   up_deltas[ ownNumber  , nbrcol   ]--  ;

 
 
  if ( ownNumber  != P - 1  && cell.row  == last   )
   for ( nbrcol = cell.col - 1  ; nbrcol  <= cell.col + 1 ; nbrcol++   )
 if ( nbrcol  >= 0 && nbrcol  < MAXCOL  )
   down_deltas[ ownNumber  , nbrcol   ]--  ;

 
 
  }

  }

  }
public static  void HandleDeltas (  int neigh,  int[,] deltas,  int line,  ReusableCellList maylive,  ReusableCellList maydie )   {
   for ( int i = 0  ;

  i  < MAXCOL ; i++   )
 if ( deltas[ neigh  , i   ]  > 0  )
   while ( deltas[ neigh  , i   ]  != 0   )
  {
   deltas[ neigh  , i   ]--  ;
 numNeighbors[ line  , i   ]++  ;
 if ( map[ line  , i   ]  == DEAD  && numNeighbors[ line  , i   ]  == 3   )
   maylive.AddCell( line   , i   )  ;

  else
 if ( map[ line  , i   ]  == ALIVE  && numNeighbors[ line  , i   ]  == 4   )
   maydie.AddCell( line   , i   )  ;

  
 }

 
  else
 if ( deltas[ neigh  , i   ]  < 0  )
   while ( deltas[ neigh  , i   ]  != 0   )
  {
   deltas[ neigh  , i   ]++  ;
 numNeighbors[ line  , i   ]--  ;
 if ( map[ line  , i   ]  == DEAD  && numNeighbors[ line  , i   ]  == 3   )
   maylive.AddCell( line   , i   )  ;

  else
 if ( map[ line  , i   ]  == ALIVE  && numNeighbors[ line  , i   ]  == 1   )
   maydie.AddCell( line   , i   )  ;

  
 }

 
  

  }
public static  void AddNeighbors (  int first,  int last,  ReusableCellList newlive,  ReusableCellList maylive,  ReusableCellList maydie )   {
   int i ;

  int nbrrow , nbrcol ;

  Cell cell ;

  for ( i = 0  ; i  < newlive.Count ; i++   )
  {
   cell = newlive.GetByIndex( i   )  ;
 for ( nbrrow = cell.row - 1  ; nbrrow  <= cell.row + 1 ; nbrrow++   )
 if ( nbrrow  >= first && nbrrow  <= last  )
   for ( nbrcol = cell.col - 1  ; nbrcol  <= cell.col + 1 ; nbrcol++   )
 if ( nbrcol  >= 0 && nbrcol  < MAXCOL && ( nbrrow  != cell.row  || nbrcol  != cell.col   )   )
    {
   numNeighbors[ nbrrow  , nbrcol   ]++  ;
 if ( map[ nbrrow  , nbrcol   ]  == DEAD  && numNeighbors[ nbrrow  , nbrcol   ]  == 3   )
   maylive.AddCell( nbrrow   , nbrcol   )  ;

  else
 if ( map[ nbrrow  , nbrcol   ]  == ALIVE  && numNeighbors[ nbrrow  , nbrcol   ]  == 4   )
   maydie.AddCell( nbrrow   , nbrcol   )  ;

  
 }

 
 
 
  }

  }
public static  void SubtractNeighbors (  int first,  int last,  ReusableCellList newdie,  ReusableCellList maylive,  ReusableCellList maydie )   {
   int i ;

  int nbrrow , nbrcol ;

  Cell cell ;

  for ( i = 0  ; i  < newdie.Count ; i++   )
  {
   cell = newdie.GetByIndex( i   )  ;
 for ( nbrrow = cell.row - 1  ; nbrrow  <= cell.row + 1 ; nbrrow++   )
 if ( nbrrow  >= first && nbrrow  <= last  )
   for ( nbrcol = cell.col - 1  ; nbrcol  <= cell.col + 1 ; nbrcol++   )
 if ( nbrcol  >= 0 && nbrcol  < MAXCOL && ( nbrrow  != cell.row  || nbrcol  != cell.col   )   )
    {
   numNeighbors[ nbrrow  , nbrcol   ]--  ;
 if ( map[ nbrrow  , nbrcol   ]  == DEAD  && numNeighbors[ nbrrow  , nbrcol   ]  == 3   )
   maylive.AddCell( nbrrow   , nbrcol   )  ;

  else
 if ( map[ nbrrow  , nbrcol   ]  == ALIVE  && numNeighbors[ nbrrow  , nbrcol   ]  == 1   )
   maydie.AddCell( nbrrow   , nbrcol   )  ;

  
 }

 
 
 
  }

  }
public static  void WriteMap (  int gens,  Cell c1,  Cell c2 )   {
   int row , col ;

  int i ;

  Console.Write( "\n\n"   )  ;
 for ( i = 0  ; i  < ( c2.col - c1.col   ) / 2 ; i++   )
 Console.Write( " "   )  ;

  Console.WriteLine( "GENERATION #" + gens + "\n"   )  ;
 for ( row = c1.row  ; row  <= c2.row ; row++   )
  {
   for ( col = c1.col  ; col  <= c2.col ; col++   )
 if ( map[ row  , col   ]  == ALIVE   )
   Console.Write( "*"   )  ;

  else
 Console.Write( "-"   )  ;
 

  Console.WriteLine( )  ;
 }

  }
}

