using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;
using System.Collections;
[Serializable()]
public  class GracefulGraph : ISerializable {

 //-------------- MCsharp functions -----------

 public GracefulGraph ( ) {
  mcsharp_initiate();
}

 public GracefulGraph ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendResult = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendResult" );
  mcsharpQueuegetResult = new MCSharp.ThreadQ();

  getResult = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetResult" );
  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  int THRESHOLD = 3  ;

 public static  bool contin = true  ;

 public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i , j ;

  bool isEven ;

  if ( args.Length  == 0   )
    {
   Console.WriteLine( "\nUsage: GracefulGraph <file-name>"   )  ;
 return ;
  }

  String filename = args[ 0   ]  ;

  int[,] G = null  ;

  int[,] V_matrix = null  ;

  int[] vertex_degrees = null  ;

  int n = 0  ;

  int e = 0  ;

  ArrayList vertices = null  ;

  ArrayList edges_names = null  ;

  readFile( filename   , ref n   , ref e   , ref G   , ref V_matrix   , ref vertices   , ref edges_names   , ref vertex_degrees   )  ;
 if ( e % 4  == 1  || e % 4  == 2   )
    {
   i = 0  ;
 isEven = true  ;
 while ( isEven  && i  < n  )
 if ( vertex_degrees[ i   ] % 2  == 0   )
   i++  ;

  else
 isEven = false  ;
 

  if ( isEven   )
    {
   Console.WriteLine( "The given graph has no a graceful labeling due to parity condition ..."   )  ;
 return ;
  }

  }

  int[] VL = new int [ n   ]    ;

  for ( i = 0  ; i  < n ; i++   )
 VL[ i   ] = -1  ;

  int[] EL = new int [ e   ]    ;

  for ( i = 0  ; i  < e ; i++   )
 EL[ i   ] = 0  ;

  int[] elabels = new int [ e + 1   ]    ;

  for ( i = 0  ; i  < e + 1 ; i++   )
 elabels[ i   ] = -1  ;

  DateTime dt1 = DateTime.Now  ;

  int v0 = 0  ;

  bool success = false  ;

  int[] result_VL = null  ;

  GracefulGraph gg = new GracefulGraph ( )   ;

  while ( !success  && v0  < n  )
  {
   if ( v0  != 0   )
   VL[ v0 - 1   ] = -1  ;

  VL[ v0   ] = 0  ;
 gg.Search( e   , v0   , VL   , EL   , elabels   , G   , V_matrix   , n   , e   , gg.sendResult   , gg.sendStop   )  ;
 result_VL = (int[])gg.getResult  .Get(new object[]{ } )
;
 if ( result_VL[ 0   ]  == -1   )
   v0++  ;

  else
 success = true  ;
 
 }

  contin = false  ;
 gg.getStop  .Get(new object[]{ } )
;
 DateTime dt2 = DateTime.Now  ;

  if ( success   )
    {
   String[] vertices_names = new String [ n   ]    ;

  for ( i = 0  ; i  < n ; i++   )
 vertices_names[ i   ] = (String)vertices[ i   ]  ;

  Array.Sort( vertices_names   )  ;
 Console.WriteLine( "The given graph has the following graceful labeling:"   )  ;
 for ( i = 0  ; i  < n ; i++   )
  {
   j = 0  ;
 while ( !vertices[ j   ].Equals( vertices_names[ i   ]   )   )
 j++  ;

  Console.WriteLine( vertices[ j   ] + " : " + result_VL[ j   ]   )  ;
 }

  Console.WriteLine( )  ;
 int vi , vj , value ;

  for ( i = 0  ; i  < n ; i++   )
  {
   vi = result_VL[ i   ]  ;
 for ( j = 0  ; j  < G[ i  , 0   ] ; j++   )
  {
   vj = result_VL[ V_matrix[ i  , j + 1   ]   ]  ;
 value = vi - vj  ;
 if ( value  < 0  )
   value = -value  ;

  elabels[ value   ] = G[ i  , j + 1   ]  ;
 }

  }

  for ( i = 1  ; i  < e + 1 ; i++   )
 Console.WriteLine( edges_names[ elabels[ i   ]   ] + " : " + i   )  ;

  }

  else
 Console.WriteLine( "The given graph has no a graceful labeling ..."   )  ;
 
 Console.WriteLine( "Elapsed time : " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendResult;

 //-------------Handler declaration-----------------

    public MCSharp.handler getResult;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetResult;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getResult = 1 << 0;
 private const int mcsharp_mask_sendResult = 1 << 1;
 private const int mcsharp_mask_getResultsendResult =
            mcsharp_mask_getResult
          | mcsharp_mask_sendResult;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetResultsendResult = new MCSharp.BitMask();

 private void scangetResultsendResult () {
  if ( mcsharpBitMaskgetResultsendResult.match
        ( mcsharp_mask_getResultsendResult ) )
   mcsharpQueuegetResult.wakeup();
 }


[OneWay]
public void mcsharpChannelsendResult (  int[] VL )  {
   lock ( mcsharpQueuegetResult ) {
    sendResult.Enqueue ( new object [] { VL } );
    if ( ! mcsharpBitMaskgetResultsendResult.match
          ( mcsharp_mask_sendResult ) )   {
     mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_sendResult );
     scangetResultsendResult ();
    }
   }
 }

 public int[] mcsharpHandlergetResult (  )   {
  Monitor.Enter ( mcsharpQueuegetResult );
  if ( ! mcsharpBitMaskgetResultsendResult.match ( mcsharp_mask_getResult ) ) goto now;
  later:
   mcsharpQueuegetResult.yield ( mcsharpQueuegetResult );
   if ( mcsharpQueuegetResult.empty )
    mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_getResult );
  now:
   if ( mcsharpBitMaskgetResultsendResult.match ( 
    mcsharp_mask_sendResult ) )   {
    object[] osendResult = ( object[] ) sendResult.Dequeue();
    int[] VL = ( int[] ) osendResult [ 0 ];
    if ( sendResult.Count == 0 )
         mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_sendResult );
    scangetResultsendResult ();
    Monitor.Exit ( mcsharpQueuegetResult );
     {
   return ( VL   )  ;
  }
   }
   else {
    mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_getResult );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
public static  void readFile (  String filename, ref  int n, ref  int e, ref  int[,] G, ref  int[,] V_matrix, ref  ArrayList vertices, ref  ArrayList edges_names, ref  int[] vertex_degrees )   {
   int i , j , k , tmp ;

  String edge ;

  bool found ;

  String[] v12 = new String [ 2   ]    ;

  int[] v12_int = new int [ 2   ]    ;

  FileStream fs = new FileStream ( filename   , FileMode.Open   , FileAccess.Read   )   ;

  StreamReader sr = new StreamReader ( fs   )   ;

  edges_names = new ArrayList ( )   ;
 String str = sr.ReadLine( )  ;

  while ( str  != null  && str.Length  >= 4  )
  {
   edges_names.Add( str   )  ;
 str = sr.ReadLine( )  ;
 }

  e = edges_names.Count  ;
 Console.WriteLine( "e=" + e   )  ;
 vertices = new ArrayList ( )   ;
 for ( i = 0  ; i  < e ; i++   )
  {
   edge = (String)edges_names[ i   ]  ;
 v12[ 0   ] = edge.Substring( 0   , 2   )  ;
 v12[ 1   ] = edge.Substring( 2   , 2   )  ;
 for ( j = 0  ; j  < 2 ; j++   )
  {
   found = false  ;
 k = 0  ;
 while ( !found  && k  < vertices.Count  )
 if ( v12[ j   ].Equals( (String)vertices[ k   ]   )   )
   found = true  ;

  else
 k++  ;
 

  if ( !found   )
   vertices.Add( v12[ j   ]   )  ;

  }

  }

  n = vertices.Count  ;
 Console.WriteLine( "n=" + n   )  ;
 vertex_degrees = new int [ n   ]    ;
 for ( i = 0  ; i  < n ; i++   )
 vertex_degrees[ i   ] = 0  ;

  G = new int [ n  , e + 1   ]    ;
 V_matrix = new int [ n  , e + 1   ]    ;
 for ( i = 0  ; i  < n ; i++   )
 for ( j = 0  ; j  < e + 1 ; j++   )
  {
   G[ i  , j   ] = 0  ;
 V_matrix[ i  , j   ] = 0  ;
 }

 
  for ( i = 0  ; i  < e ; i++   )
  {
   edge = (String)edges_names[ i   ]  ;
 v12[ 0   ] = edge.Substring( 0   , 2   )  ;
 v12[ 1   ] = edge.Substring( 2   , 2   )  ;
 for ( j = 0  ; j  < 2 ; j++   )
  {
   k = 0  ;
 while ( !v12[ j   ].Equals( (String)vertices[ k   ]   )   )
 k++  ;

  v12_int[ j   ] = k  ;
 }

  if ( v12_int[ 1   ]  < v12_int[ 0   ]  )
    {
   tmp = v12_int[ 0   ]  ;
 v12_int[ 0   ] = v12_int[ 1   ]  ;
 v12_int[ 1   ] = tmp  ;
 }

  for ( j = 0  ; j  < 2 ; j++   )
  {
   G[ v12_int[ j   ]  , G[ v12_int[ j   ]  , 0   ] + 1   ] = i  ;
 G[ v12_int[ j   ]  , 0   ]++  ;
 V_matrix[ v12_int[ j   ]  , V_matrix[ v12_int[ j   ]  , 0   ] + 1   ] = v12_int[ 1 - j   ]  ;
 V_matrix[ v12_int[ j   ]  , 0   ]++  ;
 vertex_degrees[ v12_int[ j   ]   ]++  ;
 }

  }

  }
  private class McsharpPrivateClassSearch {

   GracefulGraph parent;
   int current_label;
   int index_v;
   int[] VL;
   int[] EL;
   int[] elabels;
   int[,] G;
   int[,] V_matrix;
   int n;
   int e;
   channel  toSendResult;
   channel  toSendStop;

   public McsharpPrivateClassSearch ( GracefulGraph parent,
               int current_label,
               int index_v,
               int[] VL,
               int[] EL,
               int[] elabels,
               int[,] G,
               int[,] V_matrix,
               int n,
               int e,
               channel  toSendResult,
               channel  toSendStop
              ) {
    this.parent = parent;
    this.current_label = current_label;
    this.index_v = index_v;
    this.VL = VL;
    this.EL = EL;
    this.elabels = elabels;
    this.G = G;
    this.V_matrix = V_matrix;
    this.n = n;
    this.e = e;
    this.toSendResult = toSendResult;
    this.toSendStop = toSendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpSearchBody ( current_label, index_v, VL, EL, elabels, G, V_matrix, n, e, toSendResult, toSendStop );

   }
  }

  private void mcsharpSearchBody (
               int current_label,
               int index_v,
               int[] VL,
               int[] EL,
               int[] elabels,
               int[,] G,
               int[,] V_matrix,
               int n,
               int e,
               channel  toSendResult,
               channel  toSendStop
              )
 {
   int v ;

  int edge_index , edge , edge_label , vertex , vertex_label ;

  int i , j ;

  bool isDuplicateLabel ;

  int checked_vertex ;

  int m = 0  ;

  int m1 ;

  int[] result_VL = null  ;

  int[] copy_VL = new int [ n   ]    ;

  VL.CopyTo( copy_VL   , 0   )  ;
 int[] copy_EL = new int [ e   ]    ;

  EL.CopyTo( copy_EL   , 0   )  ;
 int[] copy_elabels = new int [ e + 1   ]    ;

  elabels.CopyTo( copy_elabels   , 0   )  ;
 while ( copy_elabels[ current_label   ]  != -1   )
 current_label--  ;

  bool success = false  ;

  if ( current_label  == 0   )
   success = true  ;

  else
  {
   v = index_v  ;
 edge_index = 0  ;
 while ( !success  && edge_index  < G[ v  , 0   ]  )
  {
   if ( copy_EL[ G[ v  , edge_index + 1   ]   ]  != 0   )
   edge_index++  ;

  else
  {
   edge = G[ v  , edge_index + 1   ]  ;
 vertex = V_matrix[ v  , edge_index + 1   ]  ;
 vertex_label = VL[ v   ] - current_label  ;
 if ( vertex_label  < 0  )
   vertex_label = VL[ v   ] + current_label  ;

  isDuplicateLabel = false  ;
 i = 0  ;
 while ( !isDuplicateLabel  && i  < n  )
 if ( copy_VL[ i   ]  == vertex_label   )
   isDuplicateLabel = true  ;

  else
 i++  ;
 

  if ( isDuplicateLabel   )
   edge_index++  ;

  else
  {
   copy_EL[ edge   ] = current_label  ;
 copy_elabels[ current_label   ] = edge  ;
 copy_VL[ vertex   ] = vertex_label  ;
 isDuplicateLabel = false  ;
 i = 0  ;
 while ( !isDuplicateLabel  && i  < G[ vertex  , 0   ]  )
  {
   checked_vertex = V_matrix[ vertex  , i + 1   ]  ;
 if ( copy_VL[ checked_vertex   ]  != -1  && copy_EL[ G[ vertex  , i + 1   ]   ]  == 0   )
    {
   edge_label = vertex_label - copy_VL[ checked_vertex   ]  ;
 if ( edge_label  < 0  )
   edge_label = -edge_label  ;

  if ( copy_elabels[ edge_label   ]  != -1   )
   isDuplicateLabel = true  ;

  else
  {
   copy_EL[ G[ vertex  , i + 1   ]   ] = edge_label  ;
 copy_elabels[ edge_label   ] = G[ vertex  , i + 1   ]  ;
 i++  ;
 }
 
 }

  else
 i++  ;
 
 }

  if ( isDuplicateLabel   )
    {
   for ( j = 0  ; j  < i ; j++   )
  {
   copy_elabels[ copy_EL[ G[ vertex  , j + 1   ]   ]   ] = -1  ;
 copy_EL[ G[ vertex  , j + 1   ]   ] = 0  ;
 }

  copy_EL[ edge   ] = 0  ;
 copy_elabels[ current_label   ] = -1  ;
 copy_VL[ vertex   ] = -1  ;
 edge_index++  ;
 }

  else
 if ( e - current_label  < THRESHOLD  )
    {
   m1 = 0  ;
 for ( i = 0  ; i  < n ; i++   )
 if ( copy_VL[ i   ]  != -1   )
    {
   m1++  ;
 new GracefulGraph ( ) .Search( current_label - 1   , i   , copy_VL   , copy_EL   , copy_elabels   , G   , V_matrix   , n   , e   , sendResult   , sendStop   )  ;
 }

 
  m = m + m1  ;
 i = 0  ;
 while ( !success  && i  < m1  )
  {
   result_VL = (int[])getResult  .Get(new object[]{ } )
;
 if ( result_VL[ 0   ]  == -1   )
   i++  ;

  else
 success = true  ;
 
 }

  if ( !success   )
   edge_index++  ;

  else
 result_VL.CopyTo( copy_VL   , 0   )  ;
 
 }

  else
  {
   success = local_Search( current_label - 1   , copy_VL   , copy_EL   , copy_elabels   , G   , V_matrix   , n   , e   )  ;
 if ( !success   )
    {
   for ( i = 0  ; i  < G[ vertex  , 0   ] ; i++   )
  {
   copy_elabels[ copy_EL[ G[ vertex  , i + 1   ]   ]   ] = -1  ;
 copy_EL[ G[ vertex  , i + 1   ]   ] = 0  ;
 }

  copy_VL[ vertex   ] = -1  ;
 edge_index++  ;
 }

  }
 
 
 }
 
 }
 
 }

  }
 
 if ( !success   )
   copy_VL[ 0   ] = -1  ;

  toSendResult.Send ( new object[] {  copy_VL    } )
  ;
 while ( contin   )
 Thread.Sleep( 10   )  ;

  for ( i = 0  ; i  < m ; i++   )
 getStop  .Get(new object[]{ } )
;

  toSendStop.Send ( new object[] {   } )
  ;
 }




  public  void Search (  int current_label,  int index_v,  int[] VL,  int[] EL,  int[] elabels,  int[,] G,  int[,] V_matrix,  int n,  int e,  channel  toSendResult,  channel  toSendStop ) {
   McsharpPrivateClassSearch prclassobject = new McsharpPrivateClassSearch ( this, current_label, index_v, VL, EL, elabels, G, V_matrix, n, e, toSendResult, toSendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public static  bool local_Search (  int current_label,  int[] VL,  int[] EL,  int[] elabels,  int[,] G,  int[,] V_matrix,  int n,  int e )   {
   bool success ;

  int v ;

  int edge_index , edge , edge_label , vertex , vertex_label ;

  int i , j ;

  bool isDuplicateLabel ;

  int checked_vertex ;

  while ( elabels[ current_label   ]  != -1   )
 current_label--  ;

  if ( current_label  == 0   )
   return ( true   )  ;
 
  success = false  ;
 v = 0  ;
 while ( v  < n && VL[ v   ]  == -1   )
 v++  ;

  while ( !success  && v  < n  )
  {
   edge_index = 0  ;
 while ( !success  && edge_index  < G[ v  , 0   ]  )
  {
   if ( EL[ G[ v  , edge_index + 1   ]   ]  != 0   )
   edge_index++  ;

  else
  {
   edge = G[ v  , edge_index + 1   ]  ;
 vertex = V_matrix[ v  , edge_index + 1   ]  ;
 vertex_label = VL[ v   ] - current_label  ;
 if ( vertex_label  < 0  )
   vertex_label = VL[ v   ] + current_label  ;

  isDuplicateLabel = false  ;
 i = 0  ;
 while ( !isDuplicateLabel  && i  < n  )
 if ( VL[ i   ]  == vertex_label   )
   isDuplicateLabel = true  ;

  else
 i++  ;
 

  if ( isDuplicateLabel   )
   edge_index++  ;

  else
  {
   EL[ edge   ] = current_label  ;
 elabels[ current_label   ] = edge  ;
 VL[ vertex   ] = vertex_label  ;
 isDuplicateLabel = false  ;
 i = 0  ;
 while ( !isDuplicateLabel  && i  < G[ vertex  , 0   ]  )
  {
   checked_vertex = V_matrix[ vertex  , i + 1   ]  ;
 if ( VL[ checked_vertex   ]  != -1  && EL[ G[ vertex  , i + 1   ]   ]  == 0   )
    {
   edge_label = vertex_label - VL[ checked_vertex   ]  ;
 if ( edge_label  < 0  )
   edge_label = -edge_label  ;

  if ( elabels[ edge_label   ]  != -1   )
   isDuplicateLabel = true  ;

  else
  {
   EL[ G[ vertex  , i + 1   ]   ] = edge_label  ;
 elabels[ edge_label   ] = G[ vertex  , i + 1   ]  ;
 i++  ;
 }
 
 }

  else
 i++  ;
 
 }

  if ( isDuplicateLabel   )
    {
   for ( j = 0  ; j  < i ; j++   )
  {
   elabels[ EL[ G[ vertex  , j + 1   ]   ]   ] = -1  ;
 EL[ G[ vertex  , j + 1   ]   ] = 0  ;
 }

  EL[ edge   ] = 0  ;
 elabels[ current_label   ] = -1  ;
 VL[ vertex   ] = -1  ;
 edge_index++  ;
 }

  else
  {
   success = local_Search( current_label - 1   , VL   , EL   , elabels   , G   , V_matrix   , n   , e   )  ;
 if ( !success   )
    {
   for ( i = 0  ; i  < G[ vertex  , 0   ] ; i++   )
  {
   elabels[ EL[ G[ vertex  , i + 1   ]   ]   ] = -1  ;
 EL[ G[ vertex  , i + 1   ]   ] = 0  ;
 }

  VL[ vertex   ] = -1  ;
 edge_index++  ;
 }

  }
 
 }
 
 }
 
 }

  if ( !success   )
    {
   v++  ;
 while ( v  < n && VL[ v   ]  == -1   )
 v++  ;

  }

  }

  return ( success   )  ;
  }
}

