using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;
using System.Text;
[Serializable()]
public  class Queens_and_Knights : ISerializable {

 //-------------- MCsharp functions -----------

 public Queens_and_Knights ( ) {
  mcsharp_initiate();
}

 public Queens_and_Knights ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendTask = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendTask" );
  mcsharpQueuegetTask = new MCSharp.ThreadQ();

  getTask = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetTask" );
  sendStart = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStart" );
  mcsharpQueuestartIteration = new MCSharp.ThreadQ();

  startIteration = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerstartIteration" );
  sendCount = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendCount" );
  mcsharpQueuegetCount = new MCSharp.ThreadQ();

  getCount = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetCount" );
  sendResult = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendResult" );
  mcsharpQueuegetResult = new MCSharp.ThreadQ();

  getResult = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetResult" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i ;

  int M ;

  int count = 0  ;

  int P = 1  ;

  DateTime dt1 = DateTime.Now  ;

  int N = Convert.ToInt32( args[ 0   ]   )  ;

  if ( args.Length  > 1  )
    {
   P = Convert.ToInt32( args[ 1   ]   )  ;
 }

  Queens_and_Knights qak = new Queens_and_Knights ( )   ;

  int[] vN = new int [ N   ]    ;

  for ( i = 0  ; i  < P ; i++   )
 qak.Worker( i   , N   , qak.getTask   , qak.startIteration   , qak.sendCount   , qak.sendResult   , P   )  ;

  int MASK = ( 1 << N  ) - 1  ;

  double maxM = N + 0.5 - 0.5 * Math.Sqrt( 4.0 * N + 9.0   )  ;

  M = (int)Math.Floor( maxM   )  ;
 int BOUND = 1  ;

  if ( N  > 4  )
   BOUND = 2  ;

  while ( count  == 0  && M  > 0  )
  {
   for ( i = 0  ; i  < P ; i++   )
 qak.sendStart.Send ( new object[] {  M    } )
  ;

  Backtrack( 0   , 0   , 0   , 0   , 0   , N   , M   , MASK   , BOUND   , vN   , qak.sendTask   )  ;
 for ( i = 0  ; i  < P ; i++   )
 qak.sendTask.Send ( new object[] {  -1   , -1   , -1   , -1   , -1   , vN   , N    } )
  ;

  for ( i = 0  ; i  < P ; i++   )
 count += (int)qak.getCount  .Get(new object[]{ } )
;

  M--  ;
 }

  for ( i = 0  ; i  < P ; i++   )
 qak.sendStart.Send ( new object[] {  0    } )
  ;

  FileStream fs_out = new FileStream ( "QNboard" + N + ".out"   , FileMode.Create   , FileAccess.Write   )   ;

  StreamWriter sw = new StreamWriter ( fs_out   )   ;

  sw.Write( "There are " + count + " possible board positions for " + ( M + 1   ) + " queens and knights on " + N + " X " + N + " board.\n\n"   )  ;
 for ( i = 0  ; i  < P ; i++   )
 sw.Write( qak.getResult  .Get(new object[]{ } )
 )  ;

  sw.Close( )  ;
 fs_out.Close( )  ;
 DateTime dt2 = DateTime.Now  ;

  Console.WriteLine( ( M + 1   ) + " queens and knights fit on a " + N + " X " + N + " board"   )  ;
 Console.WriteLine( count + " possible board positions are in QNboard" + N + ".out file"   )  ;
 Console.WriteLine( "Elapsed time = " + ( dt2 - dt1   ).TotalSeconds + " secs. "   )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendTask;

 //-------------Handler declaration-----------------

    public MCSharp.handler getTask;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetTask;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getTask = 1 << 0;
 private const int mcsharp_mask_sendTask = 1 << 1;
 private const int mcsharp_mask_getTasksendTask =
            mcsharp_mask_getTask
          | mcsharp_mask_sendTask;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetTasksendTask = new MCSharp.BitMask();

 private void scangetTasksendTask () {
  if ( mcsharpBitMaskgetTasksendTask.match
        ( mcsharp_mask_getTasksendTask ) )
   mcsharpQueuegetTask.wakeup();
 }


[OneWay]
public void mcsharpChannelsendTask (  int left,  int down,  int right,  int q,  int line,  int[] vN,  int N )  {
   lock ( mcsharpQueuegetTask ) {
    sendTask.Enqueue ( new object [] { left, down, right, q, line, vN, N } );
    if ( ! mcsharpBitMaskgetTasksendTask.match
          ( mcsharp_mask_sendTask ) )   {
     mcsharpBitMaskgetTasksendTask.set ( mcsharp_mask_sendTask );
     scangetTasksendTask ();
    }
   }
 }

 public void mcsharpHandlergetTask (  int[] task,  int[] vector )   {
  Monitor.Enter ( mcsharpQueuegetTask );
  if ( ! mcsharpBitMaskgetTasksendTask.match ( mcsharp_mask_getTask ) ) goto now;
  later:
   mcsharpQueuegetTask.yield ( mcsharpQueuegetTask );
   if ( mcsharpQueuegetTask.empty )
    mcsharpBitMaskgetTasksendTask.clear ( mcsharp_mask_getTask );
  now:
   if ( mcsharpBitMaskgetTasksendTask.match ( 
    mcsharp_mask_sendTask ) )   {
    object[] osendTask = ( object[] ) sendTask.Dequeue();
    int left = ( int ) osendTask [ 0 ];
    int down = ( int ) osendTask [ 1 ];
    int right = ( int ) osendTask [ 2 ];
    int q = ( int ) osendTask [ 3 ];
    int line = ( int ) osendTask [ 4 ];
    int[] vN = ( int[] ) osendTask [ 5 ];
    int N = ( int ) osendTask [ 6 ];
    if ( sendTask.Count == 0 )
         mcsharpBitMaskgetTasksendTask.clear ( mcsharp_mask_sendTask );
    scangetTasksendTask ();
    Monitor.Exit ( mcsharpQueuegetTask );
     {
   task[ 0   ] = left  ;
 task[ 1   ] = down  ;
 task[ 2   ] = right  ;
 task[ 3   ] = q  ;
 task[ 4   ] = line  ;
 for ( int i = 0  ;

  i  < N ; i++   )
 vector[ i   ] = vN[ i   ]  ;

  }
   }
   else {
    mcsharpBitMaskgetTasksendTask.set ( mcsharp_mask_getTask );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStart;

 //-------------Handler declaration-----------------

    public MCSharp.handler startIteration;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuestartIteration;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_startIteration = 1 << 0;
 private const int mcsharp_mask_sendStart = 1 << 1;
 private const int mcsharp_mask_startIterationsendStart =
            mcsharp_mask_startIteration
          | mcsharp_mask_sendStart;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskstartIterationsendStart = new MCSharp.BitMask();

 private void scanstartIterationsendStart () {
  if ( mcsharpBitMaskstartIterationsendStart.match
        ( mcsharp_mask_startIterationsendStart ) )
   mcsharpQueuestartIteration.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStart (  int x )  {
   lock ( mcsharpQueuestartIteration ) {
    sendStart.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskstartIterationsendStart.match
          ( mcsharp_mask_sendStart ) )   {
     mcsharpBitMaskstartIterationsendStart.set ( mcsharp_mask_sendStart );
     scanstartIterationsendStart ();
    }
   }
 }

 public int mcsharpHandlerstartIteration (  )   {
  Monitor.Enter ( mcsharpQueuestartIteration );
  if ( ! mcsharpBitMaskstartIterationsendStart.match ( mcsharp_mask_startIteration ) ) goto now;
  later:
   mcsharpQueuestartIteration.yield ( mcsharpQueuestartIteration );
   if ( mcsharpQueuestartIteration.empty )
    mcsharpBitMaskstartIterationsendStart.clear ( mcsharp_mask_startIteration );
  now:
   if ( mcsharpBitMaskstartIterationsendStart.match ( 
    mcsharp_mask_sendStart ) )   {
    object[] osendStart = ( object[] ) sendStart.Dequeue();
    int x = ( int ) osendStart [ 0 ];
    if ( sendStart.Count == 0 )
         mcsharpBitMaskstartIterationsendStart.clear ( mcsharp_mask_sendStart );
    scanstartIterationsendStart ();
    Monitor.Exit ( mcsharpQueuestartIteration );
     {
   return x  ;
  }
   }
   else {
    mcsharpBitMaskstartIterationsendStart.set ( mcsharp_mask_startIteration );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendCount;

 //-------------Handler declaration-----------------

    public MCSharp.handler getCount;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetCount;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getCount = 1 << 0;
 private const int mcsharp_mask_sendCount = 1 << 1;
 private const int mcsharp_mask_getCountsendCount =
            mcsharp_mask_getCount
          | mcsharp_mask_sendCount;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetCountsendCount = new MCSharp.BitMask();

 private void scangetCountsendCount () {
  if ( mcsharpBitMaskgetCountsendCount.match
        ( mcsharp_mask_getCountsendCount ) )
   mcsharpQueuegetCount.wakeup();
 }


[OneWay]
public void mcsharpChannelsendCount (  int count )  {
   lock ( mcsharpQueuegetCount ) {
    sendCount.Enqueue ( new object [] { count } );
    if ( ! mcsharpBitMaskgetCountsendCount.match
          ( mcsharp_mask_sendCount ) )   {
     mcsharpBitMaskgetCountsendCount.set ( mcsharp_mask_sendCount );
     scangetCountsendCount ();
    }
   }
 }

 public int mcsharpHandlergetCount (  )   {
  Monitor.Enter ( mcsharpQueuegetCount );
  if ( ! mcsharpBitMaskgetCountsendCount.match ( mcsharp_mask_getCount ) ) goto now;
  later:
   mcsharpQueuegetCount.yield ( mcsharpQueuegetCount );
   if ( mcsharpQueuegetCount.empty )
    mcsharpBitMaskgetCountsendCount.clear ( mcsharp_mask_getCount );
  now:
   if ( mcsharpBitMaskgetCountsendCount.match ( 
    mcsharp_mask_sendCount ) )   {
    object[] osendCount = ( object[] ) sendCount.Dequeue();
    int count = ( int ) osendCount [ 0 ];
    if ( sendCount.Count == 0 )
         mcsharpBitMaskgetCountsendCount.clear ( mcsharp_mask_sendCount );
    scangetCountsendCount ();
    Monitor.Exit ( mcsharpQueuegetCount );
     {
   return count  ;
  }
   }
   else {
    mcsharpBitMaskgetCountsendCount.set ( mcsharp_mask_getCount );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendResult;

 //-------------Handler declaration-----------------

    public MCSharp.handler getResult;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetResult;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getResult = 1 << 0;
 private const int mcsharp_mask_sendResult = 1 << 1;
 private const int mcsharp_mask_getResultsendResult =
            mcsharp_mask_getResult
          | mcsharp_mask_sendResult;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetResultsendResult = new MCSharp.BitMask();

 private void scangetResultsendResult () {
  if ( mcsharpBitMaskgetResultsendResult.match
        ( mcsharp_mask_getResultsendResult ) )
   mcsharpQueuegetResult.wakeup();
 }


[OneWay]
public void mcsharpChannelsendResult (  String s )  {
   lock ( mcsharpQueuegetResult ) {
    sendResult.Enqueue ( new object [] { s } );
    if ( ! mcsharpBitMaskgetResultsendResult.match
          ( mcsharp_mask_sendResult ) )   {
     mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_sendResult );
     scangetResultsendResult ();
    }
   }
 }

 public String mcsharpHandlergetResult (  )   {
  Monitor.Enter ( mcsharpQueuegetResult );
  if ( ! mcsharpBitMaskgetResultsendResult.match ( mcsharp_mask_getResult ) ) goto now;
  later:
   mcsharpQueuegetResult.yield ( mcsharpQueuegetResult );
   if ( mcsharpQueuegetResult.empty )
    mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_getResult );
  now:
   if ( mcsharpBitMaskgetResultsendResult.match ( 
    mcsharp_mask_sendResult ) )   {
    object[] osendResult = ( object[] ) sendResult.Dequeue();
    String s = ( String ) osendResult [ 0 ];
    if ( sendResult.Count == 0 )
         mcsharpBitMaskgetResultsendResult.clear ( mcsharp_mask_sendResult );
    scangetResultsendResult ();
    Monitor.Exit ( mcsharpQueuegetResult );
     {
   return s  ;
  }
   }
   else {
    mcsharpBitMaskgetResultsendResult.set ( mcsharp_mask_getResult );
    goto later;
  }

 }
public static  void Backtrack (  int q,  int line,  int left,  int down,  int right,  int N,  int M,  int MASK,  int BOUND,  int[] vN,  channel  sendTask )   {
   int bitmap , bit ;

  int[] vector ;

  int i ;

  if ( q  == BOUND   )
    {
   vector = new int [ N   ]    ;
 for ( i = 0  ; i  < N ; i++   )
 vector[ i   ] = vN[ i   ]  ;

  sendTask.Send ( new object[] {  left   , down   , right   , q   , line   , vector   , N    } )
  ;
 }

  else
 while ( line  < N - M + 1 + q  )
  {
   bitmap = MASK  & ~( left  | down  | right   )  ;
 while ( bitmap  != 0   )
  {
   bit = -bitmap  & bitmap  ;
 vN[ line   ] = bit  ;
 bitmap = bitmap  ^ bit  ;
 Backtrack( q + 1   , line + 1   , ( left  | bit   ) << 1  , down  | bit   , ( right  | bit   ) >> 1  , N   , M   , MASK   , BOUND   , vN   , sendTask   )  ;
 vN[ line   ] = 0  ;
 }

  line++  ;
 left = left << 1 ;
 right = right >> 1 ;
 }

  
 }
  private class McsharpPrivateClassWorker {

   Queens_and_Knights parent;
   int myNumber;
   int N;
   handler  getTask;
   handler  startIteration;
   channel  sendCount;
   channel  sendResult;
   int P;

   public McsharpPrivateClassWorker ( Queens_and_Knights parent,
               int myNumber,
               int N,
               handler  getTask,
               handler  startIteration,
               channel  sendCount,
               channel  sendResult,
               int P
              ) {
    this.parent = parent;
    this.myNumber = myNumber;
    this.N = N;
    this.getTask = getTask;
    this.startIteration = startIteration;
    this.sendCount = sendCount;
    this.sendResult = sendResult;
    this.P = P;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpWorkerBody ( myNumber, N, getTask, startIteration, sendCount, sendResult, P );

   }
  }

  private void mcsharpWorkerBody (
               int myNumber,
               int N,
               handler  getTask,
               handler  startIteration,
               channel  sendCount,
               channel  sendResult,
               int P
              )
 {
   int count ;

  int[] task = new int [ 5   ]    ;

  int M ;

  int[,] board = new int [ N  , N   ]    ;

  int[] vector = new int [ N   ]    ;

  int[,] vectors = new int [ 8  , N   ]    ;

  int[,] knights = new int [ N  , 2   ]    ;

  int[,] kplaces = new int [ N * N  , 2   ]    ;

  int[] nv1 = new int [ N   ]    ;

  int[] nv2 = new int [ N   ]    ;

  int[] nv3 = new int [ N   ]    ;

  int[] symmetries = new int [ 8   ]    ;

  int MASK = ( 1 << N  ) - 1  ;

  StringBuilder sb ;

  if ( N  <= 10  )
   sb = new StringBuilder ( 20000 / P   )   ;

  else
 sb = new StringBuilder ( 64000000 / P   )   ;
 
 M = (int)startIteration  .Get(new object[]{ } )
;
 while ( M  > 0  )
  {
   count = 0  ;
 getTask  .Get(new object[]{ task   , vector   } )
;
 while ( task[ 0   ]  != -1   )
  {
   Backtrack_Queens( ref count   , task[ 3   ]   , task[ 4   ]   , task[ 0   ]   , task[ 1   ]   , task[ 2   ]   , board   , vector   , knights   , kplaces   , N   , M   , MASK   , nv1   , nv2   , nv3   , symmetries   , sb   , vectors   )  ;
 getTask  .Get(new object[]{ task   , vector   } )
;
 }

  sendCount.Send ( new object[] {  count    } )
  ;
 M = (int)startIteration  .Get(new object[]{ } )
;
 }

  sendResult.Send ( new object[] {  sb.ToString( )    } )
  ;
 }




  public  void Worker (  int myNumber,  int N,  handler  getTask,  handler  startIteration,  channel  sendCount,  channel  sendResult,  int P ) {
   McsharpPrivateClassWorker prclassobject = new McsharpPrivateClassWorker ( this, myNumber, N, getTask, startIteration, sendCount, sendResult, P );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public static  void Backtrack_Queens ( ref  int count,  int q,  int line,  int left,  int down,  int right,  int[,] board,  int[] vector,  int[,] knights,  int[,] kplaces,  int N,  int M,  int MASK,  int[] nv1,  int[] nv2,  int[] nv3,  int[] symmetries,  StringBuilder sb,  int[,] vectors )   {
   int k , l ;

  int kcount ;

  int bitmap , bit ;

  bool isMin ;

  if ( q  == M   )
    {
   isMin = isMinimal( vector   , nv1   , nv2   , nv3   , N   , N - 1   , ( N % 2  == 0   )   ? N / 2   : N / 2 + 1    )  ;
 if ( isMin   )
    {
   fillSymmetries( vector   , vectors   , symmetries   , N   , N - 1   , nv1   , nv2   )  ;
 buildBoard( vector   , board   , N   )  ;
 kcount = 0  ;
 for ( k = 0  ; k  < N ; k++   )
 for ( l = 0  ; l  < N ; l++   )
 if ( board[ k  , l   ]  == 0   )
   if ( isAcceptable( k   , l   , board   , N   )   )
    {
   kplaces[ kcount  , 0   ] = k  ;
 kplaces[ kcount  , 1   ] = l  ;
 kcount++  ;
 }

  else
 board[ k  , l   ] = 10000  ;
 

 
 
  if ( kcount  >= M  )
   Backtrack_Knights( ref count   , 0   , 0   , kplaces   , kcount   , board   , knights   , N   , M   , sb   , symmetries   )  ;

  }

  }

  else
 while ( line  < N - M + 1 + q  )
  {
   bitmap = MASK  & ~( left  | down  | right   )  ;
 while ( bitmap  != 0   )
  {
   bit = -bitmap  & bitmap  ;
 vector[ line   ] = bit  ;
 bitmap = bitmap  ^ bit  ;
 Backtrack_Queens( ref count   , q + 1   , line + 1   , ( left  | bit   ) << 1  , down  | bit   , ( right  | bit   ) >> 1  , board   , vector   , knights   , kplaces   , N   , M   , MASK   , nv1   , nv2   , nv3   , symmetries   , sb   , vectors   )  ;
 vector[ line   ] = 0  ;
 }

  line++  ;
 left = left << 1 ;
 right = right >> 1 ;
 }

  
 }
public static  bool isMinimal (  int[] v,  int[] nv1,  int[] nv2,  int[] nv3,  int N,  int N1,  int N2 )   {
   int i ;

  for ( i = 0  ; i  < N2 && v[ i   ]  == v[ N1 - i   ]  ; i++   )
 ;

  if ( i  < N2 && v[ N1 - i   ]  > v[ i   ]  )
   return false  ;
 
  rotation90( v   , nv1   , N   )  ;
 for ( i = 0  ; i  < N && v[ i   ]  == nv1[ i   ]  ; i++   )
 ;

  if ( i  != N  && nv1[ i   ]  > v[ i   ]  )
   return false  ;
 
  for ( i = 0  ; i  < N2 && v[ i   ]  == nv1[ N1 - i   ]  ; i++   )
 ;

  if ( i  < N2 && nv1[ N1 - i   ]  > v[ i   ]  )
   return false  ;
 
  rotation90( nv1   , nv2   , N   )  ;
 for ( i = 0  ; i  < N && v[ i   ]  == nv2[ i   ]  ; i++   )
 ;

  if ( i  != N  && nv2[ i   ]  > v[ i   ]  )
   return false  ;
 
  for ( i = 0  ; i  < N2 && v[ i   ]  == nv2[ N1 - i   ]  ; i++   )
 ;

  if ( i  < N2 && nv2[ N1 - i   ]  > v[ i   ]  )
   return false  ;
 
  rotation90( nv2   , nv3   , N   )  ;
 for ( i = 0  ; i  < N && v[ i   ]  == nv3[ i   ]  ; i++   )
 ;

  if ( i  != N  && nv3[ i   ]  > v[ i   ]  )
   return false  ;
 
  for ( i = 0  ; i  < N2 && v[ i   ]  == nv3[ N1 - i   ]  ; i++   )
 ;

  if ( i  < N2 && nv3[ N1 - i   ]  > v[ i   ]  )
   return false  ;
 
  return true  ;
  }
public static  void fillSymmetries (  int[] v,  int[,] vectors,  int[] symmetries,  int N,  int N1,  int[] nv1,  int[] nv2 )   {
   int i ;

  for ( i = 0  ; i  < N ; i++   )
 vectors[ 0  , i   ] = v[ i   ]  ;

  int count = 1  ;

  for ( i = 0  ; i  < N ; i++   )
 nv1[ i   ] = v[ N1 - i   ]  ;

  symmetries[ 1   ] = check( nv1   , vectors   , ref count   , N   )  ;
 rotation90( v   , nv1   , N   )  ;
 symmetries[ 2   ] = check( nv1   , vectors   , ref count   , N   )  ;
 for ( i = 0  ; i  < N ; i++   )
 nv2[ i   ] = nv1[ N1 - i   ]  ;

  symmetries[ 3   ] = check( nv2   , vectors   , ref count   , N   )  ;
 rotation90( nv1   , nv2   , N   )  ;
 symmetries[ 4   ] = check( nv2   , vectors   , ref count   , N   )  ;
 for ( i = 0  ; i  < N ; i++   )
 nv1[ i   ] = nv2[ N1 - i   ]  ;

  symmetries[ 5   ] = check( nv1   , vectors   , ref count   , N   )  ;
 rotation90( nv2   , nv1   , N   )  ;
 symmetries[ 6   ] = check( nv1   , vectors   , ref count   , N   )  ;
 for ( i = 0  ; i  < N ; i++   )
 nv2[ i   ] = nv1[ N1 - i   ]  ;

  symmetries[ 7   ] = check( nv2   , vectors   , ref count   , N   )  ;
 }
public static  int check (  int[] v,  int[,] vs, ref  int count,  int N )   {
   int i , j , result ;

  result = 1  ;
 for ( i = 0  ; i  < count && result  != 0  ; i++   )
  {
   for ( j = 0  ; j  < N && v[ j   ]  == vs[ i  , j   ]  ; j++   )
 ;

  if ( j  == N   )
   result = 0  ;

  }

  if ( result  == 1   )
    {
   for ( i = 0  ; i  < N ; i++   )
 vs[ count  , i   ] = v[ i   ]  ;

  count++  ;
 }

  return result  ;
  }
public static  void buildBoard (  int[] vector,  int[,] board,  int N )   {
   int i , j ;

  int x , y ;

  for ( i = 0  ; i  < N ; i++   )
 for ( j = 0  ; j  < N ; j++   )
 board[ i  , j   ] = 0  ;

 
  for ( x = 0  ; x  < N ; x++   )
 if ( vector[ x   ]  > 0  )
    {
   y = (int)Math.Round( Math.Log( vector[ x   ]   , 2   )   )  ;
 board[ x  , y   ] = 1000  ;
 for ( i = x + 1  ; i  < N ; i++   )
 board[ i  , y   ]++  ;

  i = x + 1  ;
 j = y - 1  ;
 while ( i  < N && j  >= 0  )
  {
   board[ i  , j   ]++  ;
 i++  ;
 j--  ;
 }

  i = x + 1  ;
 j = y + 1  ;
 while ( i  < N && j  < N  )
  {
   board[ i  , j   ]++  ;
 i++  ;
 j++  ;
 }

  for ( j = 0  ; j  < y ; j++   )
 board[ x  , j   ]++  ;

  for ( j = y + 1  ; j  < N ; j++   )
 board[ x  , j   ]++  ;

  for ( i = 0  ; i  < x ; i++   )
 board[ i  , y   ]++  ;

  i = x - 1  ;
 j = y - 1  ;
 while ( i  >= 0 && j  >= 0  )
  {
   board[ i  , j   ]++  ;
 i--  ;
 j--  ;
 }

  i = x - 1  ;
 j = y + 1  ;
 while ( i  >= 0 && j  < N  )
  {
   board[ i  , j   ]++  ;
 i--  ;
 j++  ;
 }

  }

 
  }
public static  bool isAcceptable (  int i,  int j,  int[,] board,  int N )   {
   if ( i  < N - 1 && j  > 1 && board[ i + 1  , j - 2   ]  == 1000   )
   return false  ;
 
  if ( i  < N - 1 && j  < N - 2 && board[ i + 1  , j + 2   ]  == 1000   )
   return false  ;
 
  if ( i  < N - 2 && j  > 0 && board[ i + 2  , j - 1   ]  == 1000   )
   return false  ;
 
  if ( i  < N - 2 && j  < N - 1 && board[ i + 2  , j + 1   ]  == 1000   )
   return false  ;
 
  if ( i  > 0 && j  > 1 && board[ i - 1  , j - 2   ]  == 1000   )
   return false  ;
 
  if ( i  > 0 && j  < N - 2 && board[ i - 1  , j + 2   ]  == 1000   )
   return false  ;
 
  if ( i  > 1 && j  > 0 && board[ i - 2  , j - 1   ]  == 1000   )
   return false  ;
 
  if ( i  > 1 && j  < N - 1 && board[ i - 2  , j + 1   ]  == 1000   )
   return false  ;
 
  return true  ;
  }
public static  void Backtrack_Knights ( ref  int count,  int k,  int c,  int[,] kplaces,  int kcount,  int[,] board,  int[,] knights,  int N,  int M,  StringBuilder sb,  int[] symmetries )   {
   if ( k  == M   )
   outToBuffer( ref count   , sb   , board   , symmetries   , N   )  ;

  else
 while ( c  < kcount - M + 1 + k  )
 if ( board[ kplaces[ c  , 0   ]  , kplaces[ c  , 1   ]   ]  == 0   )
    {
   knights[ k  , 0   ] = kplaces[ c  , 0   ]  ;
 knights[ k  , 1   ] = kplaces[ c  , 1   ]  ;
 board[ kplaces[ c  , 0   ]  , kplaces[ c  , 1   ]   ] = 2000  ;
 updateForKnights( kplaces[ c  , 0   ]   , kplaces[ c  , 1   ]   , board   , N   )  ;
 Backtrack_Knights( ref count   , k + 1   , c + 1   , kplaces   , kcount   , board   , knights   , N   , M   , sb   , symmetries   )  ;
 restoreForKnights( kplaces[ c  , 0   ]   , kplaces[ c  , 1   ]   , board   , N   )  ;
 board[ kplaces[ c  , 0   ]  , kplaces[ c  , 1   ]   ] = 0  ;
 c++  ;
 }

  else
 c++  ;
 

  
 }
public static  void updateForKnights (  int i,  int j,  int[,] board,  int N )   {
   if ( i  < N - 1 && j  > 1 && board[ i + 1  , j - 2   ]  <= 0  )
   board[ i + 1  , j - 2   ] -= 1  ;

  if ( i  < N - 1 && j  < N - 2 && board[ i + 1  , j + 2   ]  <= 0  )
   board[ i + 1  , j + 2   ] -= 1  ;

  if ( i  < N - 2 && j  > 0 && board[ i + 2  , j - 1   ]  <= 0  )
   board[ i + 2  , j - 1   ] -= 1  ;

  if ( i  < N - 2 && j  < N - 1 && board[ i + 2  , j + 1   ]  <= 0  )
   board[ i + 2  , j + 1   ] -= 1  ;

  }
public static  void restoreForKnights (  int i,  int j,  int[,] board,  int N )   {
   if ( i  < N - 1 && j  > 1 && board[ i + 1  , j - 2   ]  < 0  )
   board[ i + 1  , j - 2   ] += 1  ;

  if ( i  < N - 1 && j  < N - 2 && board[ i + 1  , j + 2   ]  < 0  )
   board[ i + 1  , j + 2   ] += 1  ;

  if ( i  < N - 2 && j  > 0 && board[ i + 2  , j - 1   ]  < 0  )
   board[ i + 2  , j - 1   ] += 1  ;

  if ( i  < N - 2 && j  < N - 1 && board[ i + 2  , j + 1   ]  < 0  )
   board[ i + 2  , j + 1   ] += 1  ;

  }
public static  void rotation90 (  int[] v,  int[] nv,  int N )   {
   int value , new_value , p , new_p ;

  for ( int i = 0  ;

  i  < N ; i++   )
 nv[ i   ] = 0  ;

  for ( p = 0  , new_value = 1 << ( N - 1   ) ; p  < N ; p++  , new_value = new_value >> 1  )
 if ( v[ p   ]  != 0   )
    {
   new_p = 0  ;
 value = 1  ;
 while ( value  != v[ p   ]   )
  {
   value = value << 1 ;
 new_p++  ;
 }

  nv[ new_p   ] = new_value  ;
 }

 
  }
public static  void outToBuffer ( ref  int count,  StringBuilder sb,  int[,] board,  int[] symmetries,  int N )   {
   int i , j ;

  for ( i = 0  ; i  < N ; i++   )
  {
   for ( j = 0  ; j  < N ; j++   )
  {
   if ( board[ i  , j   ]  == 1000   )
   sb.Append( "Q"   )  ;

  else
 if ( board[ i  , j   ]  == 2000   )
   sb.Append( "N"   )  ;

  else
 sb.Append( "."   )  ;
 
 
 }

  sb.Append( "\n"   )  ;
 }

  sb.Append( "\n"   )  ;
 count++  ;
 if ( symmetries[ 1   ]  == 1   )
    {
   for ( i = N - 1  ; i  >= 0 ; i--   )
  {
   for ( j = 0  ; j  < N ; j++   )
  {
   if ( board[ i  , j   ]  == 1000   )
   sb.Append( "Q"   )  ;

  else
 if ( board[ i  , j   ]  == 2000   )
   sb.Append( "N"   )  ;

  else
 sb.Append( "."   )  ;
 
 
 }

  sb.Append( "\n"   )  ;
 }

  sb.Append( "\n"   )  ;
 count++  ;
 }

  if ( symmetries[ 2   ]  == 1   )
    {
   for ( j = N - 1  ; j  >= 0 ; j--   )
  {
   for ( i = 0  ; i  < N ; i++   )
  {
   if ( board[ i  , j   ]  == 1000   )
   sb.Append( "Q"   )  ;

  else
 if ( board[ i  , j   ]  == 2000   )
   sb.Append( "N"   )  ;

  else
 sb.Append( "."   )  ;
 
 
 }

  sb.Append( "\n"   )  ;
 }

  sb.Append( "\n"   )  ;
 count++  ;
 }

  if ( symmetries[ 3   ]  == 1   )
    {
   for ( j = 0  ; j  < N ; j++   )
  {
   for ( i = 0  ; i  < N ; i++   )
  {
   if ( board[ i  , j   ]  == 1000   )
   sb.Append( "Q"   )  ;

  else
 if ( board[ i  , j   ]  == 2000   )
   sb.Append( "N"   )  ;

  else
 sb.Append( "."   )  ;
 
 
 }

  sb.Append( "\n"   )  ;
 }

  sb.Append( "\n"   )  ;
 count++  ;
 }

  if ( symmetries[ 4   ]  == 1   )
    {
   for ( i = N - 1  ; i  >= 0 ; i--   )
  {
   for ( j = N - 1  ; j  >= 0 ; j--   )
  {
   if ( board[ i  , j   ]  == 1000   )
   sb.Append( "Q"   )  ;

  else
 if ( board[ i  , j   ]  == 2000   )
   sb.Append( "N"   )  ;

  else
 sb.Append( "."   )  ;
 
 
 }

  sb.Append( "\n"   )  ;
 }

  sb.Append( "\n"   )  ;
 count++  ;
 }

  if ( symmetries[ 5   ]  == 1   )
    {
   for ( i = 0  ; i  < N ; i++   )
  {
   for ( j = N - 1  ; j  >= 0 ; j--   )
  {
   if ( board[ i  , j   ]  == 1000   )
   sb.Append( "Q"   )  ;

  else
 if ( board[ i  , j   ]  == 2000   )
   sb.Append( "N"   )  ;

  else
 sb.Append( "."   )  ;
 
 
 }

  sb.Append( "\n"   )  ;
 }

  sb.Append( "\n"   )  ;
 count++  ;
 }

  if ( symmetries[ 6   ]  == 1   )
    {
   for ( j = 0  ; j  < N ; j++   )
  {
   for ( i = N - 1  ; i  >= 0 ; i--   )
  {
   if ( board[ i  , j   ]  == 1000   )
   sb.Append( "Q"   )  ;

  else
 if ( board[ i  , j   ]  == 2000   )
   sb.Append( "N"   )  ;

  else
 sb.Append( "."   )  ;
 
 
 }

  sb.Append( "\n"   )  ;
 }

  sb.Append( "\n"   )  ;
 count++  ;
 }

  if ( symmetries[ 7   ]  == 1   )
    {
   for ( j = N - 1  ; j  >= 0 ; j--   )
  {
   for ( i = N - 1  ; i  >= 0 ; i--   )
  {
   if ( board[ i  , j   ]  == 1000   )
   sb.Append( "Q"   )  ;

  else
 if ( board[ i  , j   ]  == 2000   )
   sb.Append( "N"   )  ;

  else
 sb.Append( "."   )  ;
 
 
 }

  sb.Append( "\n"   )  ;
 }

  sb.Append( "\n"   )  ;
 count++  ;
 }

  }
}

