using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;
[Serializable()]
public  class Quicksort : ISerializable {

 //-------------- MCsharp functions -----------

 public Quicksort ( ) {
  mcsharp_initiate();
}

 public Quicksort ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i ;

  int P = 1  ;

  if ( args.Length  < 2  )
    {
   Console.WriteLine( "Usage: Quicksort.exe <Number of threads/cores> <Input file name>"   )  ;
 return ;
  }

  P = System.Convert.ToInt32( args[ 0   ]   )  ;
 FileStream fs = new FileStream ( args[ 1   ]   , FileMode.Open   , FileAccess.Read   )   ;

  StreamReader sr = new StreamReader ( fs   )   ;

  int N = System.Convert.ToInt32( sr.ReadLine( )   )  ;

  Console.WriteLine( "N = " + N   )  ;
 int[] x = new int [ N   ]    ;

  DateTime dt1 = DateTime.Now  ;

  for ( i = 0  ; i  < N ; i++   )
 x[ i   ] = System.Convert.ToInt32( sr.ReadLine( )   )  ;

  DateTime dt2 = DateTime.Now  ;

  Console.WriteLine( "read_data: " + ( dt2 - dt1   ).TotalSeconds + " sec."   )  ;
 sr.Close( )  ;
 fs.Close( )  ;
 Quicksort qs = new Quicksort ( )   ;

  int THRESHOLD = N / ( 4 * P   )  ;

  dt1 = DateTime.Now  ;
 new QSort ( ) .quicksort( 0   , N - 1   , x   , qs.sendStop   , THRESHOLD   )  ;
 qs.getStop  .Get(new object[]{ } )
;
 dt2 = DateTime.Now  ;
 Console.WriteLine( N + " integers have been sorted in " + ( dt2 - dt1   ).TotalSeconds + " sec. in " + P + " thread(s)"   )  ;
 fs = new FileStream ( "Sorted.out"   , FileMode.Create   , FileAccess.Write   )   ;
 StreamWriter sw = new StreamWriter ( fs   )   ;

  dt1 = DateTime.Now  ;
 for ( i = 0  ; i  < N ; i++   )
 sw.WriteLine( x[ i   ]   )  ;

  dt2 = DateTime.Now  ;
 Console.WriteLine( "write_data: " + ( dt2 - dt1   ).TotalSeconds + " sec."   )  ;
 sw.Close( )  ;
 fs.Close( )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
}

[Serializable()]
public  class QSort : ISerializable {

 //-------------- MCsharp functions -----------

 public QSort ( ) {
  mcsharp_initiate();
}

 public QSort ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

  private class McsharpPrivateClassquicksort {

   QSort parent;
   int begin;
   int end;
   int[] x;
   channel  c;
   int THRESHOLD;

   public McsharpPrivateClassquicksort ( QSort parent,
               int begin,
               int end,
               int[] x,
               channel  c,
               int THRESHOLD
              ) {
    this.parent = parent;
    this.begin = begin;
    this.end = end;
    this.x = x;
    this.c = c;
    this.THRESHOLD = THRESHOLD;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpquicksortBody ( begin, end, x, c, THRESHOLD );

   }
  }

  private void mcsharpquicksortBody (
               int begin,
               int end,
               int[] x,
               channel  c,
               int THRESHOLD
              )
 {
   int k , l , tmp ;

  int pivot ;

  int i ;

  int lo = begin  ;

  int hi = end  ;

  int generatedSubtasks = 0  ;

  if ( begin  >= end  )
    {
   c.Send ( new object[] {   } )
  ;
 return ;
  }

  while ( hi - lo  > THRESHOLD  )
  {
   pivot = x[ lo   ]  ;
 k = lo + 1  ;
 l = hi  ;
 while ( x[ k   ]  <= pivot && k  < hi  )
 k++  ;

  while ( x[ l   ]  > pivot  )
 l--  ;

  while ( k  < l  )
  {
   tmp = x[ l   ]  ;
 x[ l   ] = x[ k   ]  ;
 x[ k   ] = tmp  ;
 do k++  ;
 
  while ( x[ k   ]  <= pivot  );
  do l--  ;
 
  while ( x[ l   ]  > pivot  );
  }

  tmp = x[ l   ]  ;
 x[ l   ] = x[ lo   ]  ;
 x[ lo   ] = tmp  ;
 if ( l - lo  < hi - l  )
    {
   new QSort ( ) .quicksort( lo   , l - 1   , x   , this .sendStop   , THRESHOLD   )  ;
 lo = l + 1  ;
 }

  else
  {
   new QSort ( ) .quicksort( l + 1   , hi   , x   , this .sendStop   , THRESHOLD   )  ;
 hi = l - 1  ;
 }
 
 generatedSubtasks++  ;
 }

  local_quicksort( lo   , hi   , x   )  ;
 for ( i = 0  ; i  < generatedSubtasks ; i++   )
 getStop  .Get(new object[]{ } )
;

  c.Send ( new object[] {   } )
  ;
 }




  public  void quicksort (  int begin,  int end,  int[] x,  channel  c,  int THRESHOLD ) {
   McsharpPrivateClassquicksort prclassobject = new McsharpPrivateClassquicksort ( this, begin, end, x, c, THRESHOLD );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
public static  void local_quicksort (  int begin,  int end,  int[] x )   {
   int k , l , tmp ;

  int pivot ;

  if ( begin  >= end  )
   return ;
 
  pivot = x[ begin   ]  ;
 k = begin + 1  ;
 l = end  ;
 while ( x[ k   ]  <= pivot && k  < end  )
 k++  ;

  while ( x[ l   ]  > pivot  )
 l--  ;

  while ( k  < l  )
  {
   tmp = x[ l   ]  ;
 x[ l   ] = x[ k   ]  ;
 x[ k   ] = tmp  ;
 do k++  ;
 
  while ( x[ k   ]  <= pivot  );
  do l--  ;
 
  while ( x[ l   ]  > pivot  );
  }

  tmp = x[ l   ]  ;
 x[ l   ] = x[ begin   ]  ;
 x[ begin   ] = tmp  ;
 local_quicksort( begin   , l - 1   , x   )  ;
 local_quicksort( l + 1   , end   , x   )  ;
 }
}

