using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;
using System.Collections;
[Serializable()]
public  class RoomAssignment : ISerializable {

 //-------------- MCsharp functions -----------

 public RoomAssignment ( ) {
  mcsharp_initiate();
}

 public RoomAssignment ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  int THRESHOLD ;

 public static  String[] names ;

 public static  int[,] disharmonies ;

 public static  int[,] assignments ;

 public static  float[] TDs ;

 public static  bool contin = true  ;

 public static  int number ;

 public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int P = 1  ;

  int time = 120  ;

  if ( args.Length  > 0  )
   P = System.Convert.ToInt32( args[ 0   ]   )  ;

  if ( args.Length  > 1  )
   time = System.Convert.ToInt32( args[ 1   ]   )  ;

  int N = InputDataFromFile( )  ;

  THRESHOLD = N * 200  ;
 assignments = new int [ P  , N   ]    ;
 TDs = new float [ P   ]    ;
 getInitialAssignments( P   , N   )  ;
 float first = EvaluateRooms( N   )  ;

  Console.WriteLine( "The initial Disharmony is " + first   )  ;
 DateTime dt1 = DateTime.Now  ;

  float final = ComputeRoomAssignments( N   , P   , time   )  ;

  DateTime dt2 = DateTime.Now  ;

  Console.WriteLine( "Time to compute room assignments is " + ( dt2 - dt1   ).TotalSeconds + " seconds"   )  ;
 Console.WriteLine( "Final Disharmony is " + final   )  ;
 PrintRoomAssignmentToFile( N   )  ;
 }
public static  float ComputeRoomAssignments (  int N,  int P,  int time )   {
   int i , j ;

  RoomAssignment ra = new RoomAssignment ( )   ;

  ra.Timer( time   , ra.sendStop   )  ;
 for ( i = 0  ; i  < P ; i++   )
 ra.Worker( i   , N   , ra.sendStop   )  ;

  i = 0  ;
 while ( contin  && i  < P  )
  {
   j = (int)ra.getStop  .Get(new object[]{ } )
;
 if ( j  == -1   )
   contin = false  ;

  else
 i++  ;
 
 }

  contin = false  ;
 for ( j = i  ; j  < P ; j++   )
 ra.getStop  .Get(new object[]{ } )
;

  float min_td = 999999.9F  ;

  number = -1  ;
 for ( i = 0  ; i  < P ; i++   )
 if ( TDs[ i   ]  < min_td  )
    {
   min_td = TDs[ i   ]  ;
 number = i  ;
 }

 
  return ( min_td   )  ;
  }
  private class McsharpPrivateClassTimer {

   RoomAssignment parent;
   int time;
   channel  sendStop;

   public McsharpPrivateClassTimer ( RoomAssignment parent,
               int time,
               channel  sendStop
              ) {
    this.parent = parent;
    this.time = time;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpTimerBody ( time, sendStop );

   }
  }

  private void mcsharpTimerBody (
               int time,
               channel  sendStop
              )
 {
   Thread.Sleep( time * 1000 - 500   )  ;
 sendStop.Send ( new object[] {  -1    } )
  ;
 }




  public  void Timer (  int time,  channel  sendStop ) {
   McsharpPrivateClassTimer prclassobject = new McsharpPrivateClassTimer ( this, time, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  int n )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] { n } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public int mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    int n = ( int ) osendStop [ 0 ];
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ( n   )  ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
  private class McsharpPrivateClassWorker {

   RoomAssignment parent;
   int ownNumber;
   int N;
   channel  sendStop;

   public McsharpPrivateClassWorker ( RoomAssignment parent,
               int ownNumber,
               int N,
               channel  sendStop
              ) {
    this.parent = parent;
    this.ownNumber = ownNumber;
    this.N = N;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpWorkerBody ( ownNumber, N, sendStop );

   }
  }

  private void mcsharpWorkerBody (
               int ownNumber,
               int N,
               channel  sendStop
              )
 {
   int i , j ;

  int ni , nj ;

  int ri , rj ;

  int neigh_i , neigh_j ;

  float d1 , d2 ;

  Random rnd = new Random ( )   ;

  float[] room_disharmonies = new float [ N / 2   ]    ;

  for ( i = 0  ; i  < N / 2 ; i++   )
 room_disharmonies[ i   ] = getPairDisharmony( assignments[ ownNumber  , 2 * i   ]   , assignments[ ownNumber  , 2 * i + 1   ]   )  ;

  TDs[ ownNumber   ] = 0.0F  ;
 for ( i = 0  ; i  < N / 2 ; i++   )
 TDs[ ownNumber   ] += room_disharmonies[ i   ]  ;

  int k = 0  ;

  while ( contin  && k  < THRESHOLD  )
  {
   i = rnd.Next( N   )  ;
 j = rnd.Next( N   )  ;
 ni = assignments[ ownNumber  , i   ]  ;
 nj = assignments[ ownNumber  , j   ]  ;
 ri = i / 2  ;
 rj = j / 2  ;
 if ( ri  != rj   )
    {
   if ( i % 2  == 0   )
   neigh_i = assignments[ ownNumber  , i + 1   ]  ;

  else
 neigh_i = assignments[ ownNumber  , i - 1   ]  ;
 
 if ( j % 2  == 0   )
   neigh_j = assignments[ ownNumber  , j + 1   ]  ;

  else
 neigh_j = assignments[ ownNumber  , j - 1   ]  ;
 
 d1 = getPairDisharmony( nj   , neigh_i   )  ;
 d2 = getPairDisharmony( ni   , neigh_j   )  ;
 if ( d1 + d2  < room_disharmonies[ ri   ] + room_disharmonies[ rj   ]  )
    {
   k = 0  ;
 assignments[ ownNumber  , i   ] = nj  ;
 assignments[ ownNumber  , j   ] = ni  ;
 TDs[ ownNumber   ] += d1 + d2 - room_disharmonies[ ri   ] - room_disharmonies[ rj   ]  ;
 room_disharmonies[ ri   ] = d1  ;
 room_disharmonies[ rj   ] = d2  ;
 }

  else
 k++  ;
 
 }

  }

  sendStop.Send ( new object[] {  0    } )
  ;
 }




  public  void Worker (  int ownNumber,  int N,  channel  sendStop ) {
   McsharpPrivateClassWorker prclassobject = new McsharpPrivateClassWorker ( this, ownNumber, N, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public static  void getInitialAssignments (  int P,  int N )   {
   int i , j , n ;

  for ( i = 0  ; i  < N ; i++   )
 assignments[ 0  , i   ] = i  ;

  Random rnd = new Random ( )   ;

  ArrayList list = new ArrayList ( )   ;

  for ( i = 1  ; i  < P ; i++   )
  {
   for ( j = 0  ; j  < N ; j++   )
 list.Add( j   )  ;

  for ( j = 0  ; j  < N ; j++   )
  {
   n = rnd.Next( N - j   )  ;
 assignments[ i  , j   ] = (int)list[ n   ]  ;
 list.RemoveAt( n   )  ;
 }

  }

  }
public static  float getPairDisharmony (  int i,  int j )   {
   int d = 0  ;

  for ( int k = 0  ;

  k  < 50 ; k++   )
 if ( disharmonies[ i  , k   ]  < disharmonies[ j  , k   ]  )
   d += disharmonies[ j  , k   ] - disharmonies[ i  , k   ]  ;

  else
 d += disharmonies[ i  , k   ] - disharmonies[ j  , k   ]  ;
 

  return ( d / 200.0F   )  ;
  }
public static  int InputDataFromFile (  )   {
   String s ;

  FileStream fs = new FileStream ( "Students.in"   , FileMode.Open   , FileAccess.Read   )   ;

  StreamReader sr = new StreamReader ( fs   )   ;

  int N = System.Convert.ToInt32( sr.ReadLine( )   )  ;

  Console.WriteLine( "N = " + N   )  ;
 names = new String [ N   ]    ;
 disharmonies = new int [ N  , 50   ]    ;
 for ( int i = 0  ;

  i  < N ; i++   )
  {
   s = sr.ReadLine( )  ;
 names[ i   ] = s.Substring( 0   , 10   )  ;
 for ( int j = 0  ;

  j  < 50 ; j++   )
 disharmonies[ i  , j   ] = System.Convert.ToInt32( s.Substring( 11 + j   , 1   )   )  ;

  }

  sr.Close( )  ;
 fs.Close( )  ;
 return ( N   )  ;
  }
public static  float EvaluateRooms (  int N )   {
   float result = 0.0F  ;

  for ( int i = 0  ;

  i  < N / 2 ; i++   )
 result += getPairDisharmony( assignments[ 0  , 2 * i   ]   , assignments[ 0  , 2 * i + 1   ]   )  ;

  return ( result   )  ;
  }
public static  void PrintRoomAssignmentToFile (  int N )   {
   FileStream fs = new FileStream ( "Assignments.out"   , FileMode.Create   , FileAccess.Write   )   ;

  StreamWriter sw = new StreamWriter ( fs   )   ;

  for ( int i = 0  ;

  i  < N ; i++   )
  {
   if ( i % 2  == 0   )
   sw.WriteLine( )  ;

  sw.WriteLine( names[ assignments[ number  , i   ]   ]   )  ;
 }

  sw.Close( )  ;
 fs.Close( )  ;
 }
}

