using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;
[Serializable()]
public  class Communicator : ISerializable {

 //-------------- MCsharp functions -----------

 public Communicator ( ) {
  mcsharp_initiate();
}

 public Communicator ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  Send = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelSend" );
  mcsharpQueueReceive = new MCSharp.ThreadQ();

  Receive = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerReceive" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel Send;

 //-------------Handler declaration-----------------

    public MCSharp.handler Receive;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueReceive;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Receive = 1 << 0;
 private const int mcsharp_mask_Send = 1 << 1;
 private const int mcsharp_mask_ReceiveSend =
            mcsharp_mask_Receive
          | mcsharp_mask_Send;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskReceiveSend = new MCSharp.BitMask();

 private void scanReceiveSend () {
  if ( mcsharpBitMaskReceiveSend.match
        ( mcsharp_mask_ReceiveSend ) )
   mcsharpQueueReceive.wakeup();
 }


[OneWay]
public void mcsharpChannelSend (  )  {
   lock ( mcsharpQueueReceive ) {
    Send.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskReceiveSend.match
          ( mcsharp_mask_Send ) )   {
     mcsharpBitMaskReceiveSend.set ( mcsharp_mask_Send );
     scanReceiveSend ();
    }
   }
 }

 public void mcsharpHandlerReceive (  )   {
  Monitor.Enter ( mcsharpQueueReceive );
  if ( ! mcsharpBitMaskReceiveSend.match ( mcsharp_mask_Receive ) ) goto now;
  later:
   mcsharpQueueReceive.yield ( mcsharpQueueReceive );
   if ( mcsharpQueueReceive.empty )
    mcsharpBitMaskReceiveSend.clear ( mcsharp_mask_Receive );
  now:
   if ( mcsharpBitMaskReceiveSend.match ( 
    mcsharp_mask_Send ) )   {
    object[] oSend = ( object[] ) Send.Dequeue();
    if ( Send.Count == 0 )
         mcsharpBitMaskReceiveSend.clear ( mcsharp_mask_Send );
    scanReceiveSend ();
    Monitor.Exit ( mcsharpQueueReceive );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskReceiveSend.set ( mcsharp_mask_Receive );
    goto later;
  }

 }
}

[Serializable()]
public  class SearchTrees : ISerializable {

 //-------------- MCsharp functions -----------

 public SearchTrees ( ) {
  mcsharp_initiate();
}

 public SearchTrees ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i , j ;

  String str ;

  String[] tokens ;

  Communicator[] comms ;

  bool contin ;

  int count ;

  float probab ;

  int P = 1  ;

  if ( args.Length  < 2  )
    {
   Console.WriteLine( "More parameteres needed ..."   )  ;
 return ;
  }

  if ( args.Length  > 2  )
   P = Convert.ToInt32( args[ 2   ]   )  ;

  DateTime dt1 = DateTime.Now  ;

  String file_name = args[ 0   ]  ;

  FileStream fs = new FileStream ( file_name   , FileMode.Open   , FileAccess.Read   )   ;

  StreamReader sr = new StreamReader ( fs   )   ;

  int n = System.Convert.ToInt32( sr.ReadLine( )   )  ;

  Console.WriteLine( "n = " + n   )  ;
 int[] n_searches = new int [ n   ]    ;

  float[] p = new float [ n   ]    ;

  String[] keys = new String [ n   ]    ;

  long sum = 0  ;

  for ( i = 0  ; i  < n ; i++   )
  {
   str = sr.ReadLine( )  ;
 tokens = str.Split( ' '   )  ;
 keys[ i   ] = tokens[ 0   ]  ;
 n_searches[ i   ] = Convert.ToInt32( tokens[ 1   ]   )  ;
 sum += n_searches[ i   ]  ;
 }

  sr.Close( )  ;
 fs.Close( )  ;
 for ( i = 0  ; i  < n ; i++   )
 p[ i   ] = ( (float)n_searches[ i   ]   ) / sum  ;

  float[,] cost = new float [ n + 1  , n + 1   ]    ;

  int[,] root = new int [ n + 1  , n + 1   ]    ;

  for ( j = n - 1  ; j  >= 0 ; j--   )
  {
   probab = (float)n_searches[ j   ] / sum  ;
 for ( i = j + 1  ; i  <= n ; i++   )
 cost[ i  , j   ] = cost[ i  , j + 1   ] + probab  ;

  root[ j  , j   ] = j  ;
 }

  comms = new Communicator [ P   ]    ;
 for ( i = 0  ; i  < P ; i++   )
 comms[ i   ] = new Communicator ( )   ;

  SearchTrees sts = new SearchTrees ( )   ;

  for ( i = 0  ; i  < P ; i++   )
 sts.Worker( i   , n   , P   , comms   , p   , cost   , root   , sts.sendStop   )  ;

  for ( i = 1  ; i  < n + 1 ; i++   )
  {
   for ( j = 0  ; j  < P ; j++   )
 sts.getStop  .Get(new object[]{ } )
;

  for ( j = 0  ; j  < P ; j++   )
 comms[ j   ].Send.Send ( new object[] {   } )
  ;

  }

  DateTime dt2 = DateTime.Now  ;

  Console.WriteLine( "Elapsed time = " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 file_name = args[ 1   ]  ;
 fs = new FileStream ( file_name   , FileMode.Open   , FileAccess.Read   )   ;
 sr = new StreamReader ( fs   )   ;
 str = sr.ReadLine( )  ;
 while ( str  != null  && str.Length  != 0   )
  {
   contin = true  ;
 i = 0  ;
 while ( contin  && i  < n  )
 if ( str.Equals( keys[ i   ]   )   )
   contin = false  ;

  else
 i++  ;
 

  if ( i  < n  )
    {
   count = 1  ;
 search( i   , ref count   , 0   , n - 1   , root   )  ;
 Console.WriteLine( keys[ i   ] + "   " + count + " nodes"   )  ;
 }

  else
 Console.WriteLine( str + "   0 nodes"   )  ;
 
 str = sr.ReadLine( )  ;
 }

  sr.Close( )  ;
 fs.Close( )  ;
 }
public static  void search (  int key, ref  int count,  int low,  int high,  int[,] root )   {
   int r = root[ low  , high + 1   ]  ;

  if ( key  == r   )
   return ;
 
  else
  {
   count++  ;
 if ( key  < r  )
   search( key   , ref count   , low   , r - 1   , root   )  ;

  else
 search( key   , ref count   , r + 1   , high   , root   )  ;
 
 }
 
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
  private class McsharpPrivateClassWorker {

   SearchTrees parent;
   int myNumber;
   int n;
   int P;
   Communicator[] comms;
   float[] p;
   float[,] cost;
   int[,] root;
   channel  sendStop;

   public McsharpPrivateClassWorker ( SearchTrees parent,
               int myNumber,
               int n,
               int P,
               Communicator[] comms,
               float[] p,
               float[,] cost,
               int[,] root,
               channel  sendStop
              ) {
    this.parent = parent;
    this.myNumber = myNumber;
    this.n = n;
    this.P = P;
    this.comms = comms;
    this.p = p;
    this.cost = cost;
    this.root = root;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpWorkerBody ( myNumber, n, P, comms, p, cost, root, sendStop );

   }
  }

  private void mcsharpWorkerBody (
               int myNumber,
               int n,
               int P,
               Communicator[] comms,
               float[] p,
               float[,] cost,
               int[,] root,
               channel  sendStop
              )
 {
   int i , j , k , size , q , r ;

  int from_ , to ;

  int low , high ;

  float rcost , bestcost ;

  int bestroot = 0  ;

  for ( i = 1  ; i  < n + 1 ; i++   )
  {
   size = n + 1 - i  ;
 q = size / P  ;
 r = size % P  ;
 if ( myNumber  < r  )
    {
   from_ = myNumber * ( q + 1   )  ;
 to = from_ + q + 1  ;
 }

  else
  {
   from_ = r * ( q + 1   ) + ( myNumber - r   ) * q  ;
 to = from_ + q  ;
 }
 
 low = from_  ;
 high = low + i  ;
 for ( j = from_  ; j  < to ; j++   )
  {
   bestcost = Single.MaxValue  ;
 if ( low  == n - 1  && high  == n   )
    {
   bestcost = cost[ low  , low   ] + cost[ low + 1  , high   ]  ;
 bestroot = low  ;
 }

  else
 for ( k = root[ low  , high - 1   ]  ; k  <= root[ low + 1  , high   ] ; k++   )
  {
   rcost = cost[ low  , k   ] + cost[ k + 1  , high   ]  ;
 if ( rcost  < bestcost  )
    {
   bestcost = rcost  ;
 bestroot = k  ;
 }

  }

  
 cost[ low  , high   ] = bestcost + cost[ high  , low   ]  ;
 root[ low  , high   ] = bestroot  ;
 low++  ;
 high++  ;
 }

  sendStop.Send ( new object[] {   } )
  ;
 comms[ myNumber   ].Receive  .Get(new object[]{ } )
;
 }

  }




  public  void Worker (  int myNumber,  int n,  int P,  Communicator[] comms,  float[] p,  float[,] cost,  int[,] root,  channel  sendStop ) {
   McsharpPrivateClassWorker prclassobject = new McsharpPrivateClassWorker ( this, myNumber, n, P, comms, p, cost, root, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

