using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.IO;
using System.Collections;
[Serializable()]
public  class Triple : ISerializable {

 //-------------- MCsharp functions -----------

 public Triple ( ) {
  mcsharp_initiate();
}

 public Triple ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public  int v ;

 public  int i ;

 public  int j ;

 public  Triple (  int v,  int i,  int j )  {

   mcsharp_initiate();

    this .v = v  ;
 this .i = i  ;
 this .j = j  ;


 }

}

[Serializable()]
public  class Parallel_ShortestPath : ISerializable {

 //-------------- MCsharp functions -----------

 public Parallel_ShortestPath ( ) {
  mcsharp_initiate();
}

 public Parallel_ShortestPath ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i , j ;

  String str ;

  int count ;

  String[] tokens ;

  String[] names ;

  DateTime dt0 , dt1 , dt2 ;

  String file_name = null  ;

  int P = 1  ;

  int[,] w ;

  int[] degrees ;

  int[,] edges ;

  int[,] SP ;

  dt0 = DateTime.Now  ;
 if ( args.Length  > 0  )
   file_name = args[ 0   ]  ;

  else
  {
   Console.WriteLine( "Usage: ShortestPath  <file-name> [<number-of-threads/cores>]"   )  ;
 return ;
  }
 
 if ( args.Length  > 1  )
   P = Convert.ToInt32( args[ 1   ]   )  ;

  FileStream fs = new FileStream ( file_name   , FileMode.Open   , FileAccess.Read   )   ;

  StreamReader sr = new StreamReader ( fs   )   ;

  dt1 = DateTime.Now  ;
 int _n = System.Convert.ToInt32( sr.ReadLine( )   )  ;

  Console.WriteLine( "Number of nodes = " + _n   )  ;
 w = new int [ _n  , _n   ]    ;
 for ( i = 0  ; i  < _n ; i++   )
 for ( j = 0  ; j  < _n ; j++   )
 if ( i  == j   )
   w[ i  , j   ] = 0  ;

  else
 w[ i  , j   ] = -1  ;
 

 
  degrees = new int [ _n   ]    ;
 for ( i = 0  ; i  < _n ; i++   )
 degrees[ i   ] = 0  ;

  Hashtable hash = new Hashtable ( _n   )   ;

  names = new String [ _n   ]    ;
 count = 0  ;
 str = sr.ReadLine( )  ;
 while ( str  != null   )
  {
   tokens = str.Split( ' '   )  ;
 if ( hash.ContainsKey( tokens[ 0   ]   )   )
   i = (int)hash[ tokens[ 0   ]   ]  ;

  else
  {
   hash.Add( tokens[ 0   ]   , count   )  ;
 names[ count   ] = tokens[ 0   ]  ;
 i = count  ;
 count++  ;
 }
 
 if ( hash.ContainsKey( tokens[ 1   ]   )   )
   j = (int)hash[ tokens[ 1   ]   ]  ;

  else
  {
   hash.Add( tokens[ 1   ]   , count   )  ;
 names[ count   ] = tokens[ 1   ]  ;
 j = count  ;
 count++  ;
 }
 
 int v = Convert.ToInt32( tokens[ 2   ]   )  ;

  w[ i  , j   ] = v  ;
 w[ j  , i   ] = v  ;
 degrees[ i   ]++  ;
 degrees[ j   ]++  ;
 str = sr.ReadLine( )  ;
 }

  int n = count  ;

  int max_degree = degrees[ 0   ]  ;

  for ( i = 1  ; i  < n ; i++   )
 if ( degrees[ i   ]  > max_degree  )
   max_degree = degrees[ i   ]  ;

 
  edges = new int [ n  , max_degree   ]    ;
 for ( i = 0  ; i  < n ; i++   )
  {
   count = 0  ;
 for ( j = 0  ; j  < n ; j++   )
 if ( w[ i  , j   ]  > 0  )
    {
   edges[ i  , count   ] = j  ;
 count++  ;
 }

 
  }

  SP = new int [ n  , n   ]    ;
 dt2 = DateTime.Now  ;
 Console.WriteLine( "read time = " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 dt1 = DateTime.Now  ;
 Parallel_ShortestPath psp = new Parallel_ShortestPath ( )   ;

  int q = n / P  , r = n % P  ;

  int from = 0  , to ;

  for ( i = 0  ; i  < P ; i++   )
  {
   to = from + q + ( i  < r  ? 1   : 0    )  ;
 psp.ComputeShortestPath( from   , to   , n   , w   , degrees   , edges   , SP   , psp.sendStop   )  ;
 from = to  ;
 }

  for ( i = 0  ; i  < P ; i++   )
 psp.getStop  .Get(new object[]{ } )
;

  dt2 = DateTime.Now  ;
 Console.WriteLine( "compute time = " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 dt1 = DateTime.Now  ;
 writeFile( n   , SP   , names   )  ;
 dt2 = DateTime.Now  ;
 Console.WriteLine( "write time = " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 Console.WriteLine( "Total time = " + ( dt2 - dt0   ).TotalSeconds + " secs."   )  ;
 }
public static  void writeFile (  int n,  int[,] SP,  String[] names )   {
   int i , j ;

  Triple[] lowest = new Triple [ 20   ]    ;

  Triple[] highest = new Triple [ 20   ]    ;

  int c_lowest = 0  ;

  int c_highest = 0  ;

  int c_no_path = 0  ;

  int n_1 = n - 1  ;

  int ip1 ;

  FileStream fs = new FileStream ( "path.out"   , FileMode.Create   , FileAccess.Write   )   ;

  StreamWriter sw = new StreamWriter ( fs   )   ;

  for ( i = 0  ; i  < n_1 ; i++   )
  {
   ip1 = i + 1  ;
 for ( j = ip1  ; j  < n ; j++   )
  {
   if ( SP[ i  , j   ]  == -1   )
   c_no_path++  ;

  else
  {
   if ( c_lowest  == 0   )
    {
   lowest[ 0   ] = new Triple ( SP[ i  , j   ]   , i   , j   )   ;
 c_lowest++  ;
 }

  else
 if ( c_lowest  == 20   )
    {
   if ( SP[ i  , j   ]  < lowest[ 19   ].v  )
   insert_to_lowest( SP[ i  , j   ]   , i   , j   , lowest   , 19   )  ;

  }

  else
  {
   insert_to_lowest( SP[ i  , j   ]   , i   , j   , lowest   , c_lowest   )  ;
 c_lowest++  ;
 }
 
 
 if ( c_highest  == 0   )
    {
   highest[ 0   ] = new Triple ( SP[ i  , j   ]   , i   , j   )   ;
 c_highest++  ;
 }

  else
 if ( c_highest  == 20   )
    {
   if ( SP[ i  , j   ]  > highest[ 19   ].v  )
   insert_to_highest( SP[ i  , j   ]   , i   , j   , highest   , 19   )  ;

  }

  else
  {
   insert_to_highest( SP[ i  , j   ]   , i   , j   , highest   , c_highest   )  ;
 c_highest++  ;
 }
 
 
 }
 
 }

  }

  sw.WriteLine( "Lowest :"   )  ;
 for ( i = 0  ; i  < c_lowest ; i++   )
  {
   sw.WriteLine( names[ lowest[ i   ].i   ] + " " + names[ lowest[ i   ].j   ] + " " + lowest[ i   ].v   )  ;
 }

  sw.WriteLine( "Highest :"   )  ;
 for ( i = 0  ; i  < c_highest ; i++   )
 sw.WriteLine( names[ highest[ i   ].i   ] + " " + names[ highest[ i   ].j   ] + " " + highest[ i   ].v   )  ;

  sw.WriteLine( "There are " + c_no_path + " node pairs that have no path."   )  ;
 sw.Close( )  ;
 fs.Close( )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
  private class McsharpPrivateClassComputeShortestPath {

   Parallel_ShortestPath parent;
   int from;
   int to;
   int n;
   int[,] w;
   int[] degrees;
   int[,] edges;
   int[,] SP;
   channel  sendStop;

   public McsharpPrivateClassComputeShortestPath ( Parallel_ShortestPath parent,
               int from,
               int to,
               int n,
               int[,] w,
               int[] degrees,
               int[,] edges,
               int[,] SP,
               channel  sendStop
              ) {
    this.parent = parent;
    this.from = from;
    this.to = to;
    this.n = n;
    this.w = w;
    this.degrees = degrees;
    this.edges = edges;
    this.SP = SP;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpComputeShortestPathBody ( from, to, n, w, degrees, edges, SP, sendStop );

   }
  }

  private void mcsharpComputeShortestPathBody (
               int from,
               int to,
               int n,
               int[,] w,
               int[] degrees,
               int[,] edges,
               int[,] SP,
               channel  sendStop
              )
 {
   int i , u , v , x ;

  int[] status = new int [ n   ]    ;

  int[] d = new int [ n   ]    ;

  for ( int source = from  ;

  source  < to ; source++   )
  {
   for ( i = 0  ; i  < n ; i++   )
  {
   status[ i   ] = 0  ;
 d[ i   ] = -1  ;
 }

  d[ source   ] = 0  ;
 SortedList B = new SortedList ( n   )   ;

  SortedList slist = new SortedList ( )   ;

  slist.Add( source   , null   )  ;
 B.Add( 0   , slist   )  ;
 int nodes_to_search = n - source - 1  ;

  int nodes_count = 0  ;

  while ( nodes_count  < nodes_to_search && B.Count  != 0   )
  {
   slist = (SortedList)B.GetByIndex( 0   )  ;
 u = (int)slist.GetKey( 0   )  ;
 if ( source  < u  )
   nodes_count++  ;

  if ( nodes_count  < nodes_to_search  )
    {
   slist.RemoveAt( 0   )  ;
 if ( slist.Count  == 0   )
   B.RemoveAt( 0   )  ;

  status[ u   ] = 1  ;
 for ( int p = 0  ;

  p  < degrees[ u   ] ; p++   )
  {
   v = edges[ u  , p   ]  ;
 if ( status[ v   ]  == 0   )
    {
   x = d[ u   ] + w[ u  , v   ]  ;
 if ( d[ v   ]  == -1   )
    {
   d[ v   ] = x  ;
 insert( B   , x   , v   )  ;
 }

  else
 if ( x  < d[ v   ]  )
    {
   remove( B   , d[ v   ]   , v   )  ;
 insert( B   , x   , v   )  ;
 d[ v   ] = x  ;
 }

  
 }

  }

  }

  }

  for ( i = source + 1  ; i  < n ; i++   )
 SP[ source  , i   ] = d[ i   ]  ;

  }

  sendStop.Send ( new object[] {   } )
  ;
 }




  public  void ComputeShortestPath (  int from,  int to,  int n,  int[,] w,  int[] degrees,  int[,] edges,  int[,] SP,  channel  sendStop ) {
   McsharpPrivateClassComputeShortestPath prclassobject = new McsharpPrivateClassComputeShortestPath ( this, from, to, n, w, degrees, edges, SP, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public static  void insert (  SortedList B,  int key,  int value )   {
   SortedList slist ;

  if ( B.ContainsKey( key   )   )
    {
   slist = (SortedList)B[ key   ]  ;
 slist.Add( value   , null   )  ;
 }

  else
  {
   slist = new SortedList ( )   ;
 slist.Add( value   , null   )  ;
 B.Add( key   , slist   )  ;
 }
 
 }
public static  void remove (  SortedList B,  int key,  int value )   {
   SortedList slist ;

  slist = (SortedList)B[ key   ]  ;
 slist.Remove( value   )  ;
 if ( slist.Count  == 0   )
   B.Remove( key   )  ;

  }
public static  void insert_to_lowest (  int v,  int i,  int j,  Triple[] lowest,  int size )   {
   int ii ;

  int count = 0  ;

  while ( count  < size && lowest[ count   ].v  <= v  )
 count++  ;

  for ( ii = size  ; ii  > count ; ii--   )
 lowest[ ii   ] = lowest[ ii - 1   ]  ;

  lowest[ count   ] = new Triple ( v   , i   , j   )   ;
 }
public static  void insert_to_highest (  int v,  int i,  int j,  Triple[] highest,  int size )   {
   int ii ;

  int count = 0  ;

  while ( count  < size && highest[ count   ].v  >= v  )
 count++  ;

  for ( ii = size  ; ii  > count ; ii--   )
 highest[ ii   ] = highest[ ii - 1   ]  ;

  highest[ count   ] = new Triple ( v   , i   , j   )   ;
 }
}

