using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Collections.Generic;
using System.Diagnostics;
using System.Runtime.InteropServices;
namespace   RayTracer
{
[Serializable()]
public  class RayTracerParallel : ISerializable {

 //-------------- MCsharp functions -----------

 public RayTracerParallel ( ) {
  mcsharp_initiate();
}

 public RayTracerParallel ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int width = 100  ;

  int height = 100  ;

  int P = 1  ;

  if ( args.Length  > 1  )
    {
   width = Convert.ToInt32( args[ 0   ]   )  ;
 height = Convert.ToInt32( args[ 1   ]   )  ;
 }

  if ( args.Length  > 2  )
   P = Convert.ToInt32( args[ 2   ]   )  ;

  int[] rgb = new int [ width * height   ]    ;

  RayTracer rayTracer = new RayTracer ( width   , height   , P   , ( int x,  int y,  Color color) => { rgb[ x + y * width   ] = color.ToInt32( )  ;
} )   ;

  rayTracer.Render( rayTracer.DefaultScene   , rgb   )  ;
 Bitmap bitmap = new Bitmap ( width   , height   , PixelFormat.Format32bppRgb   )   ;

  Rectangle rectangle = new Rectangle ( 0   , 0   , width   , height   )   ;

  BitmapData bmpData = bitmap.LockBits( rectangle   , ImageLockMode.WriteOnly   , bitmap.PixelFormat   )  ;

  Marshal.Copy( rgb   , 0   , bmpData.Scan0   , rgb.Length   )  ;
 bitmap.UnlockBits( bmpData   )  ;
 bitmap.Save( "image_" + width + "_" + height + "_" + P + ".jpg"   , ImageFormat.Jpeg   )  ;
 }
}

[Serializable()]
public  class RayTracer : ISerializable {

 //-------------- MCsharp functions -----------

 public RayTracer ( ) {
  mcsharp_initiate();
}

 public RayTracer ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

private  int screenWidth ;

 private  int screenHeight ;

 private  int P ;

 private const  int MaxDepth = 5  ;

 public  Action<int,int,Color> setPixel ;

 public  RayTracer (  int screenWidth,  int screenHeight,  int P,  Action<int,int,Color> setPixel )  {

   mcsharp_initiate();

    this .screenWidth = screenWidth  ;
 this .screenHeight = screenHeight  ;
 this .P = P  ;
 this .setPixel = setPixel  ;


 }

public static  Func<T,U> Y<T,U> (  Func<Func<T,U>,Func<T,U>> f )   {
   Func<Wrap<Func<T,U>>,Func<T,U>> g = wx => f( wx.It( wx   )   )  ;

  return g( new Wrap<Func<T,U>> ( wx => f( y => wx.It( wx   )( y   )   )   )    )  ;
  }
internal  void Render (  Scene scene,  int[] rgb )   {
   int i ;

  int q = screenWidth / P  , r = screenWidth % P  ;

  int from = 0  , to ;

  DateTime dt1 = DateTime.Now  ;

  for ( i = 0  ; i  < P ; i++   )
  {
   to = from + q + ( i  < r  ? 1   : 0    )  ;
 this .render( i   , from   , to   , scene   , rgb   , this .sendStop   )  ;
 from = to  ;
 }

  for ( i = 0  ; i  < P ; i++   )
 this .getStop  .Get(new object[]{ } )
;

  DateTime dt2 = DateTime.Now  ;

  Console.WriteLine( "Rendering time = " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 }
  private class McsharpPrivateClassrender {

   RayTracer parent;
   int myNumber;
   int _from;
   int _to;
   Scene scene;
   int[] rgb;
   channel  sendStop;

   public McsharpPrivateClassrender ( RayTracer parent,
               int myNumber,
               int _from,
               int _to,
               Scene scene,
               int[] rgb,
               channel  sendStop
              ) {
    this.parent = parent;
    this.myNumber = myNumber;
    this._from = _from;
    this._to = _to;
    this.scene = scene;
    this.rgb = rgb;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharprenderBody ( myNumber, _from, _to, scene, rgb, sendStop );

   }
  }

  private void mcsharprenderBody (
               int myNumber,
               int _from,
               int _to,
               Scene scene,
               int[] rgb,
               channel  sendStop
              )
 {
   var pixelsQuery = from  y in Enumerable.Range( 0   , screenHeight   )    let recenterY = -( y - ( screenHeight / 2.0   )   ) / ( 2.0 * screenHeight   )    
  select from  x in Enumerable.Range( _from   , ( _to - _from   )   )    let recenterX = ( x - ( screenWidth / 2.0   )   ) / ( 2.0 * screenWidth   )    
  let point = Vector.Norm( Vector.Plus( scene.Camera.Forward   , Vector.Plus( Vector.Times( recenterX   , scene.Camera.Right   )   , Vector.Times( recenterY   , scene.Camera.Up   )   )   )   )    
  let ray = new Ray ( ) { Start = scene.Camera.Pos     , Dir = point      }       
  let computeTraceRay = (Func<Func<TraceRayArgs,Color>,Func<TraceRayArgs,Color>>)( f => traceRayArgs => ( from  isect in from  thing in traceRayArgs.Scene.Things    select thing.Intersect( traceRayArgs.Ray   )       where isect  != null    
  orderby isect.Dist      
  let d = isect.Ray.Dir    
  let pos = Vector.Plus( Vector.Times( isect.Dist   , isect.Ray.Dir   )   , isect.Ray.Start   )    
  let normal = isect.Thing.Normal( pos   )    
  let reflectDir = Vector.Minus( d   , Vector.Times( 2 * Vector.Dot( normal   , d   )   , normal   )   )    
  let naturalColors = from  light in traceRayArgs.Scene.Lights    let ldis = Vector.Minus( light.Pos   , pos   )    
  let livec = Vector.Norm( ldis   )    
  let testRay = new Ray ( ) { Start = pos     , Dir = livec      }       
  let testIsects = from  inter in from  thing in traceRayArgs.Scene.Things    select thing.Intersect( testRay   )       where inter  != null    
  orderby inter.Dist      
  select inter       
  let testIsect = testIsects.FirstOrDefault( )    
  let neatIsect = testIsect  == null   ? 0   : testIsect.Dist     
  let isInShadow = !( ( neatIsect  > Vector.Mag( ldis   )  )  || ( neatIsect  == 0   )   )    
  where !isInShadow    
  let illum = Vector.Dot( livec   , normal   )    
  let lcolor = illum  > 0  ? Color.Times( illum   , light.Color   )   : Color.Make( 0   , 0   , 0   )     
  let specular = Vector.Dot( livec   , Vector.Norm( reflectDir   )   )    
  let scolor = specular  > 0  ? Color.Times( Math.Pow( specular   , isect.Thing.Surface.Roughness   )   , light.Color   )   : Color.Make( 0   , 0   , 0   )     
  select Color.Plus( Color.Times( isect.Thing.Surface.Diffuse( pos   )   , lcolor   )   , Color.Times( isect.Thing.Surface.Specular( pos   )   , scolor   )   )       
  let reflectPos = Vector.Plus( pos   , Vector.Times( .001   , reflectDir   )   )    
  let reflectColor = traceRayArgs.Depth  >= MaxDepth  ? Color.Make( .5   , .5   , .5   )   : Color.Times( isect.Thing.Surface.Reflect( reflectPos   )   , f( new TraceRayArgs ( new Ray ( ) { Start = reflectPos     , Dir = reflectDir      }      , traceRayArgs.Scene   , traceRayArgs.Depth + 1   )    )   )     
  select naturalColors.Aggregate( reflectColor   , (color, natColor) => Color.Plus( color   , natColor   )   )      ).DefaultIfEmpty( Color.Background   ).First( )   )    
  let traceRay = Y( computeTraceRay   )    
  select new { X = x     , Y = y     , Color = traceRay( new TraceRayArgs ( ray   , scene   , 0   )    )      }           ;

  foreach ( var row in pixelsQuery  ) foreach ( var pixel in row  ) setPixel( pixel.X   , pixel.Y   , pixel.Color   )  ;
 sendStop.Send ( new object[] {   } )
  ;
 }




  internal  void render (  int myNumber,  int _from,  int _to,  Scene scene,  int[] rgb,  channel  sendStop ) {
   McsharpPrivateClassrender prclassobject = new McsharpPrivateClassrender ( this, myNumber, _from, _to, scene, rgb, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
internal readonly  Scene DefaultScene = new Scene ( ) { Things = new SceneObject[] { new Plane ( ) { Norm = Vector.Make( 0   , 1   , 0   )     , Offset = 0     , Surface = Surfaces.CheckerBoard      }       , new Sphere ( ) { Center = Vector.Make( 0   , 1   , 0   )     , Radius = 1     , Surface = Surfaces.Shiny      }       , new Sphere ( ) { Center = Vector.Make( -1   , .5   , 1.5   )     , Radius = 1.5     , Surface = Surfaces.Shiny      }        }        , Lights = new Light[] { new Light ( ) { Pos = Vector.Make( -2   , 2.5   , 0   )     , Color = Color.Make( .49   , .07   , .07   )      }       , new Light ( ) { Pos = Vector.Make( 1.5   , 2.5   , 1.5   )     , Color = Color.Make( .07   , .07   , .49   )      }       , new Light ( ) { Pos = Vector.Make( 1.5   , 2.5   , -1.5   )     , Color = Color.Make( .07   , .49   , .071   )      }       , new Light ( ) { Pos = Vector.Make( 0   , 3.5   , 0   )     , Color = Color.Make( .21   , .21   , .35   )      }        }        , Camera = Camera.Create( Vector.Make( 3   , 2   , 4   )   , Vector.Make( -1   , .5   , 0   )   )      }     ;

 
 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
}

}