using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Collections.Generic;
using System.Diagnostics;
using System.Runtime.InteropServices;
namespace   RayTracer
{
[Serializable()]
public  class RayTracerParallel : ISerializable {

 //-------------- MCsharp functions -----------

 public RayTracerParallel ( ) {
  mcsharp_initiate();
}

 public RayTracerParallel ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int width = 100  ;

  int height = 100  ;

  int P = 1  ;

  if ( args.Length  > 1  )
    {
   width = Convert.ToInt32( args[ 0   ]   )  ;
 height = Convert.ToInt32( args[ 1   ]   )  ;
 }

  if ( args.Length  > 2  )
   P = Convert.ToInt32( args[ 2   ]   )  ;

  int[] rgb = new int [ width * height   ]    ;

  RayTracer rayTracer = new RayTracer ( width   , height   , P   , ( int x,  int y,  Color color) => { rgb[ x + y * width   ] = color.ToInt32( )  ;
} )   ;

  rayTracer.Render( rayTracer.DefaultScene   , rgb   )  ;
 Bitmap bitmap = new Bitmap ( width   , height   , PixelFormat.Format32bppRgb   )   ;

  Rectangle rectangle = new Rectangle ( 0   , 0   , width   , height   )   ;

  BitmapData bmpData = bitmap.LockBits( rectangle   , ImageLockMode.WriteOnly   , bitmap.PixelFormat   )  ;

  Marshal.Copy( rgb   , 0   , bmpData.Scan0   , rgb.Length   )  ;
 bitmap.UnlockBits( bmpData   )  ;
 bitmap.Save( "image_" + width + "_" + height + "_" + P + ".jpg"   , ImageFormat.Jpeg   )  ;
 }
}

[Serializable()]
public  class RayTracer : ISerializable {

 //-------------- MCsharp functions -----------

 public RayTracer ( ) {
  mcsharp_initiate();
}

 public RayTracer ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

private  int screenWidth ;

 private  int screenHeight ;

 private  int P ;

 private const  int MaxDepth = 5  ;

 public  Action<int,int,Color> setPixel ;

 public  RayTracer (  int screenWidth,  int screenHeight,  int P,  Action<int,int,Color> setPixel )  {

   mcsharp_initiate();

    this .screenWidth = screenWidth  ;
 this .screenHeight = screenHeight  ;
 this .P = P  ;
 this .setPixel = setPixel  ;


 }

internal  void Render (  Scene scene,  int[] rgb )   {
   int i ;

  int q = screenWidth / P  , r = screenWidth % P  ;

  int from = 0  , to ;

  DateTime dt1 = DateTime.Now  ;

  for ( i = 0  ; i  < P ; i++   )
  {
   to = from + q + ( i  < r  ? 1   : 0    )  ;
 this .render( i   , from   , to   , scene   , rgb   , this .sendStop   )  ;
 from = to  ;
 }

  for ( i = 0  ; i  < P ; i++   )
 this .getStop  .Get(new object[]{ } )
;

  DateTime dt2 = DateTime.Now  ;

  Console.WriteLine( "Rendering time = " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 }
  private class McsharpPrivateClassrender {

   RayTracer parent;
   int myNumber;
   int from;
   int to;
   Scene scene;
   int[] rgb;
   channel  sendStop;

   public McsharpPrivateClassrender ( RayTracer parent,
               int myNumber,
               int from,
               int to,
               Scene scene,
               int[] rgb,
               channel  sendStop
              ) {
    this.parent = parent;
    this.myNumber = myNumber;
    this.from = from;
    this.to = to;
    this.scene = scene;
    this.rgb = rgb;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharprenderBody ( myNumber, from, to, scene, rgb, sendStop );

   }
  }

  private void mcsharprenderBody (
               int myNumber,
               int from,
               int to,
               Scene scene,
               int[] rgb,
               channel  sendStop
              )
 {
   for ( int y = 0  ;

  y  < screenHeight ; y++   )
  {
   for ( int x = from  ;

  x  < to ; x++   )
  {
   Color color = TraceRay( new Ray ( ) { Start = scene.Camera.Pos     , Dir = GetPoint( x   , y   , scene.Camera   )      }      , scene   , 0   )  ;

  setPixel( x   , y   , color   )  ;
 }

  }

  sendStop.Send ( new object[] {   } )
  ;
 }




  internal  void render (  int myNumber,  int from,  int to,  Scene scene,  int[] rgb,  channel  sendStop ) {
   McsharpPrivateClassrender prclassobject = new McsharpPrivateClassrender ( this, myNumber, from, to, scene, rgb, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
private  Color TraceRay (  Ray ray,  Scene scene,  int depth )   {
   var isects = Intersections( ray   , scene   )  ;

  ISect isect = isects.FirstOrDefault( )  ;

  if ( isect  == null   )
   return Color.Background  ;
 
  return Shade( isect   , scene   , depth   )  ;
  }
private  Vector GetPoint (  double x,  double y,  Camera camera )   {
   return Vector.Norm( Vector.Plus( camera.Forward   , Vector.Plus( Vector.Times( RecenterX( x   )   , camera.Right   )   , Vector.Times( RecenterY( y   )   , camera.Up   )   )   )   )  ;
  }
private  IEnumerable<ISect> Intersections (  Ray ray,  Scene scene )   {
   return scene.Things.Select( obj => obj.Intersect( ray   )   ).Where( inter => inter  != null   ).OrderBy( inter => inter.Dist   )  ;
  }
private  Color Shade (  ISect isect,  Scene scene,  int depth )   {
   var d = isect.Ray.Dir  ;

  var pos = Vector.Plus( Vector.Times( isect.Dist   , isect.Ray.Dir   )   , isect.Ray.Start   )  ;

  var normal = isect.Thing.Normal( pos   )  ;

  var reflectDir = Vector.Minus( d   , Vector.Times( 2 * Vector.Dot( normal   , d   )   , normal   )   )  ;

  Color ret = Color.DefaultColor  ;

  ret = Color.Plus( ret   , GetNaturalColor( isect.Thing   , pos   , normal   , reflectDir   , scene   )   )  ;
 if ( depth  >= MaxDepth  )
    {
   return Color.Plus( ret   , Color.Make( .5   , .5   , .5   )   )  ;
  }

  return Color.Plus( ret   , GetReflectionColor( isect.Thing   , Vector.Plus( pos   , Vector.Times( .001   , reflectDir   )   )   , normal   , reflectDir   , scene   , depth   )   )  ;
  }
private  double RecenterX (  double x )   {
   return ( x - ( screenWidth / 2.0   )   ) / ( 2.0 * screenWidth   )  ;
  }
private  double RecenterY (  double y )   {
   return -( y - ( screenHeight / 2.0   )   ) / ( 2.0 * screenHeight   )  ;
  }
private  Color GetNaturalColor (  SceneObject thing,  Vector pos,  Vector norm,  Vector rd,  Scene scene )   {
   Color ret = Color.Make( 0   , 0   , 0   )  ;

  foreach ( Light light in scene.Lights  )  {
   Vector ldis = Vector.Minus( light.Pos   , pos   )  ;

  Vector livec = Vector.Norm( ldis   )  ;

  double neatIsect = TestRay( new Ray ( ) { Start = pos     , Dir = livec      }      , scene   )  ;

  bool isInShadow = !( ( neatIsect  > Vector.Mag( ldis   )  )  || ( neatIsect  == 0   )   )  ;

  if ( !isInShadow   )
    {
   double illum = Vector.Dot( livec   , norm   )  ;

  Color lcolor = illum  > 0  ? Color.Times( illum   , light.Color   )   : Color.Make( 0   , 0   , 0   )   ;

  double specular = Vector.Dot( livec   , Vector.Norm( rd   )   )  ;

  Color scolor = specular  > 0  ? Color.Times( Math.Pow( specular   , thing.Surface.Roughness   )   , light.Color   )   : Color.Make( 0   , 0   , 0   )   ;

  ret = Color.Plus( ret   , Color.Plus( Color.Times( thing.Surface.Diffuse( pos   )   , lcolor   )   , Color.Times( thing.Surface.Specular( pos   )   , scolor   )   )   )  ;
 }

  }
 return ret  ;
  }
private  Color GetReflectionColor (  SceneObject thing,  Vector pos,  Vector norm,  Vector rd,  Scene scene,  int depth )   {
   return Color.Times( thing.Surface.Reflect( pos   )   , TraceRay( new Ray ( ) { Start = pos     , Dir = rd      }      , scene   , depth + 1   )   )  ;
  }
private  double TestRay (  Ray ray,  Scene scene )   {
   var isects = Intersections( ray   , scene   )  ;

  ISect isect = isects.FirstOrDefault( )  ;

  if ( isect  == null   )
   return 0  ;
 
  return isect.Dist  ;
  }
internal readonly  Scene DefaultScene = new Scene ( ) { Things = new SceneObject[] { new Plane ( ) { Norm = Vector.Make( 0   , 1   , 0   )     , Offset = 0     , Surface = Surfaces.CheckerBoard      }       , new Sphere ( ) { Center = Vector.Make( 0   , 1   , 0   )     , Radius = 1     , Surface = Surfaces.Shiny      }       , new Sphere ( ) { Center = Vector.Make( -1   , .5   , 1.5   )     , Radius = .5     , Surface = Surfaces.Shiny      }        }        , Lights = new Light[] { new Light ( ) { Pos = Vector.Make( -2   , 2.5   , 0   )     , Color = Color.Make( .49   , .07   , .07   )      }       , new Light ( ) { Pos = Vector.Make( 1.5   , 2.5   , 1.5   )     , Color = Color.Make( .07   , .07   , .49   )      }       , new Light ( ) { Pos = Vector.Make( 1.5   , 2.5   , -1.5   )     , Color = Color.Make( .07   , .49   , .071   )      }       , new Light ( ) { Pos = Vector.Make( 0   , 3.5   , 0   )     , Color = Color.Make( .21   , .21   , .35   )      }        }        , Camera = Camera.Create( Vector.Make( 3   , 2   , 4   )   , Vector.Make( -1   , .5   , 0   )   )      }     ;

 }

}