using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

namespace   RandonAccessBenchmark
{
[Serializable()]
public  class RandomAccess : ISerializable {

 //-------------- MCsharp functions -----------

 public RandomAccess ( ) {
  mcsharp_initiate();
}

 public RandomAccess ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

bool atomicity = false  ;

 object anchor = new object ( )   ;

 const  long POLY = 0x0000000000000007  , PERIOD = 1317624576693539401L  ;

 public  RandomAccess (  bool atomicity )  {

   mcsharp_initiate();

    this .atomicity = atomicity  ;


 }

static  long RA_starts (  long n )   {
   int i , j ;

  long[] m2 = new long [ 64   ]    ;

  while ( n  < 0  )
 n += PERIOD  ;

  while ( n  > PERIOD  )
 n -= PERIOD  ;

  if ( n  == 0   )
   return 0x1  ;
 
  long temp = 0x1  ;

  for ( i = 0  ; i  < 64 ; i++   )
  {
   m2[ i   ] = temp  ;
 temp = ( temp << 1  )  ^ ( temp  < 0  ? POLY   : 0L    )  ;
 temp = ( temp << 1  )  ^ ( temp  < 0  ? POLY   : 0L    )  ;
 }

  for ( i = 62  ; i  >= 0 ; i--   )
 if ( ( ( n >> i  )  & 1   )  != 0   )
   break  ;

 
  long ran = 0x2  ;

  while ( i  > 0  )
  {
   temp = 0  ;
 for ( j = 0  ; j  < 64 ; j++   )
 if ( ( ( ran >> j  )  & 1   )  != 0   )
   temp = temp  ^ m2[ j   ]  ;

 
  ran = temp  ;
 i -= 1  ;
 if ( ( ( n >> i  )  & 1   )  != 0   )
   ran = ( ran << 1  )  ^ ( (long)ran  < 0  ? POLY   : 0    )  ;

  }

  return ran  ;
  }
  private class McsharpPrivateClassAccess {

   RandomAccess parent;
   BigArray<long> Table;
   uint ithread;
   UInt64 memorySizePerThread;
   channel  onDone;

   public McsharpPrivateClassAccess ( RandomAccess parent,
               BigArray<long> Table,
               uint ithread,
               UInt64 memorySizePerThread,
               channel  onDone
              ) {
    this.parent = parent;
    this.Table = Table;
    this.ithread = ithread;
    this.memorySizePerThread = memorySizePerThread;
    this.onDone = onDone;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpAccessBody ( Table, ithread, memorySizePerThread, onDone );

   }
  }

  private void mcsharpAccessBody (
               BigArray<long> Table,
               uint ithread,
               UInt64 memorySizePerThread,
               channel  onDone
              )
 {
   UInt64 updates = 4 * memorySizePerThread  ;

  long ran = RA_starts( (long)( updates * ithread   )   )  ;

  for ( UInt64 i = 0  ;

  i  < updates ; i++   )
  {
   if ( atomicity   )
   lock ( anchor   )  {
   Table[ ran  & ( Table.Length - 1   )   ] ^= ran  ;
 }

  else
 Table[ ran  & ( Table.Length - 1   )   ] ^= ran  ;
 
 ran = ( ran << 1  )  ^ ( (long)ran  < 0  ? POLY   : 0    )  ;
 }

  onDone.Send ( new object[] {   } )
  ;
 }




  public  void Access (  BigArray<long> Table,  uint ithread,  UInt64 memorySizePerThread,  channel  onDone ) {
   McsharpPrivateClassAccess prclassobject = new McsharpPrivateClassAccess ( this, Table, ithread, memorySizePerThread, onDone );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

[Serializable()]
 class Program : ISerializable {

 //-------------- MCsharp functions -----------

 public Program ( ) {
  mcsharp_initiate();
}

 public Program ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  onDone = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelonDone" );
  mcsharpQueueisDone = new MCSharp.ThreadQ();

  isDone = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerisDone" );
 }

static  void Main (  string[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  string[] args )  {
   uint threads = 1  ;

  UInt64 memorySizePerThread ;

  bool atomicity = false  ;

  bool verify = true  ;

  if ( ( args.Length  == 0   )  || ( args.Length  > 4  )   )
    {
   Console.WriteLine( "Usage: RandomAccessBenchmark.exe <threads> <mem_per_thread> [/atom] [/notest]"   )  ;
 return ;
  }

  try {
    threads = UInt32.Parse( args[ 0   ]   )  ;
 memorySizePerThread = (UInt64)( Math.Pow( 2   , UInt32.Parse( args[ 1   ]   )   )   )  ;
 if ( args.Length  == 4   )
    {
   atomicity = args[ 2   ]  == "/atom"   ? true   : false   ;
 verify = args[ 3   ]  == "/notest"   ? false   : true   ;
 }

  if ( args.Length  == 3   )
    {
   atomicity = args[ 2   ]  == "/atom"   ? true   : false   ;
 verify = args[ 2   ]  == "/notest"   ? false   : true   ;
 }

  if ( args.Length  == 2   )
    {
   if ( args[ 1   ]  == "/atom"   )
   atomicity = true  ;

  else
 if ( args[ 1   ]  == "/notest"   )
   verify = false  ;

  
 }

     }
   catch ( Exception e )
  {
    Console.WriteLine( "Usage: RandomAccessBenchmark.exe <threads> <mem_per_thread> [/atom] [/notest]"   )  ;
 return ;
   }
 
   Console.WriteLine( "RandomAccessBenchmark"   )  ;
 UInt64 mem_total = threads * memorySizePerThread  ;

  UInt64 updates_total = 4 * mem_total  ;

  Console.WriteLine( "Threads in use = " + threads   )  ;
 Console.WriteLine( "Total memory in use (in bytes) = " + mem_total * sizeof ( long )   )  ;
 Console.WriteLine( "Table length = " + mem_total   )  ;
 Console.WriteLine( "Total updates count to be done = " + updates_total   )  ;
 Console.WriteLine( "Atomicity is " + ( atomicity   ? "on"   : "off"    )   )  ;
 Console.WriteLine( "Verifying is " + ( verify   ? "on"   : "off"    )   )  ;
 Console.WriteLine( "Please wait..."   )  ;
 BigArray<long> Table = new BigArray<long> ( mem_total   )   ;

  for ( long k = 0  ;

  k  < Table.Length ; k++   )
 Table[ k   ] = k  ;

  var randomAccess = new RandomAccess ( atomicity   )   ;

  var p = new Program ( )   ;

  TimeSpan old = DateTime.Now.TimeOfDay  ;

  RunTest( p   , randomAccess   , Table   , memorySizePerThread   , threads   )  ;
 TimeSpan time_res = DateTime.Now.TimeOfDay - old  ;

  double total_time = ( time_res.Minutes * 60 + time_res.Seconds + time_res.Milliseconds * 0.001   )  ;

  Console.WriteLine( "CPU time used  = " + total_time + " seconds"   )  ;
 Console.WriteLine( "GUPS = " + ( updates_total / total_time / 1e9   ).ToString( "N12"   )   )  ;
 if ( verify   )
    {
   Console.WriteLine( "Verifying..."   )  ;
 randomAccess.Access( Table   , 0   , mem_total   , p.onDone   )  ;
 p.isDone  .Get(new object[]{ } )
;
 long errcount = 0  ;

  for ( long i = 0  ;

  i  < Table.Length ; i++   )
 if ( Table[ i   ]  != i   )
   errcount++  ;

 
  Console.WriteLine( "Found " + errcount + " errors in " + Table.Length + " locations." + "(" + (float)errcount / (float)Table.Length * 100.0f + "%)."   )  ;
 }

  }

 //-------------Channel declarations-----------------

  public MCSharp.channel onDone;

 //-------------Handler declaration-----------------

    public MCSharp.handler isDone;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueisDone;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_isDone = 1 << 0;
 private const int mcsharp_mask_onDone = 1 << 1;
 private const int mcsharp_mask_isDoneonDone =
            mcsharp_mask_isDone
          | mcsharp_mask_onDone;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskisDoneonDone = new MCSharp.BitMask();

 private void scanisDoneonDone () {
  if ( mcsharpBitMaskisDoneonDone.match
        ( mcsharp_mask_isDoneonDone ) )
   mcsharpQueueisDone.wakeup();
 }


[OneWay]
public void mcsharpChannelonDone (  )  {
   lock ( mcsharpQueueisDone ) {
    onDone.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskisDoneonDone.match
          ( mcsharp_mask_onDone ) )   {
     mcsharpBitMaskisDoneonDone.set ( mcsharp_mask_onDone );
     scanisDoneonDone ();
    }
   }
 }

 public void mcsharpHandlerisDone (  )   {
  Monitor.Enter ( mcsharpQueueisDone );
  if ( ! mcsharpBitMaskisDoneonDone.match ( mcsharp_mask_isDone ) ) goto now;
  later:
   mcsharpQueueisDone.yield ( mcsharpQueueisDone );
   if ( mcsharpQueueisDone.empty )
    mcsharpBitMaskisDoneonDone.clear ( mcsharp_mask_isDone );
  now:
   if ( mcsharpBitMaskisDoneonDone.match ( 
    mcsharp_mask_onDone ) )   {
    object[] oonDone = ( object[] ) onDone.Dequeue();
    if ( onDone.Count == 0 )
         mcsharpBitMaskisDoneonDone.clear ( mcsharp_mask_onDone );
    scanisDoneonDone ();
    Monitor.Exit ( mcsharpQueueisDone );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskisDoneonDone.set ( mcsharp_mask_isDone );
    goto later;
  }

 }
static public  void RunTest (  Program p,  RandomAccess randomAccess,  BigArray<long> Table,  ulong memorySizePerThread,  uint threads )   {
   for ( int i = 0  ;

  i  < threads ; i++   )
 randomAccess.Access( Table   , (uint)i   , memorySizePerThread   , p.onDone   )  ;

  for ( int i = 0  ;

  i  < threads ; i++   )
 p.isDone  .Get(new object[]{ } )
;

  }
}

}