using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using System.Windows.Forms;
[Serializable()]
 class Program : ISerializable {

 //-------------- MCsharp functions -----------

 public Program ( ) {
  mcsharp_initiate();
}

 public Program ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

static  void Main (  string[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  string[] args )  {
   if ( CheckParams( ref args   )  == true   )
    {
   Application.EnableVisualStyles( )  ;
 Application.SetCompatibleTextRenderingDefault( false   )  ;
 Application.Run( new Form1 ( args   )    )  ;
 }

  else
 Usage( )  ;
 
 }
static  bool CheckParams ( ref  string[] args )   {
   if ( ( args.Length  != 5   )  && ( args.Length  != 7   )   )
   return false  ;
 
  if ( args.Length  == 5   )
    {
   string[] return_args = new string [ 7   ]    ;

  ;
 args.CopyTo( return_args   , 0   )  ;
 return_args[ 5   ] = "600"  ;
 return_args[ 6   ] = "400"  ;
 args = return_args  ;
 }

  for ( int i = 0  ;

  i  < 5 ; i++   )
  {
   if ( Thread.CurrentThread.CurrentCulture.NumberFormat.NumberDecimalSeparator  == "."   )
   args[ i   ] = args[ i   ].Replace( ','   , '.'   )  ;

  else
 args[ i   ] = args[ i   ].Replace( '.'   , ','   )  ;
 
 }

  return true  ;
  }
static  void Usage (  )   {
   Console.WriteLine( "Usage: Mandelbrot.exe x1 y2 x2 y2 numOfLines cx cy"   )  ;
 Console.WriteLine( "where"   )  ;
 Console.WriteLine( " (x1, y1) - left bottom corner of fractal"   )  ;
 Console.WriteLine( " (x2, y2) - right top corner of fractal"   )  ;
 Console.WriteLine( " numOfLines - number of fragments"   )  ;
 Console.WriteLine( " (cx, cy) - width and height of picture; default=(600;400)"   )  ;
 Console.WriteLine( )  ;
 Console.WriteLine( "For example:"   )  ;
 Console.WriteLine( " Mandelbrot.exe " + -1.5 + " " + -1.5 + " " + 1.5 + " " + 1.5 + " 10 1000 600"   )  ;
 Console.WriteLine( " Mandelbrot.exe " + -1.5 + " " + -1.5 + " " + 1.5 + " " + 1.5 + " 10"   )  ;
 }
}

