using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class MatrixMultiplierParallel : ISerializable {

 //-------------- MCsharp functions -----------

 public MatrixMultiplierParallel ( ) {
  mcsharp_initiate();
}

 public MatrixMultiplierParallel ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   if ( args.Length  < 2  )
    {
   Console.WriteLine( "Usage: matrixmult.exe <size> <parts>"   )  ;
 return ;
  }

  int i , j ;

  int N = System.Convert.ToInt32( args[ 0   ]   )  ;

  int M = System.Convert.ToInt32( args[ 1   ]   )  ;

  double[,] A = new double [ N  , N   ]    ;

  double[,] B = new double [ N  , N   ]    ;

  double[,] C = new double [ N  , N   ]    ;

  Random rnd = new Random ( )   ;

  for ( i = 0  ; i  < N ; ++i   )
  {
   for ( j = 0  ; j  < N ; ++j   )
  {
   A[ i  , j   ] = rnd.NextDouble( )  ;
 B[ i  , j   ] = rnd.NextDouble( )  ;
 C[ i  , j   ] = 0.0  ;
 }

  }

  int q = N / M  , r = N % M  ;

  int from = 0  , to ;

  MatrixMultiplierParallel mmp = new MatrixMultiplierParallel ( )   ;

  DateTime dt1 = DateTime.Now  ;

  for ( i = 0  ; i  < M ; ++i   )
  {
   to = from + q + ( i  < r  ? 1   : 0    )  ;
 mmp.Multiply( N   , A   , B   , C   , from   , to   , mmp.sendStop   )  ;
 from = to  ;
 }

  for ( i = 0  ; i  < M ; ++i   )
 mmp.getStop  .Get(new object[]{ } )
;

  Console.WriteLine( "Matrix size: {0}, Number of parts: {1}."   , N   , M   )  ;
 Console.WriteLine( "Elapsed time " + ( DateTime.Now - dt1   ).TotalSeconds + " sec."   )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  int x )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public int mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    int x = ( int ) osendStop [ 0 ];
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return x  ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
  private class McsharpPrivateClassMultiply {

   MatrixMultiplierParallel parent;
   int N;
   double[,] A;
   double[,] B;
   double[,] C;
   int from;
   int to;
   channel  sendStop;

   public McsharpPrivateClassMultiply ( MatrixMultiplierParallel parent,
               int N,
               double[,] A,
               double[,] B,
               double[,] C,
               int from,
               int to,
               channel  sendStop
              ) {
    this.parent = parent;
    this.N = N;
    this.A = A;
    this.B = B;
    this.C = C;
    this.from = from;
    this.to = to;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpMultiplyBody ( N, A, B, C, from, to, sendStop );

   }
  }

  private void mcsharpMultiplyBody (
               int N,
               double[,] A,
               double[,] B,
               double[,] C,
               int from,
               int to,
               channel  sendStop
              )
 {
   int i , j , k ;

  for ( i = from  ; i  < to ; i++   )
  {
   for ( j = 0  ; j  < N ; j++   )
  {
   for ( k = 0  ; k  < N ; k++   )
 C[ i  , j   ] += A[ i  , k   ] * B[ k  , j   ]  ;

  }

  }

  sendStop.Send ( new object[] {  0    } )
  ;
 }




  public  void Multiply (  int N,  double[,] A,  double[,] B,  double[,] C,  int from,  int to,  channel  sendStop ) {
   McsharpPrivateClassMultiply prclassobject = new McsharpPrivateClassMultiply ( this, N, A, B, C, from, to, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

