using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
 class BDChannel : ISerializable {

 //-------------- MCsharp functions -----------

 public BDChannel ( ) {
  mcsharp_initiate();
}

 public BDChannel ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  Send = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelSend" );
  mcsharpQueueReceive = new MCSharp.ThreadQ();

  Receive = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerReceive" );
 }


 //-------------Channel declarations-----------------

  public MCSharp.channel Send;

 //-------------Handler declaration-----------------

    public MCSharp.handler Receive;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueReceive;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Receive = 1 << 0;
 private const int mcsharp_mask_Send = 1 << 1;
 private const int mcsharp_mask_ReceiveSend =
            mcsharp_mask_Receive
          | mcsharp_mask_Send;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskReceiveSend = new MCSharp.BitMask();

 private void scanReceiveSend () {
  if ( mcsharpBitMaskReceiveSend.match
        ( mcsharp_mask_ReceiveSend ) )
   mcsharpQueueReceive.wakeup();
 }


[OneWay]
public void mcsharpChannelSend (  object obj )  {
   lock ( mcsharpQueueReceive ) {
    Send.Enqueue ( new object [] { obj } );
    if ( ! mcsharpBitMaskReceiveSend.match
          ( mcsharp_mask_Send ) )   {
     mcsharpBitMaskReceiveSend.set ( mcsharp_mask_Send );
     scanReceiveSend ();
    }
   }
 }

 public object mcsharpHandlerReceive (  )   {
  Monitor.Enter ( mcsharpQueueReceive );
  if ( ! mcsharpBitMaskReceiveSend.match ( mcsharp_mask_Receive ) ) goto now;
  later:
   mcsharpQueueReceive.yield ( mcsharpQueueReceive );
   if ( mcsharpQueueReceive.empty )
    mcsharpBitMaskReceiveSend.clear ( mcsharp_mask_Receive );
  now:
   if ( mcsharpBitMaskReceiveSend.match ( 
    mcsharp_mask_Send ) )   {
    object[] oSend = ( object[] ) Send.Dequeue();
    object obj = ( object ) oSend [ 0 ];
    if ( Send.Count == 0 )
         mcsharpBitMaskReceiveSend.clear ( mcsharp_mask_Send );
    scanReceiveSend ();
    Monitor.Exit ( mcsharpQueueReceive );
     {
   return ( obj   )  ;
  }
   }
   else {
    mcsharpBitMaskReceiveSend.set ( mcsharp_mask_Receive );
    goto later;
  }

 }
}

[Serializable()]
 class All2all : ISerializable {

 //-------------- MCsharp functions -----------

 public All2all ( ) {
  mcsharp_initiate();
}

 public All2all ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendBDC = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendBDC" );
  mcsharpQueuegetBDC = new MCSharp.ThreadQ();

  getBDC = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetBDC" );
  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   if ( args.Length  < 1  )
    {
   Console.WriteLine( "Usage: all2all.exe <number of processes>"   )  ;
 return ;
  }

  int i ;

  int N = System.Convert.ToInt32( args[ 0   ]   )  ;

  All2all a2a = new All2all ( )   ;

  DistribProcess dproc = new DistribProcess ( )   ;

  for ( i = 0  ; i  < N ; i++   )
 dproc.Start( i   , a2a.sendBDC   , a2a.sendStop   )  ;

  BDChannel[] bdchans = new BDChannel [ N   ]    ;

  BDChannel[] interact_bdchans = new BDChannel [ N   ]    ;

  for ( i = 0  ; i  < N ; i++   )
 a2a.getBDC  .Get(new object[]{ bdchans   , interact_bdchans   } )
;

  for ( i = 0  ; i  < N ; i++   )
 bdchans[ i   ].Send.Send ( new object[] {  interact_bdchans    } )
  ;

  for ( i = 0  ; i  < N ; i++   )
 a2a.getStop  .Get(new object[]{ } )
;

  }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendBDC;

 //-------------Handler declaration-----------------

    public MCSharp.handler getBDC;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetBDC;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getBDC = 1 << 0;
 private const int mcsharp_mask_sendBDC = 1 << 1;
 private const int mcsharp_mask_getBDCsendBDC =
            mcsharp_mask_getBDC
          | mcsharp_mask_sendBDC;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetBDCsendBDC = new MCSharp.BitMask();

 private void scangetBDCsendBDC () {
  if ( mcsharpBitMaskgetBDCsendBDC.match
        ( mcsharp_mask_getBDCsendBDC ) )
   mcsharpQueuegetBDC.wakeup();
 }


[OneWay]
public void mcsharpChannelsendBDC (  int i,  BDChannel bdc,  BDChannel interact_bdc )  {
   lock ( mcsharpQueuegetBDC ) {
    sendBDC.Enqueue ( new object [] { i, bdc, interact_bdc } );
    if ( ! mcsharpBitMaskgetBDCsendBDC.match
          ( mcsharp_mask_sendBDC ) )   {
     mcsharpBitMaskgetBDCsendBDC.set ( mcsharp_mask_sendBDC );
     scangetBDCsendBDC ();
    }
   }
 }

 public void mcsharpHandlergetBDC (  BDChannel[] bdchans,  BDChannel[] interact_bdchans )   {
  Monitor.Enter ( mcsharpQueuegetBDC );
  if ( ! mcsharpBitMaskgetBDCsendBDC.match ( mcsharp_mask_getBDC ) ) goto now;
  later:
   mcsharpQueuegetBDC.yield ( mcsharpQueuegetBDC );
   if ( mcsharpQueuegetBDC.empty )
    mcsharpBitMaskgetBDCsendBDC.clear ( mcsharp_mask_getBDC );
  now:
   if ( mcsharpBitMaskgetBDCsendBDC.match ( 
    mcsharp_mask_sendBDC ) )   {
    object[] osendBDC = ( object[] ) sendBDC.Dequeue();
    int i = ( int ) osendBDC [ 0 ];
    BDChannel bdc = ( BDChannel ) osendBDC [ 1 ];
    BDChannel interact_bdc = ( BDChannel ) osendBDC [ 2 ];
    if ( sendBDC.Count == 0 )
         mcsharpBitMaskgetBDCsendBDC.clear ( mcsharp_mask_sendBDC );
    scangetBDCsendBDC ();
    Monitor.Exit ( mcsharpQueuegetBDC );
     {
   bdchans[ i   ] = bdc  ;
 interact_bdchans[ i   ] = interact_bdc  ;
 }
   }
   else {
    mcsharpBitMaskgetBDCsendBDC.set ( mcsharp_mask_getBDC );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
}

[Serializable()]
 class DistribProcess : ISerializable {

 //-------------- MCsharp functions -----------

 public DistribProcess ( ) {
  mcsharp_initiate();
}

 public DistribProcess ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

 public void Start (  int myNumber,  channel  sendBDC,  channel  sendStop )  {
   MCSharp.TCP.DeliverMovableMethod ( this,"Start_Body_MCSharpWrapper", new object[] {myNumber, sendBDC, sendStop} );
 }

 public void Start_Body_MCSharpWrapper (  int myNumber,  channel  sendBDC,  channel  sendStop )  {
   int i ;

  BDChannel bdc = new BDChannel ( )   ;

  BDChannel interact_bdc = new BDChannel ( )   ;

  sendBDC.Send ( new object[] {  myNumber   , bdc   , interact_bdc    } )
  ;
 BDChannel[] interact_bdchans = (BDChannel[])bdc.Receive  .Get(new object[]{ } )
;

  for ( i = 0  ; i  < interact_bdchans.Length ; i++   )
 if ( i  != myNumber   )
   interact_bdchans[ i   ].Send.Send ( new object[] {  myNumber    } )
  ;

 
  for ( i = 0  ; i  < interact_bdchans.Length - 1 ; i++   )
 Console.WriteLine( myNumber + " <- " + interact_bdc.Receive  .Get(new object[]{ } )
 )  ;

  sendStop.Send ( new object[] {   } )
  ;
 }
}

