using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class Fib : ISerializable {

 //-------------- MCsharp functions -----------

 public Fib ( ) {
  mcsharp_initiate();
}

 public Fib ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  c1 = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc1" );
  mcsharpQueueGet = new MCSharp.ThreadQ();

  Get = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerGet" );
 }

 public void Compute (  int n,  channel  c )  {
   MCSharp.TCP.DeliverMovableMethod ( this,"Compute_Body_MCSharpWrapper", new object[] {n, c} );
 }

 public void Compute_Body_MCSharpWrapper (  int n,  channel  c )  {
   Console.WriteLine( "Movable -> n = " + n   )  ;
 if ( n  < 44  )
    {
   Console.WriteLine( "Local -> n = " + n   )  ;
 c.Send ( new object[] {  cfib( n   )    } )
  ;
 }

  else
  {
   Console.WriteLine( "Local -> n = " + ( n - 2   )   )  ;
 new Fib ( ) .Compute( n - 1   , c1   )  ;
 c.Send ( new object[] {  cfib( n - 2   ) + (int)Get  .Get(new object[]{ } )
  } )
  ;
 }
 
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel c1;

 //-------------Handler declaration-----------------

    public MCSharp.handler Get;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueGet;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Get = 1 << 0;
 private const int mcsharp_mask_c1 = 1 << 1;
 private const int mcsharp_mask_Getc1 =
            mcsharp_mask_Get
          | mcsharp_mask_c1;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskGetc1 = new MCSharp.BitMask();

 private void scanGetc1 () {
  if ( mcsharpBitMaskGetc1.match
        ( mcsharp_mask_Getc1 ) )
   mcsharpQueueGet.wakeup();
 }


[OneWay]
public void mcsharpChannelc1 (  int x )  {
   lock ( mcsharpQueueGet ) {
    c1.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskGetc1.match
          ( mcsharp_mask_c1 ) )   {
     mcsharpBitMaskGetc1.set ( mcsharp_mask_c1 );
     scanGetc1 ();
    }
   }
 }

 public int mcsharpHandlerGet (  )   {
  Monitor.Enter ( mcsharpQueueGet );
  if ( ! mcsharpBitMaskGetc1.match ( mcsharp_mask_Get ) ) goto now;
  later:
   mcsharpQueueGet.yield ( mcsharpQueueGet );
   if ( mcsharpQueueGet.empty )
    mcsharpBitMaskGetc1.clear ( mcsharp_mask_Get );
  now:
   if ( mcsharpBitMaskGetc1.match ( 
    mcsharp_mask_c1 ) )   {
    object[] oc1 = ( object[] ) c1.Dequeue();
    int x = ( int ) oc1 [ 0 ];
    if ( c1.Count == 0 )
         mcsharpBitMaskGetc1.clear ( mcsharp_mask_c1 );
    scanGetc1 ();
    Monitor.Exit ( mcsharpQueueGet );
     {
   return x  ;
  }
   }
   else {
    mcsharpBitMaskGetc1.set ( mcsharp_mask_Get );
    goto later;
  }

 }
private  int cfib (  int n )   {
   if ( n  <= 1  )
   return ( n   )  ;
 
  else
 return ( cfib( n - 1   ) + cfib( n - 2   )   )  ;
  
 }
}

[Serializable()]
 class ComputeFib : ISerializable {

 //-------------- MCsharp functions -----------

 public ComputeFib ( ) {
  mcsharp_initiate();
}

 public ComputeFib ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  c = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc" );
  mcsharpQueueGet = new MCSharp.ThreadQ();

  Get = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerGet" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   if ( args.Length  < 1  )
    {
   Console.WriteLine( "Usage: FibAdv.exe <number>"   )  ;
 return ;
  }

  int n = System.Convert.ToInt32( args[ 0   ]   )  ;

  ComputeFib cf = new ComputeFib ( )   ;

  Fib fib = new Fib ( )   ;

  fib.Compute( n   , cf.c   )  ;
 Console.WriteLine( "For n = " + n + " value is " + cf.Get  .Get(new object[]{ } )
 )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel c;

 //-------------Handler declaration-----------------

    public MCSharp.handler Get;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueGet;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Get = 1 << 0;
 private const int mcsharp_mask_c = 1 << 1;
 private const int mcsharp_mask_Getc =
            mcsharp_mask_Get
          | mcsharp_mask_c;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskGetc = new MCSharp.BitMask();

 private void scanGetc () {
  if ( mcsharpBitMaskGetc.match
        ( mcsharp_mask_Getc ) )
   mcsharpQueueGet.wakeup();
 }


[OneWay]
public void mcsharpChannelc (  int x )  {
   lock ( mcsharpQueueGet ) {
    c.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskGetc.match
          ( mcsharp_mask_c ) )   {
     mcsharpBitMaskGetc.set ( mcsharp_mask_c );
     scanGetc ();
    }
   }
 }

 public int mcsharpHandlerGet (  )   {
  Monitor.Enter ( mcsharpQueueGet );
  if ( ! mcsharpBitMaskGetc.match ( mcsharp_mask_Get ) ) goto now;
  later:
   mcsharpQueueGet.yield ( mcsharpQueueGet );
   if ( mcsharpQueueGet.empty )
    mcsharpBitMaskGetc.clear ( mcsharp_mask_Get );
  now:
   if ( mcsharpBitMaskGetc.match ( 
    mcsharp_mask_c ) )   {
    object[] oc = ( object[] ) c.Dequeue();
    int x = ( int ) oc [ 0 ];
    if ( c.Count == 0 )
         mcsharpBitMaskGetc.clear ( mcsharp_mask_c );
    scanGetc ();
    Monitor.Exit ( mcsharpQueueGet );
     {
   return x  ;
  }
   }
   else {
    mcsharpBitMaskGetc.set ( mcsharp_mask_Get );
    goto later;
  }

 }
}

