using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class Task : ISerializable {

 //-------------- MCsharp functions -----------

 public Task ( ) {
  mcsharp_initiate();
}

 public Task ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public  int left , down , right ;

 public  Task (  int l,  int d,  int r )  {

   mcsharp_initiate();

    left = l  ;
 down = d  ;
 right = r  ;


 }

}

[Serializable()]
public  class NQueens : ISerializable {

 //-------------- MCsharp functions -----------

 public NQueens ( ) {
  mcsharp_initiate();
}

 public NQueens ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendTask = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendTask" );
  mcsharpQueuegetTask = new MCSharp.ThreadQ();

  getTask = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetTask" );
  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

public static  long totalCount = 0  ;

 public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int N = System.Convert.ToInt32( args[ 0   ]   )  ;

  int M = System.Convert.ToInt32( args[ 1   ]   )  ;

  int P = System.Convert.ToInt32( args[ 2   ]   )  ;

  NQueens nqueens = new NQueens ( )   ;

  nqueens.launchWorkers( N   , M   , P   , nqueens.getTask   , nqueens.sendStop   , nqueens   )  ;
 nqueens.generateTasks( N   , M   , P   , nqueens.sendTask   )  ;
 for ( int i = 0  ;

  i  < P ; i++   )
 nqueens.getStop  .Get(new object[]{ } )
;

  Console.Write( "Task challenge : " + N + "   "   )  ;
 Console.WriteLine( "Solutions = " + totalCount   )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendTask;

 //-------------Handler declaration-----------------

    public MCSharp.handler getTask;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetTask;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getTask = 1 << 0;
 private const int mcsharp_mask_sendTask = 1 << 1;
 private const int mcsharp_mask_getTasksendTask =
            mcsharp_mask_getTask
          | mcsharp_mask_sendTask;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetTasksendTask = new MCSharp.BitMask();

 private void scangetTasksendTask () {
  if ( mcsharpBitMaskgetTasksendTask.match
        ( mcsharp_mask_getTasksendTask ) )
   mcsharpQueuegetTask.wakeup();
 }


[OneWay]
public void mcsharpChannelsendTask (  Task task )  {
   lock ( mcsharpQueuegetTask ) {
    sendTask.Enqueue ( new object [] { task } );
    if ( ! mcsharpBitMaskgetTasksendTask.match
          ( mcsharp_mask_sendTask ) )   {
     mcsharpBitMaskgetTasksendTask.set ( mcsharp_mask_sendTask );
     scangetTasksendTask ();
    }
   }
 }

 public Task mcsharpHandlergetTask (  int count )   {
  Monitor.Enter ( mcsharpQueuegetTask );
  if ( ! mcsharpBitMaskgetTasksendTask.match ( mcsharp_mask_getTask ) ) goto now;
  later:
   mcsharpQueuegetTask.yield ( mcsharpQueuegetTask );
   if ( mcsharpQueuegetTask.empty )
    mcsharpBitMaskgetTasksendTask.clear ( mcsharp_mask_getTask );
  now:
   if ( mcsharpBitMaskgetTasksendTask.match ( 
    mcsharp_mask_sendTask ) )   {
    object[] osendTask = ( object[] ) sendTask.Dequeue();
    Task task = ( Task ) osendTask [ 0 ];
    if ( sendTask.Count == 0 )
         mcsharpBitMaskgetTasksendTask.clear ( mcsharp_mask_sendTask );
    scangetTasksendTask ();
    Monitor.Exit ( mcsharpQueuegetTask );
     {
   totalCount += count  ;
 return ( task   )  ;
  }
   }
   else {
    mcsharpBitMaskgetTasksendTask.set ( mcsharp_mask_getTask );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
  private class McsharpPrivateClasslaunchWorkers {

   NQueens parent;
   int N;
   int M;
   int P;
   handler  getTask;
   channel  sendStop;
   NQueens nqueens;

   public McsharpPrivateClasslaunchWorkers ( NQueens parent,
               int N,
               int M,
               int P,
               handler  getTask,
               channel  sendStop,
               NQueens nqueens
              ) {
    this.parent = parent;
    this.N = N;
    this.M = M;
    this.P = P;
    this.getTask = getTask;
    this.sendStop = sendStop;
    this.nqueens = nqueens;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharplaunchWorkersBody ( N, M, P, getTask, sendStop, nqueens );

   }
  }

  private void mcsharplaunchWorkersBody (
               int N,
               int M,
               int P,
               handler  getTask,
               channel  sendStop,
               NQueens nqueens
              )
 {
   for ( int i = 0  ;

  i  < P ; i++   )
 nqueens.Worker( i   , N   , M   , getTask   , sendStop   )  ;

  }




  public  void launchWorkers (  int N,  int M,  int P,  handler  getTask,  channel  sendStop,  NQueens nqueens ) {
   McsharpPrivateClasslaunchWorkers prclassobject = new McsharpPrivateClasslaunchWorkers ( this, N, M, P, getTask, sendStop, nqueens );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
public  void generateTasks (  int N,  int M,  int P,  channel  sendTask )   {
   int y = 0  ;

  int left = 0  ;

  int down = 0  ;

  int right = 0  ;

  int MASK = ( 1 << N  ) - 1  ;

  MainBacktrack( y   , left   , down   , right   , MASK   , M   , sendTask   )  ;
 Task finish_marker = new Task ( -1   , -1   , -1   )   ;

  for ( int i = 0  ;

  i  < P ; i++   )
 sendTask.Send ( new object[] {  finish_marker    } )
  ;

  }
public  void MainBacktrack (  int y,  int left,  int down,  int right,  int MASK,  int M,  channel  sendTask )   {
   int bitmap , bit ;

  if ( y  == M   )
   sendTask.Send ( new object[] {  new Task ( left   , down   , right   )     } )
  ;

  else
  {
   bitmap = MASK  & ~( left  | down  | right   )  ;
 while ( bitmap  != 0   )
  {
   bit = -bitmap  & bitmap  ;
 bitmap = bitmap  ^ bit  ;
 MainBacktrack( y + 1   , ( left  | bit   ) << 1  , down  | bit   , ( right  | bit   ) >> 1  , MASK   , M   , sendTask   )  ;
 }

  }
 
 }
 public void Worker (  int myNumber,  int N,  int M,  handler  getTask,  channel  sendStop )  {
   MCSharp.TCP.DeliverMovableMethod ( this,"Worker_Body_MCSharpWrapper", new object[] {myNumber, N, M, getTask, sendStop} );
 }

 public void Worker_Body_MCSharpWrapper (  int myNumber,  int N,  int M,  handler  getTask,  channel  sendStop )  {
   int MASK = ( 1 << N  ) - 1  ;

  int count = 0  ;

  Task task = (Task)getTask  .Get(new object[]{ count   } )
;

  while ( task.left  != -1   )
  {
   WorkerBacktrack( M   , task.left   , task.down   , task.right   , MASK   , N   , ref count   )  ;
 task = (Task)getTask  .Get(new object[]{ count   } )
;
 count = 0  ;
 }

  sendStop.Send ( new object[] {   } )
  ;
 }
public  void WorkerBacktrack (  int y,  int left,  int down,  int right,  int MASK,  int N, ref  int count )   {
   int bitmap , bit ;

  if ( y  == N   )
   count++  ;

  else
  {
   bitmap = MASK  & ~( left  | down  | right   )  ;
 while ( bitmap  != 0   )
  {
   bit = -bitmap  & bitmap  ;
 bitmap = bitmap  ^ bit  ;
 WorkerBacktrack( y + 1   , ( left  | bit   ) << 1  , down  | bit   , ( right  | bit   ) >> 1  , MASK   , N   , ref count   )  ;
 }

  }
 
 }
}

