using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
 class Eratosthenes : ISerializable {

 //-------------- MCsharp functions -----------

 public Eratosthenes ( ) {
  mcsharp_initiate();
}

 public Eratosthenes ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  Nats = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelNats" );
  mcsharpQueuegetNat = new MCSharp.ThreadQ();

  getNat = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetNat" );
  sendPrime = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendPrime" );
  mcsharpQueuegetPrime = new MCSharp.ThreadQ();

  getPrime = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetPrime" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   if ( args.Length  < 1  )
    {
   Console.WriteLine( "Usage: primeNumberSieve.exe <number>"   )  ;
 return ;
  }

  int N = System.Convert.ToInt32( args[ 0   ]   )  ;

  Eratosthenes E = new Eratosthenes ( )   ;

  new CSieve ( ) .Sieve( E.getNat   , E.sendPrime   )  ;
 for ( int n = 2  ;

  n  <= N ; n++   )
 E.Nats.Send ( new object[] {  n    } )
  ;

  E.Nats.Send ( new object[] {  -1    } )
  ;
 int p = 0  ;

  while ( ( p = (int)E.getPrime  .Get(new object[]{ } )
 )  != -1   )
 Console.WriteLine( p   )  ;

  }

 //-------------Channel declarations-----------------

  public MCSharp.channel Nats;

 //-------------Handler declaration-----------------

    public MCSharp.handler getNat;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetNat;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getNat = 1 << 0;
 private const int mcsharp_mask_Nats = 1 << 1;
 private const int mcsharp_mask_getNatNats =
            mcsharp_mask_getNat
          | mcsharp_mask_Nats;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetNatNats = new MCSharp.BitMask();

 private void scangetNatNats () {
  if ( mcsharpBitMaskgetNatNats.match
        ( mcsharp_mask_getNatNats ) )
   mcsharpQueuegetNat.wakeup();
 }


[OneWay]
public void mcsharpChannelNats (  int n )  {
   lock ( mcsharpQueuegetNat ) {
    Nats.Enqueue ( new object [] { n } );
    if ( ! mcsharpBitMaskgetNatNats.match
          ( mcsharp_mask_Nats ) )   {
     mcsharpBitMaskgetNatNats.set ( mcsharp_mask_Nats );
     scangetNatNats ();
    }
   }
 }

 public int mcsharpHandlergetNat (  )   {
  Monitor.Enter ( mcsharpQueuegetNat );
  if ( ! mcsharpBitMaskgetNatNats.match ( mcsharp_mask_getNat ) ) goto now;
  later:
   mcsharpQueuegetNat.yield ( mcsharpQueuegetNat );
   if ( mcsharpQueuegetNat.empty )
    mcsharpBitMaskgetNatNats.clear ( mcsharp_mask_getNat );
  now:
   if ( mcsharpBitMaskgetNatNats.match ( 
    mcsharp_mask_Nats ) )   {
    object[] oNats = ( object[] ) Nats.Dequeue();
    int n = ( int ) oNats [ 0 ];
    if ( Nats.Count == 0 )
         mcsharpBitMaskgetNatNats.clear ( mcsharp_mask_Nats );
    scangetNatNats ();
    Monitor.Exit ( mcsharpQueuegetNat );
     {
   return ( n   )  ;
  }
   }
   else {
    mcsharpBitMaskgetNatNats.set ( mcsharp_mask_getNat );
    goto later;
  }

 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendPrime;

 //-------------Handler declaration-----------------

    public MCSharp.handler getPrime;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetPrime;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getPrime = 1 << 0;
 private const int mcsharp_mask_sendPrime = 1 << 1;
 private const int mcsharp_mask_getPrimesendPrime =
            mcsharp_mask_getPrime
          | mcsharp_mask_sendPrime;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetPrimesendPrime = new MCSharp.BitMask();

 private void scangetPrimesendPrime () {
  if ( mcsharpBitMaskgetPrimesendPrime.match
        ( mcsharp_mask_getPrimesendPrime ) )
   mcsharpQueuegetPrime.wakeup();
 }


[OneWay]
public void mcsharpChannelsendPrime (  int p )  {
   lock ( mcsharpQueuegetPrime ) {
    sendPrime.Enqueue ( new object [] { p } );
    if ( ! mcsharpBitMaskgetPrimesendPrime.match
          ( mcsharp_mask_sendPrime ) )   {
     mcsharpBitMaskgetPrimesendPrime.set ( mcsharp_mask_sendPrime );
     scangetPrimesendPrime ();
    }
   }
 }

 public int mcsharpHandlergetPrime (  )   {
  Monitor.Enter ( mcsharpQueuegetPrime );
  if ( ! mcsharpBitMaskgetPrimesendPrime.match ( mcsharp_mask_getPrime ) ) goto now;
  later:
   mcsharpQueuegetPrime.yield ( mcsharpQueuegetPrime );
   if ( mcsharpQueuegetPrime.empty )
    mcsharpBitMaskgetPrimesendPrime.clear ( mcsharp_mask_getPrime );
  now:
   if ( mcsharpBitMaskgetPrimesendPrime.match ( 
    mcsharp_mask_sendPrime ) )   {
    object[] osendPrime = ( object[] ) sendPrime.Dequeue();
    int p = ( int ) osendPrime [ 0 ];
    if ( sendPrime.Count == 0 )
         mcsharpBitMaskgetPrimesendPrime.clear ( mcsharp_mask_sendPrime );
    scangetPrimesendPrime ();
    Monitor.Exit ( mcsharpQueuegetPrime );
     {
   return ( p   )  ;
  }
   }
   else {
    mcsharpBitMaskgetPrimesendPrime.set ( mcsharp_mask_getPrime );
    goto later;
  }

 }
}

[Serializable()]
 class CSieve : ISerializable {

 //-------------- MCsharp functions -----------

 public CSieve ( ) {
  mcsharp_initiate();
}

 public CSieve ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  cout = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelcout" );
  mcsharpQueuehin = new MCSharp.ThreadQ();

  hin = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerhin" );
 }

 public void Sieve (  handler  getList,  channel  sendPrime )  {
   MCSharp.TCP.DeliverMovableMethod ( this,"Sieve_Body_MCSharpWrapper", new object[] {getList, sendPrime} );
 }

 public void Sieve_Body_MCSharpWrapper (  handler  getList,  channel  sendPrime )  {
   int p = (int)getList  .Get(new object[]{ } )
;

  sendPrime.Send ( new object[] {  p    } )
  ;
 if ( p  != -1   )
    {
   new CSieve ( ) .Sieve( hin   , sendPrime   )  ;
 filter( p   , getList   , cout   )  ;
 }

  }

 //-------------Channel declarations-----------------

  public MCSharp.channel cout;

 //-------------Handler declaration-----------------

    public MCSharp.handler hin;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuehin;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_hin = 1 << 0;
 private const int mcsharp_mask_cout = 1 << 1;
 private const int mcsharp_mask_hincout =
            mcsharp_mask_hin
          | mcsharp_mask_cout;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskhincout = new MCSharp.BitMask();

 private void scanhincout () {
  if ( mcsharpBitMaskhincout.match
        ( mcsharp_mask_hincout ) )
   mcsharpQueuehin.wakeup();
 }


[OneWay]
public void mcsharpChannelcout (  int x )  {
   lock ( mcsharpQueuehin ) {
    cout.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskhincout.match
          ( mcsharp_mask_cout ) )   {
     mcsharpBitMaskhincout.set ( mcsharp_mask_cout );
     scanhincout ();
    }
   }
 }

 public int mcsharpHandlerhin (  )   {
  Monitor.Enter ( mcsharpQueuehin );
  if ( ! mcsharpBitMaskhincout.match ( mcsharp_mask_hin ) ) goto now;
  later:
   mcsharpQueuehin.yield ( mcsharpQueuehin );
   if ( mcsharpQueuehin.empty )
    mcsharpBitMaskhincout.clear ( mcsharp_mask_hin );
  now:
   if ( mcsharpBitMaskhincout.match ( 
    mcsharp_mask_cout ) )   {
    object[] ocout = ( object[] ) cout.Dequeue();
    int x = ( int ) ocout [ 0 ];
    if ( cout.Count == 0 )
         mcsharpBitMaskhincout.clear ( mcsharp_mask_cout );
    scanhincout ();
    Monitor.Exit ( mcsharpQueuehin );
     {
   return ( x   )  ;
  }
   }
   else {
    mcsharpBitMaskhincout.set ( mcsharp_mask_hin );
    goto later;
  }

 }
 void filter (  int p,  handler  getList,  channel  cfiltered )   {
   int n = 0  ;

  while ( ( n = (int)getList  .Get(new object[]{ } )
 )  != -1   )
 if ( n % p  != 0   )
   cfiltered.Send ( new object[] {  n    } )
  ;

 
  cfiltered.Send ( new object[] {  -1    } )
  ;
 }
}

