using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

[Serializable()]
public  class BinTree : ISerializable {

 //-------------- MCsharp functions -----------

 public BinTree ( ) {
  mcsharp_initiate();
}

 public BinTree ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

 }

public  BinTree left ;

 public  BinTree right ;

 public  int value ;

 public  BinTree (  int depth )  {

   mcsharp_initiate();

    value = 1  ;
 if ( depth  <= 1  )
    {
   left = null  ;
 right = null  ;
 }

  else
  {
   left = new BinTree ( depth - 1   )   ;
 right = new BinTree ( depth - 1   )   ;
 }
 


 }

}

[Serializable()]
public  class SumBinTree : ISerializable {

 //-------------- MCsharp functions -----------

 public SumBinTree ( ) {
  mcsharp_initiate();
}

 public SumBinTree ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  c = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc" );
  mcsharpQueueGet = new MCSharp.ThreadQ();

  Get = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerGet" );
  c1 = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc1" );
  c2 = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelc2" );
  mcsharpQueueGet2 = new MCSharp.ThreadQ();

  Get2 = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlerGet2" );
 }

public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   if ( args.Length  < 1  )
    {
   Console.WriteLine( "Usage: SumBinTree.exe <depth of tree>"   )  ;
 return ;
  }

  int depth = System.Convert.ToInt32( args[ 0   ]   )  ;

  SumBinTree sbt = new SumBinTree ( )   ;

  BinTree btree = new BinTree ( depth   )   ;

  sbt.Sum( btree   , sbt.c   )  ;
 Console.WriteLine( "Sum = " + (int)sbt.Get  .Get(new object[]{ } )
 )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel c;

 //-------------Handler declaration-----------------

    public MCSharp.handler Get;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueGet;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Get = 1 << 0;
 private const int mcsharp_mask_c = 1 << 1;
 private const int mcsharp_mask_Getc =
            mcsharp_mask_Get
          | mcsharp_mask_c;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskGetc = new MCSharp.BitMask();

 private void scanGetc () {
  if ( mcsharpBitMaskGetc.match
        ( mcsharp_mask_Getc ) )
   mcsharpQueueGet.wakeup();
 }


[OneWay]
public void mcsharpChannelc (  int x )  {
   lock ( mcsharpQueueGet ) {
    c.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskGetc.match
          ( mcsharp_mask_c ) )   {
     mcsharpBitMaskGetc.set ( mcsharp_mask_c );
     scanGetc ();
    }
   }
 }

 public int mcsharpHandlerGet (  )   {
  Monitor.Enter ( mcsharpQueueGet );
  if ( ! mcsharpBitMaskGetc.match ( mcsharp_mask_Get ) ) goto now;
  later:
   mcsharpQueueGet.yield ( mcsharpQueueGet );
   if ( mcsharpQueueGet.empty )
    mcsharpBitMaskGetc.clear ( mcsharp_mask_Get );
  now:
   if ( mcsharpBitMaskGetc.match ( 
    mcsharp_mask_c ) )   {
    object[] oc = ( object[] ) c.Dequeue();
    int x = ( int ) oc [ 0 ];
    if ( c.Count == 0 )
         mcsharpBitMaskGetc.clear ( mcsharp_mask_c );
    scanGetc ();
    Monitor.Exit ( mcsharpQueueGet );
     {
   return ( x   )  ;
  }
   }
   else {
    mcsharpBitMaskGetc.set ( mcsharp_mask_Get );
    goto later;
  }

 }
 public void Sum (  BinTree btree,  channel  c )  {
   MCSharp.TCP.DeliverMovableMethod ( this,"Sum_Body_MCSharpWrapper", new object[] {btree, c} );
 }

 public void Sum_Body_MCSharpWrapper (  BinTree btree,  channel  c )  {
   if ( btree.left  == null   )
   c.Send ( new object[] {  btree.value    } )
  ;

  else
  {
   new SumBinTree ( ) .Sum( btree.left   , c1   )  ;
 new SumBinTree ( ) .Sum( btree.right   , c2   )  ;
 c.Send ( new object[] {  (int)Get2  .Get(new object[]{ } )
  } )
  ;
 }
 
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel c1;
  public MCSharp.channel c2;

 //-------------Handler declaration-----------------

    public MCSharp.handler Get2;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueueGet2;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_Get2 = 1 << 0;
 private const int mcsharp_mask_c1 = 1 << 1;
 private const int mcsharp_mask_c2 = 1 << 2;
 private const int mcsharp_mask_Get2c1c2 =
            mcsharp_mask_Get2
          | mcsharp_mask_c1
          | mcsharp_mask_c2;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskGet2c1c2 = new MCSharp.BitMask();

 private void scanGet2c1c2 () {
  if ( mcsharpBitMaskGet2c1c2.match
        ( mcsharp_mask_Get2c1c2 ) )
   mcsharpQueueGet2.wakeup();
 }


[OneWay]
public void mcsharpChannelc1 (  int x )  {
   lock ( mcsharpQueueGet2 ) {
    c1.Enqueue ( new object [] { x } );
    if ( ! mcsharpBitMaskGet2c1c2.match
          ( mcsharp_mask_c1 ) )   {
     mcsharpBitMaskGet2c1c2.set ( mcsharp_mask_c1 );
     scanGet2c1c2 ();
    }
   }
 }

[OneWay]
public void mcsharpChannelc2 (  int y )  {
   lock ( mcsharpQueueGet2 ) {
    c2.Enqueue ( new object [] { y } );
    if ( ! mcsharpBitMaskGet2c1c2.match
          ( mcsharp_mask_c2 ) )   {
     mcsharpBitMaskGet2c1c2.set ( mcsharp_mask_c2 );
     scanGet2c1c2 ();
    }
   }
 }

 public int mcsharpHandlerGet2 (  )   {
  Monitor.Enter ( mcsharpQueueGet2 );
  if ( ! mcsharpBitMaskGet2c1c2.match ( mcsharp_mask_Get2 ) ) goto now;
  later:
   mcsharpQueueGet2.yield ( mcsharpQueueGet2 );
   if ( mcsharpQueueGet2.empty )
    mcsharpBitMaskGet2c1c2.clear ( mcsharp_mask_Get2 );
  now:
   if ( mcsharpBitMaskGet2c1c2.match ( 
    mcsharp_mask_c1 | mcsharp_mask_c2 ) )   {
    object[] oc1 = ( object[] ) c1.Dequeue();
    int x = ( int ) oc1 [ 0 ];
    if ( c1.Count == 0 )
         mcsharpBitMaskGet2c1c2.clear ( mcsharp_mask_c1 );
    object[] oc2 = ( object[] ) c2.Dequeue();
    int y = ( int ) oc2 [ 0 ];
    if ( c2.Count == 0 )
         mcsharpBitMaskGet2c1c2.clear ( mcsharp_mask_c2 );
    scanGet2c1c2 ();
    Monitor.Exit ( mcsharpQueueGet2 );
     {
   return ( x + y   )  ;
  }
   }
   else {
    mcsharpBitMaskGet2c1c2.set ( mcsharp_mask_Get2 );
    goto later;
  }

 }
}

