using System;
using MCSharp;
using System.Reflection;
using System.Threading;
using System.Runtime.Serialization;
using System.Runtime.Remoting.Messaging;

using GpuDotNet.Cuda;
[Serializable()]
public  class MatrixMult : ISerializable {

 //-------------- MCsharp functions -----------

 public MatrixMult ( ) {
  mcsharp_initiate();
}

 public MatrixMult ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.UnPack ( info, context, this );
   }

 public void GetObjectData ( SerializationInfo info, StreamingContext context ) {
  MCSharp.Serialization.Pack ( info, context, this );
 }

 public void mcsharp_initiate ( ) {

  Monitor.Enter ( CommExec.Objects );
  int mcObjectNumber = CommExec.Objects.Count + 1;
  CommExec.Objects.Add ( mcObjectNumber, this );
  Monitor.Exit ( CommExec.Objects );

  sendStop = new MCSharp.channel ( this, mcObjectNumber, "mcsharpChannelsendStop" );
  mcsharpQueuegetStop = new MCSharp.ThreadQ();

  getStop = new MCSharp.handler ( this, mcObjectNumber, "mcsharpHandlergetStop" );
 }

static  int WA = 1024  ;

 static  int HA = 1024  ;

 static  int WB = 1024  ;

 static  int HB = WA  ;

 static  int WC = WB  ;

 static  int HC = HA  ;

 public static  void Main (  String[] args )  {

  if ( ! MCSharp.Session.Init ( args ) ) return;

  Main_MCSharp_Wrapper ( args );

  MCSharp.Session.FinalizeIt();

 }

 private static void Main_MCSharp_Wrapper (  String[] args )  {
   int i , j ;

  int D = 1  ;

  DateTime dt1 , dt2 ;

  if ( args.Length  > 0  )
    {
   HA = Convert.ToInt32( args[ 0   ]   )  ;
 WA = Convert.ToInt32( args[ 1   ]   )  ;
 HB = WA  ;
 WB = Convert.ToInt32( args[ 2   ]   )  ;
 HC = WA  ;
 WC = WB  ;
 D = Convert.ToInt32( args[ 3   ]   )  ;
 }

  Console.WriteLine( "HA=" + HA + " WA=" + WA + " HB=" + HB + " WB=" + WB   )  ;
 Console.WriteLine( "D = " + D   )  ;
 double[][] A = new double [ D   ] []    ;

  for ( i = 0  ; i  < D ; i++   )
 A[ i   ] = new double [ ( HA / D   ) * WA   ]    ;

  double[] B = new double [ HB * WB   ]    ;

  double[][] C = new double [ D   ] []    ;

  for ( i = 0  ; i  < D ; i++   )
 C[ i   ] = new double [ ( HC / D   ) * WC   ]    ;

  for ( i = 0  ; i  < D ; i++   )
 for ( j = 0  ; j  < ( HA / D   ) * WA ; j++   )
 A[ i   ][ j   ] = 0.1  ;

 
  for ( i = 0  ; i  < HB * WB ; i++   )
 B[ i   ] = 0.2  ;

  for ( i = 0  ; i  < D ; i++   )
 for ( j = 0  ; j  < ( HC / D   ) * WC ; j++   )
 C[ i   ][ j   ] = 0.0  ;

 
  dt1 = DateTime.Now  ;
 MatrixMult mm = new MatrixMult ( )   ;

  for ( i = 0  ; i  < D ; i++   )
 mm.multiply( i   , A[ i   ]   , B   , C[ i   ]   , HA / D   , WA   , WB   , mm.sendStop   )  ;

  for ( i = 0  ; i  < D ; i++   )
 mm.getStop  .Get(new object[]{ } )
;

  dt2 = DateTime.Now  ;
 Console.WriteLine( "Elapsed time = " + ( dt2 - dt1   ).TotalSeconds + " secs."   )  ;
 Console.WriteLine( "C [ 0, 0 ] = " + C[ 0   ][ 0   ]   )  ;
 }

 //-------------Channel declarations-----------------

  public MCSharp.channel sendStop;

 //-------------Handler declaration-----------------

    public MCSharp.handler getStop;


 //-------------Queues------------------------------

 [NonSerialized] private MCSharp.ThreadQ mcsharpQueuegetStop;


 //-------------Masks--------------------------------

 private const int mcsharp_mask_getStop = 1 << 0;
 private const int mcsharp_mask_sendStop = 1 << 1;
 private const int mcsharp_mask_getStopsendStop =
            mcsharp_mask_getStop
          | mcsharp_mask_sendStop;
 [NonSerialized] private MCSharp.BitMask mcsharpBitMaskgetStopsendStop = new MCSharp.BitMask();

 private void scangetStopsendStop () {
  if ( mcsharpBitMaskgetStopsendStop.match
        ( mcsharp_mask_getStopsendStop ) )
   mcsharpQueuegetStop.wakeup();
 }


[OneWay]
public void mcsharpChannelsendStop (  )  {
   lock ( mcsharpQueuegetStop ) {
    sendStop.Enqueue ( new object [] {  } );
    if ( ! mcsharpBitMaskgetStopsendStop.match
          ( mcsharp_mask_sendStop ) )   {
     mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_sendStop );
     scangetStopsendStop ();
    }
   }
 }

 public void mcsharpHandlergetStop (  )   {
  Monitor.Enter ( mcsharpQueuegetStop );
  if ( ! mcsharpBitMaskgetStopsendStop.match ( mcsharp_mask_getStop ) ) goto now;
  later:
   mcsharpQueuegetStop.yield ( mcsharpQueuegetStop );
   if ( mcsharpQueuegetStop.empty )
    mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_getStop );
  now:
   if ( mcsharpBitMaskgetStopsendStop.match ( 
    mcsharp_mask_sendStop ) )   {
    object[] osendStop = ( object[] ) sendStop.Dequeue();
    if ( sendStop.Count == 0 )
         mcsharpBitMaskgetStopsendStop.clear ( mcsharp_mask_sendStop );
    scangetStopsendStop ();
    Monitor.Exit ( mcsharpQueuegetStop );
     {
   return ;
  }
   }
   else {
    mcsharpBitMaskgetStopsendStop.set ( mcsharp_mask_getStop );
    goto later;
  }

 }
  private class McsharpPrivateClassmultiply {

   MatrixMult parent;
   int myNum;
   double[] A;
   double[] B;
   double[] C;
   int HA;
   int WA;
   int WB;
   channel  sendStop;

   public McsharpPrivateClassmultiply ( MatrixMult parent,
               int myNum,
               double[] A,
               double[] B,
               double[] C,
               int HA,
               int WA,
               int WB,
               channel  sendStop
              ) {
    this.parent = parent;
    this.myNum = myNum;
    this.A = A;
    this.B = B;
    this.C = C;
    this.HA = HA;
    this.WA = WA;
    this.WB = WB;
    this.sendStop = sendStop;
   }

   public void run() {

   MCSharp.ThreadManager.SetThreadAffinityMask();

    parent.mcsharpmultiplyBody ( myNum, A, B, C, HA, WA, WB, sendStop );

   }
  }

  private void mcsharpmultiplyBody (
               int myNum,
               double[] A,
               double[] B,
               double[] C,
               int HA,
               int WA,
               int WB,
               channel  sendStop
              )
 {
   Gpu.callGpu( myNum   , A   , B   , C   , HA   , WA   , WB   )  ;
 sendStop.Send ( new object[] {   } )
  ;
 }




  public  void multiply (  int myNum,  double[] A,  double[] B,  double[] C,  int HA,  int WA,  int WB,  channel  sendStop ) {
   McsharpPrivateClassmultiply prclassobject = new McsharpPrivateClassmultiply ( this, myNum, A, B, C, HA, WA, WB, sendStop );
   ThreadStart tstart = new ThreadStart ( prclassobject.run );
   ( new Thread ( tstart ) ).Start();
  }
}

[Serializable()]
public static  class Gpu {

private const  int BLOCK_SIZE = 16  ;

 public static  void callGpu (  int myNum,  double[] A,  double[] B,  double[] C,  int HA,  int WA,  int WB )   {
   GpuConfig gpuconfig = new GpuConfig ( )   ;

  gpuconfig.SetDeviceNumber( myNum   )  ;
 gpuconfig.SetBlockSize( BLOCK_SIZE   , BLOCK_SIZE   )  ;
 gpuconfig.SetGridSize( WB / BLOCK_SIZE   , HA / BLOCK_SIZE   )  ;
 gpuconfig.MatrixMul( C   , A   , B   , WA   , WB   )  ;
 }
[ StaticArray (BLOCK_SIZE * BLOCK_SIZE    ) ]  private static  Shared1D<double> As ;

 [ StaticArray (BLOCK_SIZE * BLOCK_SIZE    ) ]  private static  Shared1D<double> Bs ;

  public delegate void _Gpu_MatrixMul_delegate (  double[] C,  double[] A,  double[] B,  int wA,  int wB ) ;

 public static void MatrixMul ( this GpuConfig gpuconfig,   double[] C,  double[] A,  double[] B,  int wA,  int wB )  
 {
  _Gpu_MatrixMul_delegate gpu_method_delegate = _Gpu_gpu_MatrixMul;
  GpuRuntime.PrepareAndCallGpuMethod ( gpuconfig, gpu_method_delegate, C, A, B, wA, wB );
 }

 public static void _Gpu_gpu_MatrixMul (  double[] C,  double[] A,  double[] B,  int wA,  int wB ) 
 {
   int bx = BlockIndex.X  ;

  int by = BlockIndex.Y  ;

  int tx = ThreadIndex.X  ;

  int ty = ThreadIndex.Y  ;

  int aBegin = wA * BLOCK_SIZE * by  ;

  int aEnd = aBegin + wA - 1  ;

  int aStep = BLOCK_SIZE  ;

  int bBegin = BLOCK_SIZE * bx  ;

  int bStep = BLOCK_SIZE * wB  ;

  double Csub = 0  ;

  for ( int a = aBegin  , b = bBegin  ;

  a  <= aEnd ; a += aStep  , b += bStep   )
  {
   As[ ty * BLOCK_SIZE + tx   ] = A[ a + wA * ty + tx   ]  ;
 Bs[ ty * BLOCK_SIZE + tx   ] = B[ b + wB * ty + tx   ]  ;
 CudaRuntime.SyncThreads( )  ;
 for ( int k = 0  ;

  k  < BLOCK_SIZE ; ++k   )
 Csub += As[ ty * BLOCK_SIZE + k   ] * Bs[ k * BLOCK_SIZE + tx   ]  ;

  CudaRuntime.SyncThreads( )  ;
 }

  int c = wB * BLOCK_SIZE * by + BLOCK_SIZE * bx  ;

  C[ c + wB * ty + tx   ] = Csub  ;
 }

}

