using System;
using GpuDotNet.Cuda;

public class GPUMath {
 
 ////////////////////////////////////////////////////////////
 //
 //         Single precision mathematical functions 
 //
 ///////////////////////////////////////////////////////////
 
 public static float sqrtf ( float x )
 {
    return CudaMath.sqrtf ( x );
 }
 public static float sinf ( float x )
 {
    return CudaMath.sinf ( x );
 }
 public static float cosf ( float x )
 {
    return CudaMath.cosf ( x );
 }
 public static float log2f ( float x )
 {
    return CudaMath.log2f ( x );
 }
 public static float exp2f ( float x )
 {
    return CudaMath.exp2f ( x );
 }
 public static float fabsf ( float x )
 {
    return CudaMath.absf ( x );
 }
 
 /////////////////////////////////////////////////////////
 //
 //         Double precision mathematical functions
 //
 ////////////////////////////////////////////////////////
 
 public static double sqrt ( double x )
 {
    return CudaMath.sqrt ( x );
 } 
 public static double sin ( double x )
 { 
    return (double) (CudaMath.sinf ( (float) x ) );  
 } 
 public static double cos ( double x )
 {
    return (double) (CudaMath.cosf ( (float) x ) );
 }
 public static double fabs ( double x )
 {
    return CudaMath.abs ( x );
 }
 
 /////////////////////////////////////////////////////////////////
 //
 //        Single precision intrinsics ( mathematical functions ) 
 //
 ////////////////////////////////////////////////////////////////
 
 public static float __logf ( float x )
 {
    return CudaMath.log2f ( x ) * 0.693147f;
 }
 public static float __expf ( float x )
 {
    return CudaMath.exp2f ( x * 1.4427f );
 } 

}
