//
// Copyright (C) 2009 Yury Serdyuk
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using System;
using System.IO;
using System.Threading;
using System.Collections;
using System.Net.Sockets;
using System.Reflection;

namespace MCSharp {
 public class CommExec {
  protected static Thread CommExecThread;
  protected static Queue clients = new Queue();
  public static Hashtable Objects = new Hashtable( 5000 );

  public static void Init() {
   CommExecThread = new Thread( new ThreadStart( CommExec.Launch ) );
   CommExecThread.Start();
  }

  private static bool NeedToContinue = true;

  private static void Launch() {
   NeedToContinue = true;
   while ( NeedToContinue ) {
    while ( clients.Count == 0 && NeedToContinue ) Thread.Sleep( 5 );
    if ( !NeedToContinue ) return;
    
    Monitor.Enter ( clients );
    Socket client = (Socket) clients.Dequeue();
    Monitor.Exit  ( clients );
    
    int bufLength = int.Parse( TCP.ReadLine( client ) );
    MemoryStream ms = new MemoryStream( bufLength );
    TCP.ReadDataToStream( client, ms );
    client.Close();
    MCStatistics.CurrentStatistics.totalSizeOfChannelMessagesAcrossNetwork += ms.Length;
    MCStatistics.CurrentStatistics.numberOfChannelMessagesAcrossNetwork++;
    ms.Seek( 0, SeekOrigin.Begin );
    Agent agent = (MCSharp.Agent) Serialization.Deserialize( ms );
    new ChannelMessageHandler( agent ).Start();
   }
  }

  public static void FinalizeIt() {
   NeedToContinue = false;
  }
  
  public static void EnqueueChannelMessage( Socket client ) {
   Monitor.Enter   ( clients );
   clients.Enqueue ( client );
   Monitor.Exit    ( clients );
  }
 }
}
