//
// Copyright (C) 2012 Yury Serdyuk
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
public class GpuConfig {

 private int deviceNumber;
 private int gridSizeX, gridSizeY;
 private int blockSizeX, blockSizeY, blockSizeZ;

 public GpuConfig () {

  deviceNumber = 0;

  gridSizeX  = 1;
  gridSizeY  = 1;

  blockSizeX = 1;
  blockSizeY = 1;
  blockSizeZ = 1;
 }

 public void SetBlockSize ( int x ) {
  blockSizeX = x;
 }
 
 public void SetBlockSize ( int x, int y ) {
  blockSizeX = x;
  blockSizeY = y;
 }
 
 public void SetBlockSize ( int x, int y, int z ) {
  blockSizeX = x;
  blockSizeY = y;
  blockSizeZ = z;
 }
 
 public void SetGridSize ( int x ) {
  gridSizeX = x;
 }
 
 public void SetGridSize ( int x, int y ) {
  gridSizeX = x;
  gridSizeY = y;
 }
 
 public void SetDeviceNumber ( int d ) {
  deviceNumber = d;
 }
 
 public int GetDeviceNumber () {
  return deviceNumber;
 }

 public int GetGridSizeX() { return gridSizeX; }
 public int GetGridSizeY() { return gridSizeY; }

 public int GetBlockSizeX() { return blockSizeX; }
 public int GetBlockSizeY() { return blockSizeY; }
 public int GetBlockSizeZ() { return blockSizeZ; }

}
