//
// Copyright (C) 2009 Yury Serdyuk
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using System;
using System.Threading;
using System.Net.Sockets;

namespace MCSharp 
{
 public class MCException 
 {
  public static string lockString = "";
  public static void WriteException( string code, string message, Exception e ) 
  {
   if ( message == null || message.Equals( "" ) ) message = "No description available!";
   string toWrite = "";
   toWrite += "Error " + code + ": " + message + "\n";
   if ( e != null ) {
    try {
     toWrite += "  Error type: " + e.GetType() + "\n";
    }
    catch {}
    try {
     toWrite += "  Error message: " + e.Message + "\n";
    }
    catch {}
    try {
     toWrite += "  Error source: " + e.Source + "\n";
    }
    catch {}
    try {
     toWrite += "  Error stack trace: " + Environment.NewLine + 
      e.StackTrace.Trim() + "\n";
    }
    catch {}
    try {
     toWrite += "  Environment.StackTrace: " + Environment.StackTrace + "\n";
    }
    catch {}
    try {
     toWrite += "  Inner exception: " + e.InnerException + "\n";
    }
    catch {}
   }
   
   Monitor.Enter( lockString );
   Console.WriteLine( toWrite );
   Monitor.Exit( lockString );
  }
 }
}
