//
// Copyright (C) 2009 Yury Serdyuk
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using System.Threading;
using System;
using System.IO;
using System.Reflection;

namespace MCSharp {
 class MovableMethodHandler {
  private MCSharp.Agent agent;

  private MovableMethodHandler() {}

  public MovableMethodHandler( Agent agent ) {
   this.agent = agent;
  }
  
  public void Start() {
   
   ThreadManager.SetThreadAffinityMask();
   
   try {
    Type t = agent.Obj.GetType();
    MethodInfo mi = t.GetMethod( agent.MethodName );
    mi.Invoke( agent.Obj, agent.Parameters );        
   }
   //catch ( ThreadAbortException ) {}
   //catch ( AppDomainUnloadedException ) {}
   catch ( Exception e ) {
    Console.WriteLine ( "EXCEPTION: " + e.Message );
    if ( !Session.Finalized ) {
     MCException.WriteException( "MMH0001", "", e );
     MCException.WriteException( "MMH0001-inner", "", e.InnerException );
    }
   }
  }
  
  public void StartInNewThread() {
   Thread t = new Thread( new ThreadStart( Start ) );
   t.Start();
  }
 }
}
