//
// Copyright (C) 2009 Yury Serdyuk
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using System.Collections;
using System.Threading;
using System;

namespace MCSharp {
 public class ThreadQItem {
  public Thread t;
  public ManualResetEvent mEvent;
  public ThreadQItem( Thread t ) {
   this.t = t;
   this.mEvent = new ManualResetEvent( false );
  }
 }

 public class ThreadQ {
  public Queue q;
  public ThreadQ() { q = new Queue(); }
  public bool empty { get { return (q.Count == 0); } }
  public void yield( object currentLock ) {
   ThreadQItem tqi = new ThreadQItem( Thread.CurrentThread );
   q.Enqueue( tqi );
   Monitor.Exit( currentLock );
   
   tqi.mEvent.WaitOne();
   Monitor.Enter( currentLock );
  }

  public void wakeup() { ((ThreadQItem) q.Dequeue()).mEvent.Set(); }

  internal int Count { get { return q.Count; } }
 }
}
