//
// Copyright (C) 2009 Yury Serdyuk
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

using System;
using System.IO;
using MCSharp;
using System.Text;

public class RMInstallUtil {
 public static void Main( string[] args ) {
  string homepath = Environment.GetEnvironmentVariable( "HOME" );
  if ( !homepath.EndsWith( "" + Path.DirectorySeparatorChar ) ) 
   homepath += "" + Path.DirectorySeparatorChar;
  
  string dir = homepath + ".mcsharp" + Path.DirectorySeparatorChar;
  string fileName = dir + ".rmport";
  string wnFileName = dir + ".wnport";
  string accesstypeFileName = dir + ".accesstype";
  
  int rmport = 0;
  try {
   TCP.CreateServerSocket( 10000, 30000, out rmport ).Close();
  }
  catch ( Exception e ) {
   MCException.WriteException( "RMIN0001", "Can't bind any free port on this system! Try to increase TCP.MAXNUMBEROFTRIES!", e );
   Environment.Exit( 1 );
  }
  int wnport = 0;
  try {
   TCP.CreateServerSocket( 10000, 30000, out wnport ).Close();
  }
  catch ( Exception e ) {
   MCException.WriteException( "RMIN0002", "Can't bind any free port on this system! Try to increase TCP.MAXNUMBEROFTRIES!", e );
   Environment.Exit( 1 );
  }
  if ( !Directory.Exists( dir ) )
   Directory.CreateDirectory( dir );
  dir = dir + Path.DirectorySeparatorChar + "logs";
  if ( !Directory.Exists( dir ) )
   Directory.CreateDirectory( dir );
   
  FileStream fs = new FileStream( fileName, FileMode.OpenOrCreate, FileAccess.Write );
  byte[] buf = Encoding.ASCII.GetBytes( "" + rmport + "\n" );
  fs.Write( buf, 0, buf.Length );
  fs.Close();

  FileStream fs2 = new FileStream( wnFileName, FileMode.OpenOrCreate, FileAccess.Write );
  byte[] buf2 = Encoding.ASCII.GetBytes( "" + wnport + "\n" );
  fs2.Write( buf2, 0, buf2.Length );
  fs2.Close();
  
  FileStream fs3 = new FileStream( accesstypeFileName, FileMode.OpenOrCreate, FileAccess.Write );
  byte[] buf3 = Encoding.ASCII.GetBytes ( "ssh\n" );
  fs3.Write ( buf3, 0, buf3.Length );
  fs3.Close();
  
 }
}
